#include "advancewirelessmodule.h"

AdvanceWirellessModule::AdvanceWirellessModule(ManageSerialPort *_serialPort, QWidget *parent):
    QWidget(parent)
{

    serialCom = _serialPort;
    fillWindow();
}

void AdvanceWirellessModule::fillWindow()
{
    setMinimumWidth(200);
    setMinimumHeight(200);
    // building frame section
    sensor_sn= new QLabel(QString::number(sensor.serialNb,16).rightJustified(4,'0').toUpper());
        QLabel *serialNbLineLabel = new QLabel(this);
        serialNbLineLabel->setText("Serial Number :");
        QHBoxLayout *serialNbLayout = new QHBoxLayout;
        serialNbLayout->addWidget(serialNbLineLabel);
        serialNbLayout->addWidget(sensor_sn);
        serialNbLayout->setAlignment(Qt::AlignLeft);

    QGroupBox *readGroup = new QGroupBox("Read Data");
        // building frame section
        addressLine= new QLineEdit(this);
            addressLine->setText("0000");   // default = external memory
            QLabel *addressLineLabel = new QLabel(this);
            addressLineLabel->setText("Address :");
            QVBoxLayout *addressLayout = new QVBoxLayout;
            addressLayout->addWidget(addressLineLabel);
            addressLayout->addWidget(addressLine);
        select_memory=new QComboBox(this);
            select_memory->addItem("EEPROM");
            select_memory->addItem("RAM");
            QLabel *select_memoryLabel = new QLabel(this);
            select_memoryLabel->setText("Type of memory :");
            QVBoxLayout *select_memoryLayout = new QVBoxLayout;
            select_memoryLayout->addWidget(select_memoryLabel);
            select_memoryLayout->addWidget(select_memory);


        sendReadOrderButton = new QPushButton("Read Data");
        connect(sendReadOrderButton, SIGNAL(clicked()), SLOT(ReadClicked()));

        QHBoxLayout *layoutFabricTrame = new QHBoxLayout;
           // layoutFabricTrame->addLayout(serialNbLayout);
            layoutFabricTrame->addLayout(addressLayout);
            layoutFabricTrame->addLayout(select_memoryLayout);
            //layoutFabricTrame->addWidget(sendReadOrderButton);


        QHBoxLayout *layoutReceivedRead = new QHBoxLayout;
            dataReadDisplay=new QLineEdit();
            dataReadDisplay->setReadOnly(true);
        QLabel *dataReadLineLabel = new QLabel(this);
            dataReadLineLabel->setText("Data :");
            layoutReceivedRead->addWidget(dataReadLineLabel);
            layoutReceivedRead->addWidget(dataReadDisplay);

        QHBoxLayout *layoutFile = new QHBoxLayout;
            record_file = new QPushButton("Save data to file");
            layoutFile->addWidget(record_file);
            connect(record_file,SIGNAL(clicked()),this,SLOT(SaveFileClicked()));

        QVBoxLayout *layoutReadData = new QVBoxLayout;
            layoutReadData->addLayout(layoutFabricTrame);
            layoutReadData->addLayout(layoutReceivedRead);
            layoutReadData->addWidget(sendReadOrderButton);
            layoutReadData->addLayout(layoutFile);

            readGroup->setLayout(layoutReadData);
    //end readGroup

    //section write
    QGroupBox *writeGroup = new QGroupBox("Write Data in EEPROM");
        QVBoxLayout *writeDataLayout = new QVBoxLayout;
            addressLineWrite= new QLineEdit(this);
                addressLineWrite->setText("0000");   // default
                QLabel *addressLineWriteLabel = new QLabel(this);
                addressLineWriteLabel->setText("Address :");
                QVBoxLayout *addressWriteLayout = new QVBoxLayout;
                addressWriteLayout->addWidget(addressLineWriteLabel);
                addressWriteLayout->addWidget(addressLineWrite);

            reset_chip=new QCheckBox(this);
                QLabel *reset_chipLabel = new QLabel(this);
                reset_chipLabel->setText("Reset Chip :");
                QVBoxLayout *reset_chipLayout = new QVBoxLayout;
                reset_chipLayout->addWidget(reset_chipLabel);
                reset_chipLayout->addWidget(reset_chip);

            valueToWrite = new QLineEdit(this);
                valueToWrite->setText("00");
                QLabel *valueToWriteLabel = new QLabel(this);
                valueToWriteLabel->setText("Value to write :");
                QVBoxLayout *valueToWriteLayout = new QVBoxLayout;
                valueToWriteLayout->addWidget(valueToWriteLabel);
                valueToWriteLayout->addWidget(valueToWrite);

            writeButton = new QPushButton("Write Data");
            connect(writeButton, SIGNAL(clicked()), SLOT(WriteClicked()));     //TODO

            QHBoxLayout *writeFrameLayout = new QHBoxLayout;
                writeFrameLayout->addLayout(addressWriteLayout);
                writeFrameLayout->addLayout(reset_chipLayout);
                writeFrameLayout->addLayout(valueToWriteLayout);
               // writeFrameLayout->addWidget(writeButton);
        writeDataLayout->addLayout(writeFrameLayout);
        writeDataLayout->addWidget(writeButton);
        writeGroup->setLayout(writeDataLayout);
    //end writeGroup

    QGroupBox *writfirmwareGroup = new QGroupBox("Update Sensor Firmware");
        QVBoxLayout *writfirmVLayout0 = new QVBoxLayout;
        QHBoxLayout *writfirmHLayout0 = new QHBoxLayout;
        writfirmsensor = new QPushButton("Upload file to sensor");
        connect(writfirmsensor,SIGNAL(clicked()),this,SLOT(ProgramClicked()));
        QHBoxLayout *writfirmHLayout1 = new QHBoxLayout;
        write_firm_sensor_status = new QLabel(this);
        write_firm_sensor_status->setText(" ");
        writfirmHLayout0->addWidget(writfirmsensor);
        writfirmHLayout1->addWidget(write_firm_sensor_status);
        writfirmVLayout0->addLayout(writfirmHLayout0);
        writfirmVLayout0->addLayout(writfirmHLayout1);
        writfirmwareGroup->setLayout(writfirmVLayout0);

    QVBoxLayout* layoutTotal = new QVBoxLayout;
    layoutTotal->addLayout(serialNbLayout);
    layoutTotal->addWidget(readGroup);
    layoutTotal->addWidget(writeGroup);
    layoutTotal->addWidget(writfirmwareGroup);
    layoutTotal->setAlignment(Qt::AlignTop);
    setLayout(layoutTotal);
    setWindowModality(Qt::ApplicationModal);
}

AdvanceWirellessModule::~AdvanceWirellessModule(){

}
