#ifndef COMMON_H
#define COMMON_H

//*******************
// Common includes
//*******************

//QT lib
#include <QDebug>
#include <QtGui>
//#include <QtWidgets>


//#include <QByteArray>
//#include <qlistbox.h>

//C++ STL
#include <string>
#include <vector>
#include <algorithm>    // to sort vectors
#include <ctime>
#include <cstdlib>
    #include <stdint.h>
using namespace std;
#ifdef _TTY_POSIX_

#endif
extern QDateTime current_time; //global current_time
//*******************
//  Typedef
//*******************
typedef unsigned int uint;
typedef unsigned char uchar;
typedef short int16;
typedef unsigned short uint16;
typedef unsigned long int uint32;




//*************************
// Casting Routines
//*************************

string uchar2hexString(uchar * ucharToConvert, int _length);    //not used, debug only
void placeUint32InUcharTab(uint32 inputUint32, uchar *ucharTab, int position);
void placeUint64InUcharTab(uint64_t inputUint64, uchar *ucharTab, int position);
void placeUint16InUcharTab(uint16 inputUint16, uchar *ucharTab, int position);

uint64_t peekUint48FromUcharTabBigEndian(uchar * _inputCharTab, int position);

uint32 peekUint32FromUcharTabBigEndian(uchar * _inputCharTab, int position);

uint32 peekInt32FromUcharTabBigEndian(uchar * _inputCharTab, int position);

uint32 peekUint32FromUcharTabLittleEndian(uchar * _inputCharTab, int position);

uint16 peekUint16FromUcharTabBigEndian(uchar * _inputCharTab, int position);
uint16 peekUint16FromUcharTabLittleEndian(uchar * _inputCharTab, int position);

int8_t peekInt8FromUcharTab(uchar * _inputCharTab, int position);

int16_t peekInt16FromUcharTabBigEndian(uchar * _inputCharTab, int position);

int16 peekInt16FromUcharTabLittleEndian(uchar * _inputCharTab, int position);

uchar bcdFromDecimal(uchar _value);
vector<uchar> peek12ucharFromVector(vector<uchar> _inputVector, uint32 position);
uint16 peekUint16FromVectorBigEndian(vector<uchar> _inputVector, int position);
uint32 peekUint32FromVectorBigEndian(vector<uchar> _inputVector, int position);
void refresh_events();
//**********************
//  Pause et Debug
//**********************

#define lo(x)  		(*((uint8_t*)&x))
#define hi(x)  		(*((uint8_t*)&x+1))
#define hh(x)  		(*((uint8_t*)&x+2))
#define hhh(x)  	(*((uint8_t*)&x+3))
#define h4(x)  	(*((uint8_t*)&x+3))
#define h5(x)  	(*((uint8_t*)&x+3))
#define h6(x)  	(*((uint8_t*)&x+3))
#define h7(x)  	(*((uint8_t*)&x+3))


#define hi16(x)  		(*((uint16_t*)&x+2))
#define lo16(x)  		(*((uint16_t*)&x))

void waitFor(int msec=5);   //5msec as default value
void waitForUs(int usecs=500);
void displayUcharTab(uchar *_UcharTab, int _length);
void displayCharTab(char *_CharTab, int _length);
void debugDisplayVector(vector<uchar> vectorToPrint);
void debugDisplayQByteArray(QByteArray _byteArray);

//********************
//  Wireless Sensors
//********************

struct Sensor
{
    uint16 serialNb;
    uchar channelType;
    uchar channelType2;
    QString sensorName;
    float coefficient;
    int displayPrecision;
    QString unitString;
};


//********************
//  Modules
//********************

enum moduleType {  powerModule=0, temperatureModule=1, pressureModule=2, wirelessModule=3,powerModule2=4, wirelessModule2=5, pulsesModule=6};
enum connectionType { infrared=0, radio802=1, bluetooth=2,wired=3,radio868=4,json=5,wirelesslog=6};

struct Module
{
    uint32 serialNb;
    moduleType typeOfModule;
    uchar divCoeff[6];
    uchar mulCoeff[6];
    QString channelName[6];
    uchar nbOfLines;    //For wireless sensors, = nb Of Sensors / 6 (due to old Palm version)
    uchar memoryAvailable;
    vector< Sensor> sensorList;
    uchar version;
};

struct Module_serv
{
    uint32 serialNb;
    uint8_t typeOfModule;
    uchar divCoeff[6];
    uchar mulCoeff[6];
    QString channelName[6];
    uchar nbOfLines;    //For wireless sensors, = nb Of Sensors / 6 (due to old Palm version)
    uchar memoryAvailable;
};

struct compareModules   // used to sort Modules by SN
{
    bool operator ()(Module const& a, Module const& b) const {
        return (a.serialNb < b.serialNb);
    }
};




#endif // COMMON_H
