#ifndef DATAACQUISITION_H
#define DATAACQUISITION_H

#include "manageserialport.h"
#include "refreshtimer.h"
class DataAcquisition : public QWidget
{
    Q_OBJECT
public:
    explicit DataAcquisition(ManageSerialPort *_serialPort, RefreshTimer *_commonRefreshTimer, vector<Module> _moduleList, QWidget *parent = 0);
    ~DataAcquisition();

signals:
    void backToMainWindow();

public slots:

    void startTimerAgain();



private slots:
    void timerSlot();
    void clearMemory();
    void downloadDataClicked();
    void setCentralTime();
    void backToManageModule();
    void setPeriod(int indexChanged);
    void centralNameChanged();

private:
    ManageSerialPort *serialCom;
    RefreshTimer *commonRefreshTimer;
    vector<Module> moduleList;
    uint32 offsetPerLine[256];
    bool updateMemoryInfo();
    uint32 memoryPointer;
    uchar memoryOverflow;
    uint32 endOfMemory;
    uint32 endOfData;
    uchar typeofcentral; //0 -> old , 1-> new
//download data
    bool downloadCampaign();
    bool getWirelessSensorList(int _wirelessModuleIndex);
    vector< vector< uchar > > tableOfDownloadedValues;
    uint32 memoryPointerBeforeDownload;
    uint32 memoryPointerAfterDownload;
    bool writedata(uint32_t serialNb,uint32_t address,uint8_t datatowrite);
// write data to file
    bool generateFile();
    bool writeSample(uint32 lineNb);
    QFile *tsvFile;
    QTextStream tsvFileStream;

//graphics elements :
    void fillWindow();
    QVBoxLayout *globalLayout;
    QGroupBox *groupBoxData;
    QVBoxLayout *verticalLayout;
        QGridLayout *gridLayout;
            QLineEdit *centralNameEdit;
            QLabel *serialNumber;
            QComboBox *periodValue;
            QLabel *centralDate;
            QPushButton *setTimeButton;
            QLabel *nbOfData;
            QLabel *freeMemorySpace;
        QHBoxLayout *buttonLayout;
            QPushButton *returnButton;
            QPushButton *clearMemoryButton;
            QPushButton *downloadButton;

//debug
    void debugDisplayTable();
};

#endif // DATAACQUISITION_H
