#ifndef ETHERNETCONFIG_H
#define ETHERNETCONFIG_H

//#include <QWidget>
#include "manageserialport.h"

class EthernetConfig : public QWidget
{
    Q_OBJECT
public:
    explicit EthernetConfig(ManageSerialPort *_serialPort,QWidget *parent = 0);

signals:
    void closingWindow();

public slots:
    void closeEvent(QCloseEvent *event);
    void networkConfig();
    void networkUpdate();
    void ftpSendNow();
    void ftpServerConfig();
    void ftpServerUpdate();
    void timeConfig();
    void timeConfigUpdate();
    void timeConfigSave();
    void timeConfigQuit();
    void mvConfig();
    void mvConfigUpdate();
    void mvConfigAdd();
    void mvConfigConfig();
    void mvConfigDel();
    void mvConfigQuit();
    void networkConfigSave();
    void networkConfigQuit();
    void ftpConfigSave();
    void ftpConfigQuit();
    void mvResetData();
    void mvSearch();
    void mvSearchMore();
    void mvModuleQuit();
    void mvModuleUpdate();
    void mvUploadChanged(int state);

private:
    QSettings *settingFile;
    ManageSerialPort *serialCom;
    QByteArray DataRead;
    int DHCPmem;
    int nbSys;      // Nbre systems MV enregistrs
    int radioSelIndex;
    uint16 listSys[10];
    QString listSysNom[10];
    QStringList listSysView;
    QStringList listModView;

    QString ipToString(QByteArray IPBytes,uint32 offset);
    QString macToString(QByteArray MACBytes);
    QByteArray stringToIp(QString IPString);
    QByteArray stringToQBA(QString TextString,uint16 nchar);
    void closeQuit();

    QWidget *rightWidget;

    void fillWindow();
    QHBoxLayout *horizontalConfigLayout;
    QVBoxLayout *normalConfigLayout;
    QPushButton *networkConfigButton;
    QPushButton *ftpSendNowButton;
    QPushButton *ftpServerConfigButton;
    QPushButton *timeConfigButton;
    QPushButton *mvConfigButton;
    QGridLayout *rightlayout;
    QVBoxLayout *rightVLayout;

    QLineEdit *currentIPValue;
    QLineEdit *maskValue;
    QLineEdit *gatewayValue;
    QLineEdit *dnsValue;
    QLineEdit *defaultIPValue;
    QLineEdit *defaultMaskValue;
    QLineEdit *macAddrValue;
    QPushButton *networkConfigSaveButton;
    QPushButton *networkConfigQuitButton;

    QLineEdit *ftpServerNameValue;
    QLineEdit *ftpUserNameValue;
    QLineEdit *ftpPasswordValue;
    QLineEdit *ftpDirectoryValue;
    QLineEdit *ftpLastResultValue;
    QLineEdit *ftpLastErrorValue;
    QCheckBox *checkDHCP;
    QPushButton *ftpConfigSaveButton;
    QPushButton *ftpConfigQuitButton;

    QLineEdit *timeServerIPValue;
    QLineEdit *callTimeValue;
    QLineEdit *timeZoneValue;
    QLineEdit *timeNowValue;
    QPushButton *timeConfigSaveButton;
    QPushButton *timeConfigQuitButton;

    QLineEdit *systemAddEdit;
    QListView *systemsListBox;
    QPushButton *mvAddButton;
    QPushButton *mvDelButton;
    QPushButton *mvQuitButton;

    QLineEdit *wModuleEdit;
    QLineEdit *centralEdit;
    QLineEdit *centralNameEdit;
    QCheckBox *enableUpload;
    QLineEdit *dataToLoadEdit;
    QPushButton *resetDataButton;
    QPushButton *searchModuleButton;
    QPushButton *searchMoreButton;
    QPushButton *moduleQuitButton;
    QListView *modulesListView;
};

#endif // ETHERNETCONFIG_H
