#include "http_server.h"
#ifdef _RPI_
#include "PCD8544.h"
#include <wiringPi.h>
#include "c_function.h"
#endif
// HttpDaemon is the the class that implements the simple HTTP server.


    HttpDaemon::HttpDaemon(quint16 port,ManageSerialPort *_serialPort,bool ftp_req,bool invalid_setting, QObject* parent)
        : QTcpServer(parent), disabled(false)
    {

    sec10=0;
    interfaces=0;
    settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    timeout_ftp=0;


#ifdef _RPI_
    current_ip_id=0;
        timerscroll=new QTimer;
    // pin setup
    int _channel = 0;
    int _speed = 1000000;
    int _dc = 6;
    int _rst = 5;
    int _cs = 4;
    inter_lcd=200;
    nb_pix_scroll=1;
    // lcd contrast
    int contrast = 40;
    if(settingFile->contains("LCD/CONTRAST"))
        contrast=settingFile->value("LCD/CONTRAST").toString().toInt();
    if(settingFile->contains("LCD/SPI_SPEED"))
        _speed=settingFile->value("LCD/SPI_SPEED").toString().toInt();
    if(settingFile->contains("LCD/TIMER_INTER"))
        inter_lcd=settingFile->value("LCD/TIMER_INTER").toString().toInt();
    if(settingFile->contains("LCD/NB_PIXEL"))
        nb_pix_scroll=settingFile->value("LCD/NB_PIXEL").toString().toInt();
     wiring_init_ok=false;
  // check wiringPi setup
  if (wiringPiSetup() == -1)
  {

        qDebug("wiringPi-Error");
  }
else
  {
       wiring_init_ok=true;
  LCDInit(_cs,_dc, _rst, contrast,_channel,_speed);
  LCDclear();
  LCDsetBacklight(0);
  //LCDshowLogo();
  refresh_inter();

  connect(timerscroll,SIGNAL(timeout()),this,SLOT(timer_lcd()));
 // timerscroll->start(inter_lcd);

  // show logo
 //LCDshowLogo();
  }
#endif
    delete settingFile;

  close_request=false;
  time_config=false;
        daily_req_ok=true;
        date_tmp=QDate::currentDate();
        busy_http=false;
        ftp = new myFtp();
        connect(ftp,SIGNAL(command_done(bool)),this,SLOT(process_ftp(bool)));
        httpconfig = new QWidget;
        ftp_statut=0;
        nb_host=0;
        count_sec=0xFFFF;
        config_ongo=false;
        uint16_t temp_per[19]= {1,2,5,10,15,20,30,60,600,3600,120,300,900, 600,600,600, 120,300,900};
        for(int i=0;i<19;i++)
        {
            periodes[i]=temp_per[i];
        }
        always_header=true;
        Timer1=new QTimer;

        endOfFindingModules=true;
        autodetectRetry=0;  //init value, will change next
        centralDetected=false;
        nb_sys=1;
        serialCom=_serialPort;

        HTTP_VAR_ESC_STRING="%";
        HTTP_PERCENT="%%";
        httpFiles<<"TXT"
                 <<"HTM"
                <<"HTML"
                <<"CGI"
                <<"XML"
                <<"GIF"
                <<"PNG"
                <<"JPG"
                <<"CLA"
                <<"WAV"
                <<"";


           // Content entry order must match with those "HTTP File Types" define's.
           httpContents<<"text/plain"             // HTTP_TXT
                <<"text/html"              // HTTP_HTML
                <<"text/html"              // HTTP_CGI
                <<"text/html"              // HTTP_CGI
                <<"text/xml"              // HTTP_XML
                <<"image/gif"              // HTTP_GIF
                <<"image/png"              // HTTP_PNG
                <<"image/jpeg"             // HTTP_JPG
                <<"application/java-vm"    // HTTP_JAVA
                <<"audio/x-wave"         // HTTP_WAV
                <<"" 			 // HTTP_UNKNOWN
           ;
        HTTPMessages<< "HTTP/1.1 404 Not found\r\n\r\nNotfound.\r\n"
                    <<"HTTP/1.1 503 \r\n\r\nService Unavailable\r\n"
                    <<"HTTP/1.1 503 \r\n\r\nOngoing FTP Transfert - Please Wait\r\n";

        // Standard HTTP messages.
        HTTP_OK_STRING = "HTTP/1.1 200 OK\r\nContent-type: ";
        HTTP_OK_NO_CACHE_STRING = "HTTP/1.1 200 OK\r\nDate: Wed, 05 Apr 2006 02:53:05 GMT\r\nExpires: Wed, 05 Apr 2006 02:52:05 GMT\r\nCache-control: private\r\nContent-type: ";

       HTTP_HEADER_END_STRING = "\r\n\r\n";


        // HTTP Command Strings
        HTTP_GET_STRING = "GET";

        // Default HTML file.
        HTTP_DEFAULT_FILE_STRING = "INDEX.HTM";
        fillWindow();
        if(invalid_setting) change_label("Invalid setting.ini");
        tryToOpenPort();
        settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);

        bool ok=true;
        serialCom->address_API=9999;
        if(settingFile->contains("HTTP_SERV/LIST_SYS"))
        {

            QStringList list_sensor=settingFile->value("HTTP_SERV/LIST_SYS").toString().split(";", QString::SkipEmptyParts);
            nb_sys=list_sensor.count();
            for(int i=0;i<list_sensor.count();i++)
            {
                m_radio_ex[i]=false;
                qDebug()<<"sys"<<list_sensor.at(i).toUInt(&ok,16);
                sys_radio[i]=(list_sensor.at(i)).toUInt(&ok,16);
                update_addAPI(sys_radio[i]);
                nb_mod[i]=0;
                nb_mod2[i]=0;
                if(settingFile->contains("HTTP_SERV/"+list_sensor.at(i)+"/MOD_LIST"))
                {
                    QStringList list_mod=settingFile->value("HTTP_SERV/"+list_sensor.at(i)+"/MOD_LIST").toString().split(";", QString::SkipEmptyParts);
                    qDebug()<<list_mod<<list_mod.count();
                    for(int j=0;j<list_mod.count();j++)
                    {
                        addFoundModuleOnList(list_mod.at(j).toULong(&ok,16),i);
                    }
                }
                if(settingFile->contains("HTTP_SERV/"+list_sensor.at(i)+"/IS_ACTIV"))
                {
                    if(settingFile->value("HTTP_SERV/"+list_sensor.at(i)+"/IS_ACTIV").toString().toUShort()==0)
                        is_actif[i]=false;
                    else is_actif[i]=true;
                }
                else is_actif[i]=true;
                if(settingFile->contains("HTTP_SERV/"+list_sensor.at(i)+"/LAST_ADDRESS"))
                    last_address[i]=settingFile->value("HTTP_SERV/"+list_sensor.at(i)+"/LAST_ADDRESS").toString().toULong();
                else last_address[i]=0;


            }

        }
        else
        {
            nb_sys=0;
            if(serialCom->getTypeofconnection()!=radio802)
            {
                nb_sys=1;
                m_radio_ex[0]=false;
                sys_radio[0]=0;
                nb_mod[0]=0;
                nb_mod2[0]=0;
                is_actif[0]=true;
                last_address[0]=0;
            }
        }
        if(settingFile->contains("HTTP_SERV/HH_APPEL"))
            hh_appel=settingFile->value("HTTP_SERV/HH_APPEL").toString().toUShort();
        else hh_appel=04;
        if(settingFile->contains("HTTP_SERV/MM_APPEL"))
            mm_appel=settingFile->value("HTTP_SERV/MM_APPEL").toString().toUShort();
        else mm_appel=00;
        if(settingFile->contains("HTTP_SERV/FTP_SERV"))
            FTP_ServerName=settingFile->value("HTTP_SERV/FTP_SERV").toString();
        else FTP_ServerName="";
        if(settingFile->contains("HTTP_SERV/FTP_USER"))
            FTP_UserName=settingFile->value("HTTP_SERV/FTP_USER").toString();
        else FTP_UserName="";
        if(settingFile->contains("HTTP_SERV/FTP_PASS"))
            FTP_Password=settingFile->value("HTTP_SERV/FTP_PASS").toString();
        else FTP_Password="";
        if(settingFile->contains("HTTP_SERV/FTP_REP"))
            FTP_Rep=settingFile->value("HTTP_SERV/FTP_REP").toString();
        else FTP_Rep="0001";
        if(settingFile->contains("HTTP_SERV/HTTP_REP"))
            HTTP_rep=settingFile->value("HTTP_SERV/HTTP_REP").toString();
        else HTTP_rep="/boot/multivoies/http_files/";
        if(settingFile->contains("HTTP_SERV/PDC_REP"))
            PDC_rep=settingFile->value("HTTP_SERV/PDC_REP").toString();
        else PDC_rep="/boot/multivoies/pdc_files/";
        if(settingFile->contains("HTTP_SERV/HEADER"))
        {
            if(!settingFile->value("HTTP_SERV/HEADER").toString().toUShort())
            always_header=false;
        }
        else always_header=true;
        delete settingFile;
        settingFile=NULL;
        update_config();
      //  module_detection();
        handle_nr=0;
        if(ftp_req)
        {
            daily_req_ok=true;
            ftp_statut=1;
            count_sec=0;
        }
        listen(QHostAddress::Any, port);
        change_statut("Web Server ON");

       //
        #ifdef _RPI_
  timerscroll->start(inter_lcd);
#endif
  connect(Timer1,SIGNAL(timeout()),this,SLOT(each_sec()));
  Timer1->start(1000);

    }


    void HttpDaemon::tryToOpenPort()
    {
        if(!serialCom->isOpen())
        {
        //Try to open serial port, launch connection window if cannot open
        settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
        if(settingFile->contains("COM/COM_PORT")&&settingFile->contains("COM/COM_TYPE"))
        {
            qDebug()<<"File and data found";
           // if(serialCom==NULL) serialCom = new ManageSerialPort();
            qDebug()<<"type of connection : "<<settingFile->value("COM/COM_TYPE").toInt();
            QString portName=settingFile->value("COM/COM_PORT").toString();

            serialCom->open(portName,settingFile->value("COM/COM_TYPE").toInt());

            if(!serialCom->isOpen()){
                qDebug()<<"port not open";
                change_label("Can't open COM port");
                //openConnectionWindow();
            }
            else //port opened properly
            {

                //returnFromConnectionDialog();   //=after connection procedure
               // serialCom->centralDetection();
                change_label("COM port successfully opened");

            }
        }
        else
        {
          qDebug()<<"No value on the configuration file";
         // openConnectionWindow();
        }
        delete settingFile;
        settingFile=NULL;
    }
    }


    void HttpDaemon::incomingConnection(int socket)
    {
        //qDebug()<<"socket nr"<<socket;
        if(handle_nr++>=MAX_HTTP_CONNECTIONS)
        {
            qDebug()<<"max connection reached";
            return;
        }
        HCB[handle_nr].socket=socket;
        HCB[handle_nr].smHTTP=SM_HTTP_IDLE;
     //   qDebug()<<"New Connection"<<socket<<handle_nr;
        if (disabled)
            return;

        // When a new client connects, the server constructs a QTcpSocket and all
        // communication with the client is done over this QTcpSocket. QTcpSocket
        // works asynchronously, this means that all the communication is done
        // in the two slots readClient() and discardClient().
        QTcpSocket* s = new QTcpSocket(this);
        connect(s, SIGNAL(readyRead()), this, SLOT(readClient()));
        connect(s, SIGNAL(disconnected()), this, SLOT(discardClient()));
        s->setSocketDescriptor(socket);
        s->setObjectName(QString::number(socket));

    }

    void HttpDaemon::pause()
    {
        disabled = true;
    }

    void HttpDaemon::resume()
    {
        disabled = false;
    }

    void HttpDaemon::readClient()
    {

        QTcpSocket* socket = (QTcpSocket*)sender();
        int current_handle=handle_nr;
        //qDebug()<<"local adress"<<socket->peerAddress();
        currentIP=socket->localAddress().toString();
        for(int i=0;i<=handle_nr;i++)
        {
            if(HCB[i].socket==socket->objectName().toInt())
            {
                current_handle=i;
            }
        }
        HTTP_INFO* ph;
        ph = &HCB[current_handle];

        bool host_exist=false;
        uint8_t current_host_index=0;
        QHostAddress current_add=socket->peerAddress();
        for(int i=0;i<nb_host;i++)
        {

            if(current_add==host_add[i])
            {
              host_exist=true;
              current_host_index=i;
              break;
            }

        }
        if(host_exist)
        {
            ph->current_sys=current_sysh[current_host_index];
            ph->ligne=current_lineh[current_host_index];
            ph->voie=current_voieh[current_host_index];
        }
        else
        {
            if(nb_host<MAX_HTTP_CONNECTIONS)
            {
              host_add[nb_host++]= current_add;
            }
            else
            {
                for(int i =1;i<MAX_HTTP_CONNECTIONS;i++)
                    host_add[i-1]=host_add[i];
                host_add[MAX_HTTP_CONNECTIONS]=current_add;
            }
        }
   //     qDebug()<<"socket descriptor"<<socket->socketDescriptor()<<HCB[current_handle].socket<<current_handle;



        if (disabled)
            return;

        // This slot is called when the client sent data to the server. The
        // server looks if it was a get request and sends a very simple HTML
        // document back.


      //  ph->socket = socket;
        if (socket->canReadLine()) {
            if(!ftp_statut&&!config_ongo)
            {

                if(HTTPParse(QString(socket->readLine()), ph)==HTTP_GET)
                {
                    if(!ftp_statut)
                    {
                        open_and_send_file(ph,socket);
                        current_sysh[current_host_index]=ph->current_sys;
                        current_lineh[current_host_index]=ph->ligne;
                        current_voieh[current_host_index]=ph->voie;
                    }
                    else //si commande send_now
                    {
                        QTextStream os(socket);
                        os.setAutoDetectUnicode(true);
                        os << "HTTP/1.0 200 Ok\r\n"
                              "Content-Type: text/html; charset=\"utf-8\"\r\n"
                              "\r\n"
                              "<head>"
                              "<meta http-equiv=\"refresh\" content=\"20; url=\">"
                              "</head>"
                              "<h1>ONGOING FTP TRANSFERT, PLEASE WAIT ...</h1>\n";
                        socket->close();
                    }
                    if (socket->state() == QTcpSocket::UnconnectedState) {
                        delete socket;
                    }
                }
            }
            else
            {
                QStringList tokens = QString(socket->readLine()).split(QRegExp("[ \r\n][ \r\n]*"));
                if (tokens[0] == "GET") {
                    QTextStream os(socket);
                    os.setAutoDetectUnicode(true);
                    if(ftp_statut)
                    {
                        os << "HTTP/1.0 200 Ok\r\n"
                              "Content-Type: text/html; charset=\"utf-8\"\r\n"
                              "\r\n"
                              "<head>"
                              "<meta http-equiv=\"refresh\" content=\"20; url=\">"
                              "</head>"
                              "<h1>ONGOING FTP TRANSFERT, PLEASE WAIT ...</h1>\n";
                    }
                    else
                    {
                        os << "HTTP/1.0 200 Ok\r\n"
                              "Content-Type: text/html; charset=\"utf-8\"\r\n"
                              "\r\n"
                              "<head>"
                              "<meta http-equiv=\"refresh\" content=\"20; url=\">"
                              "</head>"
                              "<h1>SERVER IN CONFIG MODE, PLEASE WAIT ...</h1>\n";
                    }
                    socket->close();

                    if (socket->state() == QTcpSocket::UnconnectedState) {
                        delete socket;
                    }
                }
            }
        }
    }

    uint8_t HttpDaemon::HTTPParse(QString httpData, HTTP_INFO* ph )
    {
        QStringList tokens = httpData.split(QRegExp("[ \r\n][ \r\n]*"));
        HTTP_COMMAND cmd;

        // Only "GET" is supported for time being.
        if(tokens.size()<1)
        {
            return HTTP_NOT_SUPPORTED;
        }
        if (tokens[0]==HTTP_GET_STRING)
        {
            cmd = HTTP_GET;
        }
        else
        {
            return HTTP_NOT_SUPPORTED;
        }

        // Skip white spaces.
        qDebug()<<tokens[1];
        QStringList file_cmd =tokens[1].split("?");
        QString filename=QString(file_cmd[0]).remove(QChar('/'));
        QStringList filename_tmp=filename.split(".");
        if(filename_tmp.size()<2)
        {
            ph->Filename="index.htm";
            ph->fileType=HTTP_HTM;
        }
        else
        {
            QString file_ext=filename_tmp.at(filename_tmp.size()-1);
            ph->Filename=filename;
            ph->fileType=HTTP_UNKNOWN;
            for(int i =0; i<FILE_TYPES_SIZE;i++)
            {
                if(file_ext.toUpper()==httpFiles.at(i))
                {

                    ph->fileType=i;
                    break;
                }
            }
        }

        if(file_cmd.size()>1) //si commande (aprs ?)
        {
            QString cmd_var=file_cmd[1];
            //qDebug()<<"cmd"<<cmd_var;
            QStringList list_var_tmp,list_var;
            list_var.clear();
            ph->command=cmd_var.at(0).toAscii();
            list_var_tmp =cmd_var.split("&");
            for(int i=0;i<list_var_tmp.size();i++)
            {
                QString current_var=list_var_tmp.at(i);
                int index_var=current_var.indexOf("=");
                current_var.replace(0,index_var+1,"");
                list_var.append(current_var);
            }
             ph->variable=list_var;
             //qDebug()<<list_var;
           /*
            QString var_tmp="";
            uint8_t var_size=0;
            bool ok=true;
            if((cmd_var.size()>2)&&(cmd_var.size()<7))
            {
                var_size=cmd_var.size()-2;
                for(int i=0;i<var_size;i++)
                {
                    var_tmp.append(cmd_var.at(i+2));
                }
                ph->variable=var_tmp.toUInt(&ok,16);
            }
            else ph->variable=0;
            qDebug()<<"commande"<<ph->command<<QString::number(ph->variable,16).rightJustified(4,'0').toUpper();*/
            HTTPExecCmd(ph);

        }
        return cmd;
    }

    void HttpDaemon::HTTPExecCmd(HTTP_INFO* ph)
    {
        while(busy_http);
        busy_http=true;
        uint16_t var=0;
        uint8_t cmd =ph->command-'A';
        //qDebug()<<"commande :"<<cmd;
        switch(cmd)
        {
        case 0:	// ACTION=A : Affichage d'un systme x
            var=decode_var(ph->variable.at(0));
           // qDebug()<<var;
                    if ((var>0) && (var<=nb_sys))
                    {
                            ph->current_sys = var-1;
                            update_addAPI(sys_radio[ph->current_sys]);
                               // qDebug()<<sys_radio[ph->current_sys]<<serialCom->address_API;
                            //litcoefs();
                    }
                    //else ph->current_sys=-1;
             break;

        case 1:	// ACTION=B : Toggle activation radio X
           var=decode_var(ph->variable.at(0));
                    if ((var>0) && (var<=nb_sys))	{
                            if(is_actif[var-1])
                                is_actif[var-1]=false;
                            else
                                is_actif[var-1]=true;
                            //SaveAppConfig2();
                            update_config();
                    }
                    break;

        case 2:	// ACTION=C : Supprime ligne
            var=decode_var(ph->variable.at(0));
                    if ((var>0) && (var<=nb_sys))
                            lignetodelete=var-1;		// Test
                    else
                            lignetodelete=nb_sys;
                    break;

        case 3:	// ACTION=D : Confirme suppression
                    if(nb_sys) {
                            for (int i=lignetodelete;i<nb_sys;i++)
                            {
                                sys_radio[i]=sys_radio[i+1];
                                is_actif[i]=is_actif[i+1];
                                nb_mod[i]=nb_mod[i+1];
                                nb_mod2[i]=nb_mod2[i+1];
                                for (int j=0;j<nb_mod2[i];j++)
                                     moduleList[i][j]=moduleList[i+1][j];
                            }
                            nb_sys--;
                            update_config();
                            }
                    break;

        case 4:	// ACTION=E : Ajoute SNConcentrateur
            var=decode_var(ph->variable.at(0));
            sys_radio[nb_sys]=var;
            is_actif[nb_sys]=true;
            last_address[nb_sys]=0;
            m_radio_ex[nb_sys]=0;
            nb_mod[nb_sys]=0;
            nb_mod2[nb_sys++]=0;
            update_config();
                    break;

        case 16:	// ACTION=Q : Save NBLignes radio
            var=decode_var(ph->variable.at(0));
            update_addAPI(sys_radio[ph->current_sys]);
                    if (var<=8)
                    serialCom->writeByteAtWithRetry(sys_radio[ph->current_sys],0x0100008D,var,3);
                    ph->voie=1;
            //	RechercheModules();*/

        case 5:	// ACTION=F : Dmarre recherche
            current_sys=ph->current_sys;
            initModuleDetection(ph->current_sys);
            waitFor(50);

        case 6:	// ACTION=G : Recherche Module
            refreshTableValues(ph->current_sys);
            update_config();

                    break;

        case 7:	// ACTION=H : Changer nom concentrateur
                   /* ecrit_string(snr[RadioSel],0x01000000,0x01000020,argv[2],16);
                    memcpy(noms[RadioSel],(void*)argv[2],16);*/
            update_addAPI(sys_radio[ph->current_sys]);
                    serialCom->setModuleName(serialCom->getCentralSN(),0x01000020,ph->variable.at(0));
            break;

        case 8:	// ACTION=I : Changer priode
            var=decode_var(ph->variable.at(0));
            serialCom->writeByteAtWithRetry(serialCom->getCentralSN(),0x01000013,var,3);
            periode[ph->current_sys] = periodes[var];
                    break;

        case 9:	// ACTION=J : changer date/heure
                   // set_multivoies_time();
                    break;

        case 10:	// ACTION=K : Clear Data du concentrateur
                clearMemory(ph->current_sys);
            break;

        case 11:	// ACTION=L : Envoi FTP Now
                   // envoiFTP_start();
            if(!ftp_statut)
            {
                count_sec=0;
                ftp_statut=1;
                daily_req_ok=true;
            }
                    break;

        case 12:	// ACTION=M : changer heure appel
                                    // Arvv2=0 -> chaque heure / 1: 2 fois par jour / 2: chaque jour

                if (!decode_var(ph->variable.at(0)))
                {
                            hh_appel = 24;
                            mm_appel = QString::number(decode_var(ph->variable.at(2)),16).toUInt();;
                }
                else if (decode_var(ph->variable.at(0))==1)
                {
                            hh_appel = QString::number(decode_var(ph->variable.at(1)),16).toUInt();
                            mm_appel = QString::number(decode_var(ph->variable.at(2)),16).toUInt();
                }
                else	{
                            hh_appel = 25 +  QString::number(decode_var(ph->variable.at(1)),16).toUInt();
                            mm_appel = QString::number(decode_var(ph->variable.at(2)),16).toUInt();
                            }
                update_config();
            break;

        case 13:	// ACTION=N : save config radio (SN)
            var=decode_var(ph->variable.at(0));
            update_addAPI(sys_radio[ph->current_sys]);

            serialCom->writeByteAtWithRetry(sys_radio[ph->current_sys],0x010000A0+2*(ph->voie-1),var>>8,3);
            serialCom->writeByteAtWithRetry(sys_radio[ph->current_sys],0x010000A1+2*(ph->voie-1),var,3);
            update_module(ph);
            break;

        case 14:	// ACTION=O : changer serveur FTP
            FTP_ServerName=ph->variable.at(0);
            FTP_UserName=ph->variable.at(1);
            if(ph->variable.at(2).at(0)!='*')
                FTP_Password=ph->variable.at(2);
            FTP_Rep=ph->variable.at(3);
            update_config();
            break;

        case 15:	// ACTION=P : change Phase & invert
            var=decode_var(ph->variable.at(0));
                    if (ph->voie < 7)
                    {
                        update_addAPI(sys_radio[ph->current_sys]);
                        serialCom->writeByteAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x110+ph->voie-1,var,3);
                        qDebug()<<"change phase/invert voie "<<ph->voie<<"value"<<var;
                        update_module(ph);
                    }

                    break;

        case 17:	// ACTION=R : save config radio ( Type)
            var=decode_var(ph->variable.at(0));
            update_addAPI(sys_radio[ph->current_sys]);

            serialCom->writeByteAtWithRetry(sys_radio[ph->current_sys],0x01000040+(ph->voie-1),var,3);
            update_module(ph);
                    break;

        case 18:	// ACTION=S : changer SNTP Serv
                  /*  copy_arg(SNTP_ServerIP, argv[2], 16);
                    SaveAppConfig2();*/
                    break;

        case 19:	// ACTION=T : RAZ Data dj envoyes
                    reset_pointer(ph->current_sys);
                    break;

        case 20:	// ACTION=U : Change TIMEZONE
                   /* zone = sarg(argv,2,0);
                    SaveAppConfig2();
                    // Remet  jour l'heure
                    SetTimeTick(GetTimeTick());*/
                    break;

        case 21:	// Action V : VAR_HEADER
            var=decode_var(ph->variable.at(0));
            if(!var) always_header=false;
            else always_header=true;
            update_config();
                    break;

        case 22:	// Action W : Choix module  afficher
            var=decode_var(ph->variable.at(0));
            if(var>=nb_mod2[ph->current_sys]) break;
            if (var<nb_mod[ph->current_sys])	{
                        ph->ligne=var;
                        ph->voie = 1;
                        update_module(ph);
                            }
            else{
                ph->ligne=var;
                ph->voie = ((var-nb_mod[ph->current_sys]+1)*6)+1;
                update_module(ph);
            }
            break;
        case 23:	// Action X :  Change channel
            var=decode_var(ph->variable.at(0));
            if (var==0x99){   // Previous
                if (ph->voie>1) ph->voie--;
            }
            else if (var==0x98)	{		// Next
                 if (moduleList[ph->current_sys][ph->ligne].typeOfModule==250)
                 {
                     if (ph->voie<47) ph->voie++;
                 }
                 else
                 {
                     if (ph->voie<6) ph->voie++;
                 }
            }
            else if(var<=6) ph->voie = var;
            else ph->voie=1;
            // Mets  jour l'affichage
            update_module(ph);

            break;
        }
        busy_http=false;
    }

    bool HttpDaemon::open_and_send_file(HTTP_INFO* ph,QTcpSocket* socket )
    {
        uint8_t open_mode=0;
        QFile local_file(HTTP_rep+ph->Filename);
        switch(ph->fileType)
        {
        case  HTTP_HTM:
        case  HTTP_HTML:
        case  HTTP_CGI:
            //qDebug()<<"filename"<<ph->Filename;
            if(!local_file.open((QIODevice::ReadOnly | QIODevice::Text)))
            {
                qDebug()<<"The file can't be opened"<<ph->Filename;
                socket->close();
                return false;
            }
            open_mode=0;
            break;

        case HTTP_GIF:
            if(!local_file.open((QIODevice::ReadOnly))){
                qDebug()<<"The file can't be opened"<<ph->Filename;
                socket->close();
                return false;
            }
            open_mode=1;
            break;
        default:
            socket->close();
            return false;

        }
        QTextStream os(socket);
        os.setAutoDetectUnicode(true);
        os<<"HTTP/1.0 200 Ok\r\n";
        os<<"Content-Type: "<<httpContents.at(ph->fileType); //header

        if(!open_mode)
        {

            QTextStream in(&local_file);
           os <<"; charset=\"utf-8\"\r\n"
               "\r\n";
            QString line = in.readLine();
            while (!line.isNull())
            {
                if(ph->fileType==HTTP_CGI)
                {

                    line.replace(HTTP_PERCENT, "PERCENT");
                    int var_count=line.count(HTTP_VAR_ESC_STRING);
                    for(int i=0;i<var_count;i++)
                    {
                        int index_var=line.indexOf(HTTP_VAR_ESC_STRING);
                        bool ok=true;
                        QString var_tmp;
                        var_tmp.append(line.at(index_var+1));
                        var_tmp.append(line.at(index_var+2));
                        uint8_t VarGet=var_tmp.toUShort(&ok,16);//((uint8_t)strtol(tmp, 0, 16));
                        HTTPGetVar(VarGet,ph);
                        line.replace(index_var,3,ph->VarString);

                    }
                    line.replace("PERCENT", "%");
                }
                os<<line;
                //qDebug()<<line;
                line = in.readLine();
            }
        }
        else
        {
            while (!local_file.atEnd()) {
                socket->write(local_file.readLine());

            }
        }
        local_file.close();
        waitFor(5);
        socket->close();
        return true;
    }

    void HttpDaemon::HTTPGetVar(uint8_t var,HTTP_INFO* ph)
    {
        while(busy_http);
        busy_http=true;
        QString VarString="";
        uint8_t i=0;
        switch(var)
        {
        case VAR_TYPE_CONNECTION:
            if(serialCom->getTypeofconnection()!=radio802)
            {
               VarString="0";
            }
            else  VarString="1";
            break;

        case VAR_MAC_ADDRESS:
            //updateIP();
            VarString=MAC_adress;
            break;
        case VAR_IP_ADDRESS:
            VarString=currentIP;
             break;
        case VAR_SUBNET_MASK:
            VarString=mask_addr;
             break;
        case VAR_GATEWAY_ADDRESS:
            VarString=broadcast_addr;
            break;
        case VAR_DHCP_TRUE:
        case VAR_DHCP_FALSE:
            break;

        case VAR_RAZ_LIGNE:
            ph->ligne=0;
            //qDebug()<<"raz";
            VarString = '\0';
            break;
        case VAR_SNRADIO:
            if(!nb_sys) break;
            if(serialCom->getTypeofconnection()!=radio802)
            {
               VarString="Wired";
            }
            else
            {
                VarString=QString::number(sys_radio[ph->ligne],16).rightJustified(4,'0').toUpper();
            }
            break;

        case VAR_NOM_CONCENTRATEUR:
            if(!nb_sys) break;
            if(update_addAPI(sys_radio[ph->ligne]))
            {
                VarString = serialCom->getCentralName();
            }
            break;
        case VAR_ACTIF:
            if(!nb_sys) break;
            if (is_actif[ph->ligne])
                VarString ="on";
            else
                VarString ="off";
            if((ph->ligne<(nb_sys-1))&&nb_sys) ph->ligne++;
            break;

        case VAR_NBSYS:
            VarString=QString::number(nb_sys);
            break;

            // Menu Array
        case VAR_NBMOD:
            //itoa(nb_mod2,VarString);
            if(!nb_sys) break;
            //VarString=QString::number(nb_mod[ph->current_sys]);
            VarString=QString::number(nb_mod2[ph->current_sys]);
            //qDebug()<<"size"<<VarString<<ph->current_sys;
            break;

        case VAR_SNMODULES:
            if(!nb_sys) break;

            if(ph->ligne>(nb_mod2[ph->current_sys]-1))
                break;
            //qDebug()<<"nb_of_mod2"<<nb_mod2[ph->current_sys];
            VarString=QString::number(moduleList[ph->current_sys][ph->ligne].serialNb,16).rightJustified(8,'0').toUpper();
            //qDebug()<<nb_mod2[ph->current_sys]<<ph->ligne;
            //qDebug()<<"sn"<<VarString.rightJustified(4,'0').toUpper();
            ph->voie=1;
            mesure_puissance(ph);
            ph->ligne++;
            break;

        case VAR_MESURESP:
            if(!nb_sys) break;
            if(ph->ligne>(nb_mod2[ph->current_sys]))
                break;
            VarString=QString::number(ph->value[ph->voie-1],'f',0);
            //qDebug()<<"format voie"<<ph->voie<<" : "<<ph->format[ph->voie-1];
            switch(ph->format[ph->voie-1])
            {
            case 0:
                break;
            case 1:
                if(i>1)
                    VarString=QString::number(float(ph->value[ph->voie-1])/(10*(i-1)),'f',(i-1));
                break;
            case 2:
                    VarString=QString::number(float(ph->value[ph->voie-1])/100.,'f',2);
                break;

            case 0xFF:
                VarString="~";
                break;
            }
            if(ph->voie<6)
                ph->voie++;
            break;
        case VAR_SNRADIO2: //	itoa(snr_array,VarString);
            if(!nb_sys) break;
            if(update_addAPI(sys_radio[ph->current_sys]))
                VarString=QString::number(serialCom->address_API,16).rightJustified(4,'0').toUpper();
            //bcd32(snr[RadioSel],VarString);
            break;
        case VAR_SNCONCEN2:
            if(!nb_sys) break;
            if(update_addAPI(sys_radio[ph->current_sys]))
            {
            VarString=QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0').toUpper();
            qDebug()<<"sn concetrator"<<VarString<<ph->current_sys<<sys_radio[ph->current_sys];
            }
           // bcd32(snc[RadioSel],VarString);
            break;

            // Menu Data
        case VAR_NOM_CONCENTRATEUR2:
            if(!nb_sys) break;
            if(update_addAPI(sys_radio[ph->current_sys]))
            {
                VarString = serialCom->getCentralName();
                updateMemoryInfo(ph->current_sys);

            }
            break;
        case VAR_SNCONCEN3:
            if(!nb_sys) break;
            if(update_addAPI(sys_radio[ph->current_sys]))
                VarString=QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0').toUpper();

            break;
        case VAR_PERIODE:
            if(!nb_sys) break;
            VarString=QString::number(periode[ph->current_sys]);
            break;
        case VAR_DATE_CONCENTRATEUR:
            if(!nb_sys) break;
            /*if (lit8(snr[RadioSel],0x01000000,0x00000120))	{
                VarString[0]=ascii(GetTrameIn(12)>>4);
                VarString[1]=ascii(GetTrameIn(12) & 0x0f);
                VarString[2]='/';
                VarString[3]=ascii(GetTrameIn(11)>>4);
                VarString[4]=ascii(GetTrameIn(11) & 0x0f);
                VarString[5]='/';
                VarString[6]='2';
                VarString[7]='0';
                VarString[8]=ascii(GetTrameIn(10)>>4);
                VarString[9]=ascii(GetTrameIn(10) & 0x0f);
                VarString[10]=' ';
                VarString[11]=ascii(GetTrameIn(13)>>4);
                VarString[12]=ascii(GetTrameIn(13) & 0x0f);
                VarString[13]=':';
                VarString[14]=ascii(GetTrameIn(14)>>4);
                VarString[15]=ascii(GetTrameIn(14) & 0x0f);
                VarString[16]=':';
                VarString[17]=ascii(GetTrameIn(15)>>4);
                VarString[18]=ascii(GetTrameIn(15) & 0x0f);
                VarString[19]=0;
            }
            else VarString[0]=0;*/
            break;
        case VAR_NBDATA:
            if(!nb_sys) break;
            if(memoryOverflow[ph->current_sys]>0)
            {
                VarString=QString::number(endOfMemory[ph->current_sys]);
            }
            else
            {
                VarString=QString::number(memoryPointer[ph->current_sys]);
            }

            //ltoa(nbdata,VarString);
            break;
        case VAR_FREEMEM:
            if(!nb_sys) break;
            if(memoryOverflow[ph->current_sys]>0)
            {
                VarString="0";
            }
            else
            {
                VarString=QString::number(
                            ((endOfMemory[ph->current_sys]-memoryPointer[ph->current_sys])*100 /endOfMemory[ph->current_sys]));
            }
            break;
        case VAR_HEURE_APPEL:
            if(!nb_sys) break;
            VarString=QString::number(hh_appel);
            break;
        case VAR_MIN_APPEL:
            if(!nb_sys) break;
            VarString=QString::number(mm_appel);
            break;
        case VAR_FTP_SERV:
            VarString=FTP_ServerName;
            break;
        case VAR_FTP_USER:
            VarString=FTP_UserName;
            break;
        case VAR_FTP_PASS:
            if(FTP_Password.size()>0)
            {
                for (int i=0;i<FTP_Password.length();i++) VarString+="*";
            }
            else VarString="";

            break;
        case VAR_FTP_REP:
            VarString=FTP_Rep;
            break;
        case VAR_DATE_CARTE:
            VarString=QDateTime::currentDateTime().toString("dd/MM/yy hh:mm:ss");
            break;
        case VAR_SNTP_SERV:
            //memcpy(VarString,(void*)SNTP_ServerIP,16);
            break;
        case VAR_FTP_RESPONSE:
            VarString=ftp_state->text();
            break;
        case VAR_NB_DATASENT:
            if(!nb_sys) break;
            VarString=QString::number(last_address[ph->current_sys]);
            //ltoa(last_address[RadioSel],VarString);
            break;
        case VAR_TIME_ZONE:
           // itoa(zone,VarString);
            break;
        case VAR_HEADER:
           // itoa(always_header,VarString);
            if(!always_header) VarString="0";
            else  VarString="1";
            break;
        case VAR_MODULE:
            if(!nb_sys) break;
            if(ph->ligne>(nb_mod2[ph->current_sys]))
                break;
            VarString=QString::number(moduleList[ph->current_sys][ph->ligne].serialNb,16).rightJustified(8,'0').toUpper();

            break;
        case VAR_CHANNEL:
            if(!nb_sys) break;
            VarString=QString::number(ph->voie);
            break;
        case VAR_PHASE:
            if(!nb_sys) break;
            VarString=QString::number(ph->phase);
            qDebug()<<"phase : "<<VarString;
            break;
        case VAR_SENSORSN:
             VarString=QString::number(ph->sensor_sn,16).rightJustified(4,'0').toUpper();
            break;
        case VAR_SENSORCH:
            if(!nb_sys) break;
            VarString=QString::number(ph->sensor_ch);
           // itoa(SensorCH,VarString);
            break;
        case VAR_NBLIGNES:
            VarString=QString::number(nb_mod2[ph->current_sys]-nb_mod[ph->current_sys]+1);
            break;
        case VAR_MODULETYPE:
            if(ph->ligne>(nb_mod2[ph->current_sys]))
            VarString=QString::number(moduleList[ph->current_sys][ph->ligne].typeOfModule);
           // itoa(typemod[ModuleSel],VarString);
            break;
        case VAR_SENSORTYPE:
            VarString=QString::number(ph->SensorType);
            break;
        case VAR_VERSION:
            VarString=QString::number(VERSION_SOFT);
            break;
         case VAR_M_RADIO_EXIST:
            if(m_radio_ex[ph->current_sys])
                VarString="1";
            else  VarString="0";
            break;
        }
        ph->VarString=VarString;
        busy_http=false;
    }



    void HttpDaemon::discardClient()
    {
        QTcpSocket* socket = (QTcpSocket*)sender();
        socket->deleteLater();
        for(int i=0;i<=handle_nr;i++) //delete HCB
        {
            if(socket->objectName().toInt()==HCB[i].socket)
            {
              //  qDebug()<<"Connection closed"<<HCB[i].socket<<i;
                HCB[i]=HCB[handle_nr];
                HCB[handle_nr--].socket=-1;
                break;
            }
        }

    }


    bool HttpDaemon::initModuleDetection(uint8_t i_sysradio)
    {

        update_addAPI(sys_radio[i_sysradio]);
        nbRemainingRetryToFindModule=10; //this is not the real value (3), will be applied when first module found
        // clear lists of last modules founded
        //moduleList.clear();
        nb_mod[i_sysradio]=0;

        // ask to all modules to listen the autodetection request
        bool ok=serialCom->writeByteAt(ALL_MODULE,0x155,0);
        waitFor(10);
        ok=serialCom->writeByteAt(ALL_MODULE,0x155,0);    //done again to be sure
        waitFor(10);

        // ask to all centrals to initialize the module detection
        ok = serialCom->writeByteAt(ALL_CENTRAL,0x160,1);
        //qDebug()<<"0x160"<<ok;
        autodetectRetry=10; //max of retry
        endOfFindingModules=false;
        return ok;
    }

    int HttpDaemon::fetchModuleDetectionResult(uint8_t i_sysradio)
    {   // read number of module detected and serial number of these modules
        update_addAPI(sys_radio[i_sysradio]);
         m_radio_ex[i_sysradio]=false;
        bool ok =false;
        uchar nbOfModulesBytesFound=0;
        // reading nb of modules detected
        ok = serialCom->readBytesAtWithRetry(serialCom->getCentralSN(),0x160,1,3);
        qDebug()<<"nb_of_module"<<ok<<serialCom->getReceivedData()[1];
        if(ok)
        {
            nbOfModulesBytesFound = serialCom->getReceivedData()[1];
            if(nbOfModulesBytesFound==0)    //No new modules
                return 0;
            if(serialCom->getReceivedData()[0]>0)
            {
                nbOfModulesBytesFound=0; // Not yet updated
                return 0;
            }
            //else qDebug()<<"Value is updated, "<<nbOfModulesBytesFound<<" bytes found (nb modules x4).";

            // New module(s) detected, looking for serial number
            if((nbOfModulesBytesFound>0) && ((nbOfModulesBytesFound & 0x3)==0))
            {
                if(nbOfModulesBytesFound>64) nbOfModulesBytesFound=64;
                // Not more than 16 modules at once

                //Read the list of SN found :
                ok=serialCom->readBytesAtWithRetry(serialCom->getCentralSN(), 0x400,8,3);
                if(ok)
                {
                    // Copy to not overwrite by a read/write operation
                    uchar receivedModulesSN [nbOfModulesBytesFound];
                    for(uchar i=0; i<nbOfModulesBytesFound; i++) receivedModulesSN[i]= serialCom->getReceivedData()[i];

                    // Take modules SN from the data received
                    for(int i=0; i<(nbOfModulesBytesFound/4);i++)
                    {
                        uint32 moduleSN=peekUint32FromUcharTabLittleEndian(receivedModulesSN,i*4);
                        qDebug()<<"module found : "<<QString::number(moduleSN,16);
                        addFoundModuleOnList(moduleSN,i_sysradio);

                        //prevent future answer of this module :
                        if(!serialCom->writeByteDontCheckResponse(moduleSN,0x155,1))
                        {
                            qDebug()<<"error on preventing answer";
                        }
                        waitFor(20);
                    }
                }
            }
        }
        else    //not ok
        {
            qDebug()<<"No response from the central";
        }

        if(!ok) return -1;
        else return nbOfModulesBytesFound/4;    //=nb of modules found
    }


    bool HttpDaemon::addFoundModuleOnList(uint32 _moduleSN,uint8_t i_sysradio)
    {
        int module_exist=-1;
        // Query informations about module and add it in the module list.
        for(uint i=0; i<nb_mod[i_sysradio]; i++) //prevent double entry
        {
            if(moduleList[i_sysradio][i].serialNb==_moduleSN)
            {
                module_exist=i;
                break;
            }
        }
        //reading @1000080  //nbLines, type and coeffs
        if(!serialCom->readBytesAtWithRetry(_moduleSN,0x01000080,2,3))
        {
            qDebug()<<"Error on updating a module !";           //TODO : ?
            return false;
        }
        else    //read OK
        {
            int nbOfLines=1;    //default nbOfLines
            if(serialCom->getReceivedData()[12]==250) // module type wireless
            {
                nbOfLines=serialCom->getReceivedData()[13];
                if(nbOfLines>8) nbOfLines=8;    //to limit nOfLines to 8
            }

            Module_serv moduleFound;
            moduleFound.serialNb=_moduleSN;
            moduleFound.typeOfModule=serialCom->getReceivedData()[12];    //type of module
           /* {
            case 0:
            case 255:
                moduleFound.typeOfModule=powerModule;
                break;
            case 249:
                moduleFound.typeOfModule=wirelessModule2;
                break;
            case 250 :
                moduleFound.typeOfModule=wirelessModule;
                break;
            case 252 :
                moduleFound.typeOfModule=pressureModule;
                break;
            case 253 :
                moduleFound.typeOfModule=temperatureModule;
                break;
            default :
                moduleFound.typeOfModule=powerModule2;
            }*/
            moduleFound.memoryAvailable=serialCom->getReceivedData()[14];
            moduleFound.nbOfLines=nbOfLines;

            //fetching coefficient values :
            for(int channelIndex=0;channelIndex<6;channelIndex++)
            {
                moduleFound.mulCoeff[channelIndex]=serialCom->getReceivedData()[2*channelIndex];
                moduleFound.divCoeff[channelIndex]=serialCom->getReceivedData()[(2*channelIndex)+1];
            }

            // Place on the list and sort

            if(module_exist==-1)
            {
                moduleList[i_sysradio][nb_mod[i_sysradio]++]=moduleFound;
                nb_mod2[i_sysradio]=nb_mod[i_sysradio];
                qDebug()<<"nb_of_ligne"<<nbOfLines;
                if(moduleFound.typeOfModule==250)
                {
                    m_radio_ex[i_sysradio]=true;
                    for(int i=1;i<nbOfLines;i++)
                    {
                       moduleList[i_sysradio][nb_mod2[i_sysradio]++].serialNb=moduleFound.serialNb;
                    }
                    for(int k=nb_mod[i_sysradio]-1;k<nb_mod2[i_sysradio];k++)
                    {
                        if (serialCom->readBytesAtWithRetry( moduleList[i_sysradio][k].serialNb,0x01000000 | (0xA0+(12u*k)),2,3 ))
                        {
                            for (int i=0;i<6;i++)
                            {
                                moduleList[i_sysradio][k].divCoeff[i]=serialCom->getReceivedData()[1+i*2];
                                moduleList[i_sysradio][k].mulCoeff[i]=serialCom->getReceivedData()[i*2];
                            }
                             moduleList[i_sysradio][k].typeOfModule = moduleFound.typeOfModule;
                        }
                    }

                }
            }
            else {
                moduleList[i_sysradio][module_exist]=moduleFound;
                 }
            return true;
        }

    }





    void HttpDaemon::refreshTableValues(uint8_t i_sysradio)
    {
        //qDebug()<<"refresh";

        if(serialCom->isOpen())
        {
            //serialCom->deleteErrorCom();    //retry in case of error
                //Check if new modules
                int returnFromModuleDetection=fetchModuleDetectionResult(i_sysradio);
                if(returnFromModuleDetection==0) //No module
                {
                    qDebug("No module found");
                    nbRemainingRetryToFindModule--; //no module found = decrement
                    qDebug()<<"nbRemainingRetryToFindModule="<<nbRemainingRetryToFindModule;
                }
                else if(returnFromModuleDetection<0)
                {
                    qDebug("Error com during module detection fetching");
                }
                else
                {
                    qDebug("New module found");
                    //new modules found = restart counter
                    nbRemainingRetryToFindModule=NB_RETRY_TO_FIND_MODULES;
                }
        }   //else = wait for com port

    }

    void HttpDaemon::mesure_puissance(HTTP_INFO* ph)
    {

        if(!update_addAPI(sys_radio[ph->current_sys]))return;
        for (int i=0;i<6;i++)
        {
            ph->format[i]=0;
        }
        switch(moduleList[ph->current_sys][ph->ligne].typeOfModule)
        {


        case 249:
            for (int i=0;i<6;i++) ph->format[i]=1;
            break;
        case 250:

            if (serialCom->readBytesAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x160+12u*(ph->ligne-nb_mod[ph->current_sys]+1),2,3))
            {

                for (int i=0;i<6;i++)	{
                    int16_t p = int16(peekUint16FromUcharTabBigEndian(serialCom->getReceivedData(),i*2));
                    //qDebug()<<"value"<<p;
                    if ((p==int16_t(0x8000)) || (p==0x7FFE)||(p==-10281))
                    {
                        ph->format[i]=0xff;
                        ph->value[i]=0;
                    }
                    else	{
                        if (moduleList[ph->current_sys][ph->ligne].mulCoeff[i]<0x06)			{  //03-THygro: 04-05:TPulse
                            ph->value[i]=p;
                            ph->format[i]=2;
                        }
                        else if (moduleList[ph->current_sys][ph->ligne].mulCoeff[i]<0x13)	{	//06-12-Lamp
                            ph->value[i]=p * 100 / 255;
                            ph->format[i]=0;
                        }
                        else if (moduleList[ph->current_sys][ph->ligne].mulCoeff[i]<0x60)	{	// 13-29:THygro  30-59: TPulse
                            ph->value[i]=p;
                            ph->format[i]=2;
                        }
                        else  if (moduleList[ph->current_sys][ph->ligne].mulCoeff[i]<0x80)	{  // Rserv
                            ph->value[i]=p;
                            ph->format[i]=2;
                        }
                        else	{							// Prises
                            if (serialCom->readBytesAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x500+24u*(ph->ligne-nb_mod[ph->current_sys]+1)+i*4,1,3))
                            {
                            int32_t (peekUint32FromUcharTabBigEndian(serialCom->getReceivedData(),0));
                            ph->value[i]=p;
                            ph->format[i]=1;
                            }
                        }
                    }
                }
            }
            else
                for (int i=0;i<6;i++) ph->value[i]=0;
            break;

        default:

            if(serialCom->readBytesAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x000001E0,2,3))
                for (int i=0;i<6;i++)
                {
                    ph->value[i]=int16(peekUint16FromUcharTabBigEndian(serialCom->getReceivedData(),i*2))/ moduleList[ph->current_sys][ph->ligne].divCoeff[i] * moduleList[ph->current_sys][ph->ligne].mulCoeff[i];
                    //qDebug()<<"p"<<i<<ph->value[i];
                }
            else
                for (int i=0;i<6;i++) ph->value[i]=0;
        }
        //qDebug()<<"mesure pui";
    }

    bool HttpDaemon::updateMemoryInfo(uint16_t _current_sys)
    {   //get info to update memoryPointer & memoryOverflow
        bool ok=serialCom->readBytesAtWithRetry(serialCom->getCentralSN(),0x01000010,1,3);
        if(!ok)
            qDebug()<<"error on quering free space value";
        else
        {
            memoryPointer[_current_sys]=serialCom->getReceivedData()[0]   //24bits, bigEndian
                    +uint32(serialCom->getReceivedData()[1]<<8)
                    +uint32(serialCom->getReceivedData()[2]<<16);
            endOfMemory[_current_sys] = FINMEMOIRE1;   // End of External EEPROM
            if(serialCom->getReceivedData()[6]==0x02 && serialCom->getReceivedData()[7]==0x01)
            {
            //    memoryconfig->setCurrentIndex(1);
                endOfMemory[_current_sys]=FINMEMOIRE2; // End of External EEPROM Central 2 (double memory)
            }
            //else memoryconfig->setCurrentIndex(0);
            memoryOverflow[_current_sys]=serialCom->getReceivedData()[4];
            periode[_current_sys]=periodes[serialCom->getReceivedData()[3]];
        }
        return ok;
    }

    void  HttpDaemon::update_module(HTTP_INFO* ph)
    {
        if(!update_addAPI(sys_radio[ph->current_sys]))return;
           switch(moduleList[ph->current_sys][ph->ligne].typeOfModule)
           {
           case 250:
               if (serialCom->readBytesAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x01000040+ph->voie-1,1,3))
               {
                   ph->sensor_ch = serialCom->getReceivedData()[0];
               }
               if (serialCom->readBytesAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x010000A0+ph->voie+ph->voie-2,1,3))
               {
                   ph->sensor_sn = peekUint16FromUcharTabLittleEndian(serialCom->getReceivedData(),0);
               }
               ph->SensorType = 3;   // Plug
               if ( (hi(ph->sensor_sn)<4) || ((hi(ph->sensor_sn)>=0x13) && (hi(ph->sensor_sn)<0x30)) ) ph->SensorType = 0;  // TempHygroPulse
               else if ( ((hi(ph->sensor_sn)>=0x4) && (hi(ph->sensor_sn)<6)) || ((hi(ph->sensor_sn)>=0x30) && (hi(ph->sensor_sn)<0x60)) ) ph->SensorType = 1; // TempPulse
               else if ( (hi(ph->sensor_sn)>=0x6) && (hi(ph->sensor_sn)<13) ) ph->SensorType = 2;  // Lamp
                    ph->phase = 200;		// Pour demander l'affichage spcial radio
                    break;
            default:
               if(serialCom->readBytesAtWithRetry(moduleList[ph->current_sys][ph->ligne].serialNb,0x00000110+ph->voie-1,1,3))
               {
                   ph->phase =serialCom->getReceivedData()[0];
               }
               break;
           }


     }
    bool HttpDaemon::update_addAPI(uint16_t newadd)
    {
        if(newadd!= serialCom->address_API)
        {
            serialCom->address_API=newadd;
            bool ok=serialCom->centralDetection();
            return ok;
        }

        return true;
    }


    void HttpDaemon::update_config()
    {
        QFile(QString(DEFAULT_DIR)+"config.ini").copy(QString(DEFAULT_DIR)+"config.ini.old"); //copy du fichier en local
        QSettings *settingFile=new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
        QString line_list_sys="";

        for(int i=0;i<nb_sys;i++){
            uint16_t radio_sys=sys_radio[i];
            QString line_list_mod="";
            QString sys_string=QString::number(radio_sys,16).rightJustified(4,'0').toUpper();
            for(int j=0;j<nb_mod[i];j++)
            {
               line_list_mod+=QString::number(moduleList[i][j].serialNb,16).rightJustified(8,'0').toUpper()+";";
            }
            line_list_sys+=sys_string+";";
            settingFile->setValue("HTTP_SERV/"+sys_string+"/MOD_LIST",line_list_mod);
            if(is_actif[i]) settingFile->setValue("HTTP_SERV/"+sys_string+"/IS_ACTIV","1");
            else settingFile->setValue("HTTP_SERV/"+sys_string+"/IS_ACTIV","0");
            settingFile->setValue("HTTP_SERV/"+sys_string+"/LAST_ADDRESS",last_address[i]);
        }
        settingFile->setValue("HTTP_SERV/LIST_SYS",line_list_sys);
        settingFile->setValue("HTTP_SERV/HH_APPEL",QString::number(hh_appel));
        settingFile->setValue("HTTP_SERV/MM_APPEL",QString::number(mm_appel));
        settingFile->setValue("HTTP_SERV/FTP_SERV",FTP_ServerName);
        settingFile->setValue("HTTP_SERV/FTP_USER",FTP_UserName);
        settingFile->setValue("HTTP_SERV/FTP_PASS",FTP_Password);
        settingFile->setValue("HTTP_SERV/FTP_REP",FTP_Rep);
   //     settingFile->setValue("HTTP_SERV/HTTP_REP",HTTP_rep);
   //     settingFile->setValue("HTTP_SERV/PDC_REP",PDC_rep);
        if(!always_header)
            settingFile->setValue("HTTP_SERV/HEADER","0");
        else
            settingFile->setValue("HTTP_SERV/HEADER","1");
        delete settingFile;

    }


    bool HttpDaemon::initenvoiFTP()
    {
     SysEnvoi = 0;
     while (!is_actif[SysEnvoi] && (SysEnvoi<nb_sys))
     {
         SysEnvoi++; //choix du prochain systeme actif
     }
     if (is_actif[SysEnvoi] && (SysEnvoi<nb_sys))
     {
         return true;
     }
     return false;
    }

    bool HttpDaemon::envoiFTP_next()
        {

        SysEnvoi++;
        while (!is_actif[SysEnvoi] && (SysEnvoi<nb_sys))
        {
            SysEnvoi++;
        }
        if (is_actif[SysEnvoi] && (SysEnvoi<nb_sys))
        {
            return true;
        }
        return false;

        }


    uint8_t HttpDaemon::downloadCampaign()
    {
        update_addAPI(sys_radio[SysEnvoi]);
        change_label("Reading MV Data");
        data_over65k=false;
        QDir _dir;
        int _dirExists = _dir.exists( PDC_rep+QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0') );
        // if not, create it
        if( !_dirExists )
            _dir.mkdir( PDC_rep+QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0') );
        pdc_file_name=QDateTime::currentDateTime().toString("yyMMdd_hhmmss")+".pdc";
        // init file for writing
       QFile *pdc_file = new QFile(PDC_rep+QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0')+"/"+pdc_file_name);
        //QFile *pdc_file = new QFile("d:/file.pdc");
        if(!pdc_file->open(QFile::WriteOnly | QFile::Truncate))
        {
            qDebug()<<"can't open file";
            return 0;
        }
        pdc.setDevice(pdc_file);
        uint32_t current_address;// = last_address[SysEnvoi];



        if(!serialCom->readBytesAtWithRetry(serialCom->getCentralSN(),0x01000010,1,5))
        {
            qDebug()<<"can't get concentrator SN";
            return 1;
        }
        //------------ENTETE CONCENTRATEUR*/
        uint32 currentSN=0;
        uint32_t snc2 = serialCom->getCentralSN();

        if (serialCom->readBytesAtWithRetry(snc2,0x01000010,1,5))
        {
            now_address=serialCom->getReceivedData()[0]   //24bits, bigEndian
                                +uint32(serialCom->getReceivedData()[1]<<8)
                                +uint32(serialCom->getReceivedData()[2]<<16);
            infoc1.Nbdata = now_address;
            infoc1.overflow=serialCom->getReceivedData()[4];
            infoc1.Mem=serialCom->getReceivedData()[6];
            mem=infoc1.Mem;
        }
        else return (2);	// Erreur lecture CAN address courante

        // Entte Concentrateur
        if (serialCom->readBytesAtWithRetry(snc2,0x01000020,4,5))						// Nom
            memcpy((void *)&infoc1.nom[0],(void *)&serialCom->getReceivedData()[0],16);
        else return (4);	// Erreur lecture Nom

        memcpy((void *)&infoc1.SN,(void *)&snc2,4);		// SN

        if (snc2 >= 0x01001000) central2 = 1;		// Teste si Central2 (pour bug buffer temporaire)
        else central2 = 0;

        if (serialCom->readBytesAtWithRetry(snc2,0x01000013,1,5))						// Priode et overflow
            infoc1.periode=serialCom->getReceivedData()[0];
        else return (5);	// Erreur lecture Perioe

        infoc1.Version  = VER;							// Version Fichier
        infoc1.NbMod = nb_mod[SysEnvoi];

        if (now_address < last_address[SysEnvoi])
        {
            if (infoc1.overflow) /* && (hh(last_address[SysEnvoi])>=2)  */
            {
                if (infoc1.Mem==2)
                    now_address = FINMEMOIRE2;
                else
                    now_address = FINMEMOIRE1;
            }
            else last_address[SysEnvoi] = 0;	// Raz
        }

        if ((now_address-last_address[SysEnvoi]) > MAXDATA )
        {
            now_address = last_address[SysEnvoi] + MAXDATA ;
            data_over65k=true;
        }

        // Sauve Entte Concentrateur
        if(always_header)
        {
        pdc<<uint16_t(0x8001);
        uint16_t size_c1=0x1E;//sizeof(infoc1);
        pdc<<uint8_t(lo(size_c1));		// Nombre de donnes du bloc
        pdc<<uint8_t(hi(size_c1));
        pdc<<uint16_t(0x0001);
        uint8_t *p;
        p=(uint8_t *)&infoc1;
        for (uint8_t i=0;i<size_c1;i++)
            pdc<<uint8_t(*p++);
        pdc<<uint16_t(0x7FFD);
        }
        uint8_t NbLigneModules=0;
        for (int m=0;m<nb_mod[SysEnvoi];m++) //enttes modules
        {
                currentSN=moduleList[SysEnvoi][m].serialNb;
            uint8_t i=0;
                infom1.SN=currentSN;
                infomw1.SN=currentSN;
                infom1.Reserved1 = 0;
                if (serialCom->readBytesAtWithRetry(currentSN,0x01000080,8,5))
                {
                        infom1.TypeMod = serialCom->getReceivedData()[0x0c];  	// Adresse 8C
                        if (infom1.TypeMod==250)
                        {
                                infomw1.NumLigne	= serialCom->getReceivedData()[0xd];
                                if ((infomw1.NumLigne<1) || (infomw1.NumLigne>8))
                                        infomw1.NumLigne = 1;
                                NbLigneModules = infomw1.NumLigne;  	// Nombre de lignes

                        }
                        else
                        {
                                infomw1.NumLigne = 1;
                        }
                        moduleList[SysEnvoi][m].nbOfLines=1;
                        infom1.Mem =  serialCom->getReceivedData()[0x0E];  	// Adresse 8E
                        infom1.Version =  serialCom->getReceivedData()[0x1F];	// Address 9F
                        infomw1.TypeMod=infom1.TypeMod;
                        infomw1.Mem =  infom1.Mem;  	// Adresse 8E
                        infomw1.Version =  infom1.Version ;	// Address 9F
                }
                else return (2);	// Erreur lecture

                if (infom1.TypeMod==250)
                {
                        // Modules Radio
                        for (int j=0;j<NbLigneModules;j++)
                        {
                                // modules normaux : Coef / Phases et noms de voies
                                if (serialCom->readBytesAtWithRetry(currentSN,0x010000A0+12*j,2,5))
                                {	// SensorsSN
                                        for (i=0;i<6;i++)
                                                infomw1.SensorsSN[i] = *((unsigned int*)(&(serialCom->getReceivedData()[i+i])));
                                }
                                else return (2);	// Erreur lecture

                                if (serialCom->readBytesAtWithRetry(currentSN,0x01000040+6*j,1,5))
                                {	// SensorsCh
                                        for (i=0;i<6;i++)
                                                infomw1.SensorsCh[i] = serialCom->getReceivedData()[i];
                                }
                                else return (3);	// Erreur lecture

                                if (serialCom->readBytesAtWithRetry(currentSN,0x031FFD00+96*(unsigned int)j,8,5))
                                { // Noms
                                        for (i=0;i<64;i++)
                                                infomw1.NomVoies[i] = serialCom->getReceivedData()[i];
                                }
                                else return (4);	// Erreur lecture

                                if (serialCom->readBytesAtWithRetry(currentSN,0x031FFD00+64+96*(unsigned int)j,8,5))
                                { // Noms Suite
                                        for (i=0;i<32;i++)
                                                infomw1.NomVoies[64+i] = serialCom->getReceivedData()[i];
                                }
                                else return (41);	// Erreur lecture

                                infomw1.NumLigne = j;
                                if(always_header)
                                {
                                pdc<<uint16_t(0x8001);
                                 uint16_t size_mw1=0x7A;
                                pdc<<uint8_t(lo(size_mw1));
                                pdc<<uint8_t(hi(size_mw1));
                                pdc<<uint16_t(0x0002);
                                uint8_t *p;
                                p=(uint8_t *)&infomw1;
                                for (i=0;i<size_mw1;i++)
                                        pdc<<uint8_t(*p++);
                                pdc<<uint16_t(0x7FFD);
                                }
                        }	// Boucle J
                }		// Module Radio
                else
                {		// modules normaux et 254 : Coef / Phases et noms de voies
                        if (infom1.TypeMod==254)
                        {   // Module Radio Ancien
                                if (serialCom->readBytesAtWithRetry(currentSN,0x01000012,1,5))
                                {	// SN Sensors
                                        for (i=0;i<6;i++)
                                                infomw1.SensorsSN[i] = *((unsigned int*)(&(serialCom->getReceivedData()[i+i])));
                                }
                                else return (2);	// Erreur lecture CAN
                                if (serialCom->readBytesAtWithRetry(currentSN,0x0100000C,1,5))
                                {	// SensorsCH
                                        for (i=0;i<6;i++)
                                                infomw1.SensorsCh[i] = serialCom->getReceivedData()[i];
                                }
                                else return (3);	// Erreur lecture
                        }
                        else
                        {	// Module Normal
                                if (serialCom->readBytesAtWithRetry(currentSN,0x01000080,2,5))
                                {	// Coefs
                                        for (i=0;i<12;i++)
                                                infom1.Coefs[i] = serialCom->getReceivedData()[i];
                                }
                                else return (2);	// Erreur lecture

                                if (serialCom->readBytesAtWithRetry(currentSN,0x01000004,1,5))
                                {	// Phases
                                        for (i=0;i<6;i++)
                                                infom1.Phases[i] = serialCom->getReceivedData()[i];
                                        }
                                else return (3);	// Erreur lecture
                                }

                                if (serialCom->readBytesAtWithRetry(currentSN,0x010000A0,8,5))
                                { // Noms
                                        for (i=0;i<64;i++)
                                                infom1.NomVoies[i] = serialCom->getReceivedData()[i];
                                }
                                else return (4);	// Erreur lecture

                                if (serialCom->readBytesAtWithRetry(currentSN,0x010000A0+64,8,5))
                                { // Noms suite
                                        for (i=0;i<32;i++)
                                                infom1.NomVoies[64+i] = serialCom->getReceivedData()[i];
                                }
                        else return (42);	// Erreur lecture CAN
                                if(always_header)
                                {
                                pdc<<uint16_t(0x8001);
                                uint16_t size_m1=0x7A;
                                pdc<<uint8_t(lo(size_m1));
                                pdc<<uint8_t(hi(size_m1));
                                pdc<<uint16_t(0x0002);
                                uint8_t *p;
                                p=(uint8_t *)&infom1;
                                for (i=0;i<size_m1;i++)
                                    pdc<<uint8_t(*p++);
                                pdc<<uint16_t(0x7FFD);
                                }
                        }
        }
    //****************************
    // Fetching campaign data
        change_label("Reading MV Data");
        for(int moduleIndex=0; moduleIndex<nb_mod[SysEnvoi]+1; moduleIndex++)
        {
            uint maxline=1;
            if(moduleIndex>0)
            {
            if(moduleList[SysEnvoi][moduleIndex-1].typeOfModule==250) maxline=moduleList[SysEnvoi][moduleIndex-1].nbOfLines;
            else if(moduleList[SysEnvoi][moduleIndex-1].typeOfModule==140) maxline=2; //pour ractif
            }
           for(uint lineIndex=0; lineIndex<maxline; lineIndex++)
            {
            uint8_t TypeModule;
            current_address = last_address[SysEnvoi]; //recupere current adress
            // update currentSN from list
            if(moduleIndex==0)  // central
            {
                currentSN=serialCom->getCentralSN();
                TypeModule=0;
            }
            else    //other modules
            {
                currentSN=moduleList[SysEnvoi][moduleIndex-1].serialNb;
                TypeModule=moduleList[SysEnvoi][moduleIndex-1].typeOfModule;
            }
            uint16_t size_bloc=uint32_t(now_address-last_address[SysEnvoi])+12;
            qDebug()<<"> module nb "<<moduleIndex<<", current SN : "<<QString::number(currentSN,16)<<"now adress "<<now_address
                       <<"last adress"<<last_address[SysEnvoi]<<"size bloc"<<size_bloc;
                // 6 premier octets de data : 8001 nbdata 0010
                int i=0;
                pdc<<uint16_t(0x8001);
                pdc<<uint8_t(lo(size_bloc));// Nombre de donnes du bloc
                pdc<<uint8_t(hi(size_bloc));
                pdc<<uint16_t(0x0010);
                pdc<<uint8_t(lo(currentSN));// SN du concentrateur/module dont on prend les data
                pdc<<uint8_t(hi(currentSN));
                pdc<<uint8_t(hh(currentSN));
                pdc<<uint8_t(hhh(currentSN));
                pdc<<uint8_t(lo(current_address));// ADresse mmoire correspondant au dbut des data
                pdc<<uint8_t(hi(current_address));
                pdc<<uint8_t(hh(current_address));
                pdc<<uint8_t(hhh(current_address));   
                pdc<<uint8_t(TypeModule); // Type de module
                pdc<<uint8_t(0);
                pdc<<uint8_t(lo(lineIndex+1));
                pdc<<uint8_t(hi(lineIndex+1));		// Numro de ligne (pour module Radio, 0 sinon ) rev 8/11/12, tait=ligne_radio


                uint32_t offset_address = 0x03000000;
                if (TypeModule == 0xfa)
                    hh(offset_address) = (lineIndex<<2);
                else if (TypeModule == 140)	{
                    if (lineIndex>0) offset_address = 0x04000000;		// REActif  08/11/2012
                }

                // Rev 15/10/2012 : pb lecture buffer temporaire des donnes moduli
                if (central2  && (TypeModule != 0xfa))   // ni concentrateur,   (ni module radio?)
                    offset_address |= 0x00800000;	// Corr 15/10/12: lecture correcte du buffer temporaire pour Moduli

                if (lo(current_address) & 0x07)
                {
                    if (mem!=2)	{
                        if (!lit2(currentSN,offset_address + (current_address & 0x3FFFF),4))	return 7;
                    }
                    else	{
                        if (!lit2(currentSN,offset_address + current_address , 4))	return 7;
                    }
                    current_address+=4;
                }

                if (lo(current_address) & 0x3F) // modif 17/05/2011 : soucis passage 0x010000
                {
                    i = 64 -(lo(current_address)& 0x3F);
                    if (mem!=2)
                    {
                        if(!lit2(currentSN,offset_address + (current_address & 0x3FFFF), i))	return 8;
                    }
                    else	{
                        if (!lit2(currentSN,offset_address + current_address , i))	return 8;
                    }
                    current_address+=i;
                }

                while (current_address<now_address)
                {
                    if ((now_address - current_address)>64) 		// Doit tre multiple de 64 pour lecture Flash
                        i = 64;
                    else
                        i = now_address - current_address;
                    if (mem!=2) {
                        if (!lit2(currentSN,offset_address + (current_address & 0x3FFFF), i))
                            return 9;
                    }
                    else	{
                        if (!lit2(currentSN,offset_address + current_address, i))
                            return 9;
                    }
                    current_address+=i;
                }
                pdc<<uint16_t(0x7FFD); //fin du bloc
            }
        }   // end of moduleSN loop

        //end of download


       /* pdc_file_name=QDateTime::currentDateTime().toString("yyMMdd_hhmmss")+".pdc";
        pdc_file->copy(PDC_rep+QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0')+"/"+pdc_file_name); //copy du fichier en local*/
        pdc_file->close();
        return 11;
    }

    uint16_t HttpDaemon::decode_var(QString _variable)
    {
        QString var_tmp="";
        bool ok=true;
        for(int i=0;i<_variable.size();i++)
        {
            var_tmp.append(_variable.at(i));
        }
        return var_tmp.toUInt(&ok,16);
    }


    bool HttpDaemon::lit2(uint32_t snm2,uint32_t adress , uint8_t _i)
    {
        int n_try=3;
        int n_try2=1;
        bool ok=false;
        do
        {
            n_try=3;
            do
            {
                ok=serialCom->readBytesAtWithRetry(snm2,adress,8,5);
               // qDebug()<<"read data sn:"<<QString::number(snm2,16).rightJustified(8,'0')<<" adress :"<<QString::number(adress,16).rightJustified(8,'0');
                if(serialCom->getReceivedDataLength()<64) ok=false;
                if (!ok){
                    waitFor(100);
                    //serialCom->deleteErrorCom();
                }
                QCoreApplication::processEvents();
            }while(!ok&&n_try--&&!close_request);
            QCoreApplication::processEvents();
            if(close_request) return false;
        }
        while(!ok&&--n_try2&&!close_request);
        if(close_request) return false;
        if(!ok)
        {
            qDebug()<<"error comm in dl, SN : "<<snm2<<", address :"<<adress;
            return false;
        }
        else
        {
            for(int i=0;i<_i;i++)
            {
                pdc<<uint8_t(serialCom->getReceivedData()[i]);
            }
        }
        return true;
    }

    void HttpDaemon::each_sec()
    {
        if((ftp_statut>4)&&(ftp_statut<11))
        {
            if(!timeout_ftp--)
            {
                change_label("Timeout FTP, err "+QString::number(ftp_statut));
                ftp_statut=44;
    
            }
        }
        if(++sec10>=5)
        {
            QByteArray def;
            def[0]=(0xCC);
            serialCom->write_serial_data(def,0);
            sec10=0;
#ifdef _RPI_

        refresh_inter();
#endif

        }
        if(sec10&0x01)
        {
#ifdef _RPI_
        if(current_ip_id<(interfaces-1)) current_ip_id++;
        else current_ip_id=0;
#endif
        }
        if(config_ongo)
        {
            change_statut("Config Mode "+QString::number(--timeout_config));
            if(!timeout_config)
            {
                mvModuleQuit();
                closeQuit();
            }
        }

        if(time_config) //update clock
            timeNowValue->setText(QDateTime::currentDateTime().toString("dd/MM/yy hh:mm:ss"));

        //check time
        if(!ftp_statut)
        {
            if(hh_appel>24)
            {
                if(((QTime::currentTime().hour()==(hh_appel-25))||
                    (QTime::currentTime().hour()==(12+hh_appel-25)))&&(count_sec==0xFFFF))
                {
                    if(QTime::currentTime().minute()==mm_appel)
                    {
                        qDebug()<<"heure ok";
                        daily_req_ok=true;
                        ftp_statut=1;
                        count_sec=0;
                    }
                }
                
                if(!daily_req_ok&&((QTime::currentTime().addSecs(-mm_appel*60-DELAI_UP).hour()==(hh_appel-25))||
                                   (QTime::currentTime().addSecs(-mm_appel*60-DELAI_UP).hour()==(12+hh_appel-25)))&&(count_sec==0xFFFF))
                {
                    
                    qDebug()<<"heure ok";
                    daily_req_ok=true;
                    ftp_statut=1;
                    count_sec=0;
                }
            }
            else if(hh_appel==24)
            {
                if((QTime::currentTime().minute()==mm_appel)&&(count_sec==0xFFFF))
                {
                    qDebug()<<"heure ok";
                    daily_req_ok=true;
                    ftp_statut=1;
                    count_sec=0;
                }
            }
            else
            {
                if((QTime::currentTime().hour()==hh_appel)&&(count_sec==0xFFFF))
                {
                    if(QTime::currentTime().minute()==mm_appel)
                    {
                        qDebug()<<"heure ok";
                        daily_req_ok=true;
                        ftp_statut=1;
                        count_sec=0;
                    }
                }
                
                if(!daily_req_ok&&(QTime::currentTime().addSecs(-mm_appel*60-DELAI_UP).hour()==hh_appel)&&(count_sec==0xFFFF))
                {
                    
                    qDebug()<<"heure ok";
                    daily_req_ok=true;
                    ftp_statut=1;
                    count_sec=0;
                }
            }
            
            if((date_tmp != QDate::currentDate())&&(count_sec==0xFFFF))
            {
                qDebug()<<"new day";
                daily_req_ok=false;
                date_tmp=QDate::currentDate();
            }
        }

        if(count_sec!=0xFFFF)
            if(count_sec++>DELAI_UP) count_sec=0xFFFF; //to avoid multiple send of data

        if(ftp_statut==2)
        {
            ftp_statut=3;

            qDebug()<<"start getting data";
            change_label("Reading MV Data");
            data_over65k=false;
            int return_code=downloadCampaign();
            if(return_code!=11)
            {
                change_label("Error when getting data, error nr : "+QString::number(return_code));
                change_statut("Web Server ON");
                ftp_statut=0;
                disable_server->setEnabled(true);
                groupBoxconfig->setEnabled(true);
            }
            else
            {
                if(FTP_ServerName.size()>0)
                {
                change_label("Connect to ftp host");
                change_statut("FTP Transfert");
                timeout_ftp=30;
                ftp_statut=4;
                ftp->connectToHost(FTP_ServerName);
                ftp_statut=5;
                }
                else    //server host vide : pas d'envoi ftp
                {
                    change_label("File transfert OK");
                    if (infoc1.Mem==2)	{
                            if (now_address==FINMEMOIRE2) now_address=0;
                    }
                    else
                            if (now_address==FINMEMOIRE1) now_address=0;

                    last_address[SysEnvoi] = now_address;
                    update_config();
                    ftp_statut=12;
                }
            }
        }
        if(ftp_statut==3)
        {
            change_label("Reading MV Data");
        }
        if(ftp_statut==1)
        {
            change_statut("Get MV Data");
            change_label("Reading MV Data");
            if(!initenvoiFTP())
            {
                change_statut("Web Server ON");
                ftp_statut=0;
                change_label("No activ system");
                return;
            }
            groupBoxconfig->setEnabled(false);
            disable_server->setEnabled(false);
            ftp_statut=2;
        }

        if(ftp_statut==12)
        {
            if(data_over65k)
            {
                ftp_statut=1;
            }
            else if(envoiFTP_next())
            {
                ftp_statut=1;
            }
            else
            {
                groupBoxconfig->setEnabled(true);
                disable_server->setEnabled(true);
                change_statut("Web Server ON");
                ftp_statut=0;

                //change_label("No activ system");
                return;
            }
        }
    }
#ifdef _RPI_
    void HttpDaemon::timer_lcd()
    {
    update_lcd();
    }
#endif

    void HttpDaemon::process_ftp( bool error)
    {
        bool dir_exist=false;
        QString central_name;
        qDebug()<<"ftp statut"<<ftp_statut;
        switch(ftp_statut)
        {
        case 5:
            if(error)
            {
               change_label("Error connecting to ftp host");
               ftp_statut=44;
               break;
            }
            change_label("Loging to FTP server");
            ftp->login(FTP_UserName,FTP_Password);
            ftp_statut=6;
            timeout_ftp=30;
            break;
        case 6:
            if(error)
            {
               change_label("Error with FTP username/password");
               ftp_statut=44;
               break;
            }
            change_label("Accessing base directory");
            ftp->cd(FTP_Rep);
            ftp_statut=7;
            timeout_ftp=30;
            break;
        case 7:
            if(error)
            {
               change_label("Error accessing base directory");
               ftp_statut=44;
               break;
            }
            ftp->listfile.clear();
            ftp->list();
            ftp_statut=8;
            timeout_ftp=30;
            break;
        case 8:
            if(error)
            {
               change_label("Error browsing base directory");
               ftp_statut=44;
               break;
            }

            central_name=QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0');
            for(int i=0;i<ftp->listfile.size();i++)
            {
                if(ftp->listfile.at(i)==central_name)
                {
                    dir_exist=true;
                    qDebug()<<"dir exist";
                    break;
                }
            }
            if(!dir_exist)
            {
                ftp->mkdir(central_name);
                ftp_statut=9;
                change_label("Creating concentrator directory");
                timeout_ftp=30;
                break;
            }
            ftp_statut=9;

        case 9:
            if(error)
            {
               change_label("Error creating concentrator directory");
               ftp_statut=44;
               break;
            }
            change_label("Browse concentrator directory");
            central_name=QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0');
            ftp->cd(central_name);
            ftp_statut=10;
            timeout_ftp=30;
            break;

        case 10:
            if(error)
            {
               change_label("Error accessing concentrator directory");
               ftp_statut=44;
               break;
            }
            change_label("Uploading file "+pdc_file_name);
            central_name=QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0');
            ftp->put(new QFile(PDC_rep+QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0')+"/"+pdc_file_name),pdc_file_name);
            ftp_statut=11;
            timeout_ftp=600;
            break;

        case 11:
            if(error)
            {
               change_label("Error sending file");
               ftp_statut=44;
               break;
            }
            change_label("FTP transfert OK");
            ftp_statut=44;
            if (infoc1.Mem==2)	{
                    if (now_address==FINMEMOIRE2) now_address=0;
            }
            else
                    if (now_address==FINMEMOIRE1) now_address=0;

            last_address[SysEnvoi] = now_address;
            update_config();
            break;
        }
        if(ftp_statut==44)
        {
            ftp_statut=12;
            ftp->close();
        }
    }





    void HttpDaemon::fillWindow()
    {
      //set GUI
        QVBoxLayout *verticalLayout = new QVBoxLayout;   //split window
        groupBoxconfig = new QGroupBox("Server Configuration");
        horizontalConfigLayout = new QHBoxLayout;   //split window
        QWidget *normalConfigWidget =new QWidget;
        rightWidget = new QWidget;
        normalConfigLayout = new QVBoxLayout;   //Boutons de menu
        networkConfigButton = new QPushButton("Network config");
        connect(networkConfigButton, SIGNAL(clicked()),this,SLOT(networkConfig()));
        ftpSendNowButton = new QPushButton("FTP Send Now");
        connect(ftpSendNowButton, SIGNAL(clicked()),this,SLOT(ftpSendNow()));
        ftpServerConfigButton = new QPushButton("FTP Server config");
        connect(ftpServerConfigButton, SIGNAL(clicked()),this,SLOT(ftpServerConfig()));
        timeConfigButton = new QPushButton("Time config");
        connect(timeConfigButton, SIGNAL(clicked()),this,SLOT(timeConfig()));
        mvConfigButton = new QPushButton("MV Systems Config");
        connect(mvConfigButton, SIGNAL(clicked()),this,SLOT(mvConfig()));
        QPushButton *key3g_button = new QPushButton("3G Dongle");
        key3g_button->setEnabled(false);

        normalConfigLayout->addWidget(networkConfigButton);
        normalConfigLayout->addWidget(ftpSendNowButton);
        normalConfigLayout->addWidget(ftpServerConfigButton);
        normalConfigLayout->addWidget(timeConfigButton);
        normalConfigLayout->addWidget(mvConfigButton);
        normalConfigLayout->addWidget(key3g_button);
        normalConfigWidget->setLayout(normalConfigLayout);

        normalConfigWidget->setFixedWidth(150);
        rightWidget = new QWidget;

        horizontalConfigLayout->addWidget(normalConfigWidget);
        horizontalConfigLayout->addWidget(rightWidget);
        groupBoxconfig->setLayout(horizontalConfigLayout);
        groupBoxconfig->setFixedSize(540,300);
        disable_server = new QPushButton("Disable Server and enable Multivoies configuration system");
        disable_server->setFixedHeight(80);
        QHBoxLayout *ftp_stateLayout = new QHBoxLayout;   //split window
        QLabel *ftp_state_lab=new QLabel("Last Status : ");
        ftp_state=new QLabel("");
        ftp_stateLayout->setAlignment(Qt::AlignLeft);
        ftp_stateLayout->addWidget(ftp_state_lab);
        ftp_stateLayout->addWidget(ftp_state);

        connect(disable_server,SIGNAL(clicked()),this,SLOT(button_quit_clicked()));
        verticalLayout->addWidget(disable_server);
        verticalLayout->addLayout(ftp_stateLayout);
        verticalLayout->addWidget(groupBoxconfig);
        httpconfig->setFixedWidth(550);
        httpconfig->setLayout(verticalLayout);
    }




    void HttpDaemon::networkConfig()
    {
        config_ongo=false;
        time_config=false;
        if (rightWidget!=NULL)
        {
            horizontalConfigLayout->removeWidget(rightWidget);
            delete rightWidget;
        }
        rightWidget = new QWidget;
        rightlayout = new QGridLayout;
        QLabel *lab0 = new QLabel("Current Interface:");
        lab0->setAlignment(Qt::AlignRight);
        rightlayout->addWidget(lab0,0,0);
            QLabel *lab1 = new QLabel("Current IP:");
            lab1->setAlignment(Qt::AlignRight);
            rightlayout->addWidget(lab1,1,0);
            QLabel *lab2 = new QLabel("Mask:");
            lab2->setAlignment(Qt::AlignRight);
            rightlayout->addWidget(lab2,2,0);
            QLabel *lab3 = new QLabel("Gateway:");
            lab3->setAlignment(Qt::AlignRight);
            rightlayout->addWidget(lab3,3,0);
          /*  QLabel *lab4 = new QLabel("DNS:");
            lab4->setAlignment(Qt::AlignRight);
            rightlayout->addWidget(lab4,3,0);*/
            QLabel *lab7 = new QLabel("MAC addr:");
            lab7->setAlignment(Qt::AlignRight);
            rightlayout->addWidget(lab7,4,0);
          /*  checkDHCP = new QCheckBox("DHCP Enabled");
            rightlayout->addWidget(checkDHCP,7,1);*/

            currentIface = new QComboBox();
            rightlayout->addWidget(currentIface,0,1);
            currentIPValue = new QLineEdit();
            rightlayout->addWidget(currentIPValue,1,1);
            maskValue = new QLineEdit();
            rightlayout->addWidget(maskValue,2,1);
            gatewayValue = new QLineEdit();
            rightlayout->addWidget(gatewayValue,3,1);
           // dnsValue = new QLineEdit();
            //rightlayout->addWidget(dnsValue,3,1);
            macAddrValue = new QLineEdit();
            rightlayout->addWidget(macAddrValue,4,1);
          //  checkDHCP->setEnabled(false);
            currentIPValue->setEnabled(false);
            maskValue->setEnabled(false);
            gatewayValue->setEnabled(false);
         //   dnsValue->setEnabled(false);
            macAddrValue->setEnabled(false);
            networkConfigQuitButton = new QPushButton("Quit");
            rightlayout->addWidget(networkConfigQuitButton,8,1);
            connect(currentIface,SIGNAL(currentIndexChanged(int)),this,SLOT(network_index_changed(int)));
            connect(networkConfigQuitButton, SIGNAL(clicked()),this,SLOT(networkConfigQuit()));
        rightWidget->setLayout(rightlayout);
        horizontalConfigLayout->addWidget(rightWidget);
        networkUpdate();
    }

    void HttpDaemon::network_index_changed(int _index)
    {
        char i_face_char[32];
        for(int i=0;i<32;i++)
        {
            if(i_face[_index].length()>i)
                i_face_char[i]= i_face[_index].at(i).toAscii();
            else i_face_char[i]='\0';
        }
        updateIP(i_face_char);
        currentIPValue->setText(currentIP);
        maskValue->setText (mask_addr);
        gatewayValue->setText (broadcast_addr);
        macAddrValue->setText (MAC_adress);
    }

    void HttpDaemon::refresh_inter()
    {
#ifdef _RPI_
        int sock;
        char *p;
        struct ifconf ifconf;
        struct ifreq ifreq[MAXINTERFACES];
        int i;

        // Create a socket or return an error.
        sock = socket(AF_INET, SOCK_STREAM, 0);
        if (sock < 0)
            qDebug()<<"socket";

        // Point ifconf's ifc_buf to our array of interface ifreqs.
        ifconf.ifc_buf = (char *) ifreq;

        // Set ifconf's ifc_len to the length of our array of interface ifreqs.
        ifconf.ifc_len = sizeof ifreq;

        //  Populate ifconf.ifc_buf (ifreq) with a list of interface names and addresses.
        if (ioctl(sock, SIOCGIFCONF, &ifconf) == -1)
            qDebug()<<"ioctl";

        // Divide the length of the interface list by the size of each entry.
        // This gives us the number of interfaces on the system.
        if(sizeof(ifreq[0])) interfaces = ifconf.ifc_len / sizeof(ifreq[0]);
        else interfaces=0;

        // Loop through the array of interfaces, printing each one's name and IP.
        for (i = 0; i < interfaces; i++)
        {
            if (-1==ioctl(sock, SIOCGIFADDR, &ifreq[i])) {
                 qDebug()<<"ioctl(SIOCGIFADDR) ";
                return ;
            }
            p=inet_ntoa(((struct sockaddr_in *)(&ifreq[i].ifr_addr))->sin_addr);
            strncpy(ip[i],p,sizeof(ip[i])-1);
            ip[i][sizeof(ip[i])-1]='\0';
            i_face[i]=ifreq[i].ifr_name;

            // Convert the binary IP address into a readable string.
        }
    closesocket(sock);
#endif
    }

    void HttpDaemon::updateIP(char *select_iface)
    {
#ifdef _RPI_
      struct ifreq ifr;
      int sock, j, k;
      char *p, addr[32], mask[32], mac[32],broadcast[32];
      sock=socket(PF_INET, SOCK_STREAM, 0);
      if (-1==sock) {
          qDebug()<<"error opening socket";
          return;
      }


      strncpy(ifr.ifr_name,select_iface,sizeof(ifr.ifr_name)-1);
      ifr.ifr_name[sizeof(ifr.ifr_name)-1]='\0';


      if (-1==ioctl(sock, SIOCGIFADDR, &ifr)) {
           qDebug()<<"ioctl(SIOCGIFADDR) ";
          return ;
      }
      p=inet_ntoa(((struct sockaddr_in *)(&ifr.ifr_addr))->sin_addr);
      strncpy(addr,p,sizeof(addr)-1);
      addr[sizeof(addr)-1]='\0';


      if (-1==ioctl(sock, SIOCGIFNETMASK, &ifr)) {
           qDebug()<<"ioctl(SIOCGIFNETMASK) ";
          return ;
      }
      p=inet_ntoa(((struct sockaddr_in *)(&ifr.ifr_netmask))->sin_addr);
      strncpy(mask,p,sizeof(mask)-1);
      mask[sizeof(mask)-1]='\0';

      if (-1==ioctl(sock, SIOCGIFBRDADDR, &ifr))    {
          qDebug()<<"ioctl(SIOCGIFBRDADDR)";
          return;
      }
      p=inet_ntoa(((struct sockaddr_in *)(&ifr.ifr_broadaddr))->sin_addr);
      strncpy(broadcast,p,sizeof(broadcast)-1);
      broadcast[sizeof(broadcast)-1]='\0';

      if (-1==ioctl(sock, SIOCGIFHWADDR, &ifr)) {
           qDebug()<<"ioctl(SIOCGIFHWADDR) ";
          return ;
      }
      for (j=0, k=0; j<6; j++) {
          k+=snprintf(mac+k, sizeof(mac)-k-1, j ? ":%02X" : "%02X",
              (int)(unsigned int)(unsigned char)ifr.ifr_hwaddr.sa_data[j]);
      }
      mac[sizeof(mac)-1]='\0';



    //  i_face=ifr.ifr_name;
      currentIP=addr;
      mask_addr=mask;
      broadcast_addr=broadcast;
      MAC_adress=mac;
      closesocket(sock);
#endif
    }

    void HttpDaemon::networkUpdate()
    {
        //refresh_inter();
        if(interfaces>0)
        {
        for(int i=0;i<interfaces;i++)
            currentIface->addItem(i_face[i]);
        }

    }

    void  HttpDaemon::ftpServerConfig()
    {
        config_ongo=false;
        time_config=false;
        if (rightWidget!=NULL)
        {
            horizontalConfigLayout->removeWidget(rightWidget);
            delete rightWidget;
        }
        rightWidget = new QWidget;
        rightlayout = new QGridLayout;
            QLabel *lab1 = new QLabel("FTP Server Name:");
            rightlayout->addWidget(lab1,0,0);
            QLabel *lab2 = new QLabel("User Name:");
            rightlayout->addWidget(lab2,1,0);
            QLabel *lab3 = new QLabel("Password:");
            rightlayout->addWidget(lab3,2,0);
            QLabel *lab4 = new QLabel("FTP Directory");
            rightlayout->addWidget(lab4,3,0);
            /*QLabel *lab5 = new QLabel("Last FTP Result:");
            rightlayout->addWidget(lab5,4,0);
            QLabel *lab6 = new QLabel("FTP Last Error:");
            rightlayout->addWidget(lab6,5,0);*/

            ftpServerNameValue = new QLineEdit();
            rightlayout->addWidget(ftpServerNameValue,0,1);
            ftpUserNameValue = new QLineEdit();
            ftpUserNameValue->setMinimumWidth(180);
            rightlayout->addWidget(ftpUserNameValue,1,1);
            ftpPasswordValue = new QLineEdit();
            rightlayout->addWidget(ftpPasswordValue,2,1);
            ftpDirectoryValue = new QLineEdit();
            rightlayout->addWidget(ftpDirectoryValue,3,1);
            /*ftpLastResultValue = new QLineEdit();
            rightlayout->addWidget(ftpLastResultValue,4,1);
            ftpLastErrorValue = new QLineEdit();
            rightlayout->addWidget(ftpLastErrorValue,5,1);*/

           ftpConfigSaveButton = new QPushButton("Save");
            rightlayout->addWidget(ftpConfigSaveButton,8,0);
            connect(ftpConfigSaveButton, SIGNAL(clicked()),this,SLOT(ftpConfigSave()));
            connect(ftpConfigSaveButton, SIGNAL(clicked()),this,SLOT(ftpServerUpdate()));

            ftpConfigQuitButton = new QPushButton("Quit");
            rightlayout->addWidget(ftpConfigQuitButton,8,1);
            connect(ftpConfigQuitButton, SIGNAL(clicked()),this,SLOT(ftpConfigQuit()));
        rightWidget->setLayout(rightlayout);
        horizontalConfigLayout->addWidget(rightWidget);
        ftpServerUpdate();
    }

    void  HttpDaemon::ftpServerUpdate()
    {

        ftpServerNameValue->setText (FTP_ServerName);
        ftpUserNameValue->setText (FTP_UserName);
        QString pass="";
        for (int i=0;i<FTP_Password.length();i++) pass+="*";
        ftpPasswordValue->setText (pass);
        ftpDirectoryValue->setText(FTP_Rep);
    }

    void HttpDaemon::networkConfigSave()
    {
      /*  bool needToSave = false;
        if(defaultIPValue->isModified())
        {
           // serialCom->WriteEthernetModuleRam(0x4D4,stringToIp(defaultIPValue->text()));
            needToSave = true;
        }
        if(defaultMaskValue->isModified())
        {
           //serialCom->WriteEthernetModuleRam(0x4D8,stringToIp(defaultMaskValue->text()));
            needToSave = true;
        }
        if(gatewayValue->isModified())
        {
           // serialCom->WriteEthernetModuleRam(0x4C8,stringToIp(gatewayValue->text()));
            needToSave = true;
        }
        if(checkDHCP->isChecked() && ((DHCPmem & 0x40)==0))
        {
            QByteArray configQByteArray;
            configQByteArray.push_back(DHCPmem | 0x40);
           // serialCom->WriteEthernetModuleRam(0x4F2,configQByteArray);
            needToSave = true;
        }
        if(!checkDHCP->isChecked() && ((DHCPmem & 0x40)!=0))
        {
            QByteArray configQByteArray;
            configQByteArray.push_back(DHCPmem & 0xBF);
            //serialCom->WriteEthernetModuleRam(0x4F2,configQByteArray);
            needToSave = true;
        }
        if (needToSave)
        {
            update_config();
        }*/
    }

    void HttpDaemon::ftpConfigSave()
    {
        bool needToSave = false;
        if(ftpServerNameValue->isModified())
        {
            FTP_ServerName=ftpServerNameValue->text();
            needToSave = true;
        }
        if(ftpUserNameValue->isModified())
        {
            FTP_UserName=ftpUserNameValue->text();
            needToSave = true;
        }
        if(ftpPasswordValue->isModified())
        {
            FTP_Password=ftpPasswordValue->text();
            needToSave = true;
        }
        if(ftpDirectoryValue->isModified())
        {
            FTP_Rep=ftpDirectoryValue->text();
            needToSave = true;
        }
        if (needToSave)
        {
            update_config();
        }
    }

    void HttpDaemon::ftpConfigQuit()
    {
        closeQuit();
    }

    void HttpDaemon::networkConfigQuit()
    {
        closeQuit();
    }

    void HttpDaemon::timeConfigQuit()
    {
        config_ongo=false;
        time_config=false;
        closeQuit();
    }

    void  HttpDaemon::ftpSendNow()
    {
        if(!ftp_statut)
        {
            count_sec=0;
            ftp_statut=1;
            daily_req_ok=true;
        }
    }

    void  HttpDaemon::timeConfig()
    {
        time_config=true;
        if (rightWidget!=NULL)
        {
            horizontalConfigLayout->removeWidget(rightWidget);
            delete rightWidget;
        }
        rightWidget = new QWidget;
        QVBoxLayout *vert_time_layout=new QVBoxLayout;
        QHBoxLayout *time_now_lay= new QHBoxLayout;
            QLabel *lab4 = new QLabel("Time Now:");
            time_now_lay->addWidget(lab4);
            timeNowValue = new QLineEdit();
            time_now_lay->addWidget(timeNowValue);
            timeNowValue->setEnabled(false);
/*
            QLabel *lab2 = new QLabel("Call Time:");
            rightlayout->addWidget(lab2,1,0);*/
            QGroupBox *groupBoxtime = new QGroupBox("Call Time");
            groupBoxtime->setFixedHeight(100);
            QVBoxLayout *vert_callt_layout=new QVBoxLayout;
            QButtonGroup *butt_group=new QButtonGroup;
            QHBoxLayout *hor_callt_layout= new QHBoxLayout;
            each_hour =new QRadioButton("Each hour");
            each_day =new QRadioButton("Once a day");
            twice_a_day =new QRadioButton("Twice a day");
            butt_group->addButton(each_hour);
            butt_group->addButton(each_day);
            butt_group->addButton(twice_a_day);
            hor_callt_layout->addWidget(each_hour);
            hor_callt_layout->addWidget(each_day);
            hor_callt_layout->addWidget(twice_a_day);
            vert_callt_layout->addLayout(hor_callt_layout);
            connect(butt_group,SIGNAL(buttonClicked(int)),SLOT(timeConfig_rbox(int)));
            QWidget *time_lab=new QWidget;
            QLabel *lab_e1 = new QLabel(" ");
            lab_e1->setFixedWidth(95);
            QLabel *lab_e2 = new QLabel(" ");
            lab_e2->setFixedWidth(55);
            QHBoxLayout *time_call_h= new QHBoxLayout;

            callTimehValue=new QLineEdit;
            callTimehValue->setFixedWidth(22);
            QLabel *lab2 = new QLabel(":");
            lab2->setFixedWidth(5);
            callTimemValue=new QLineEdit;
            callTimemValue->setFixedWidth(22);
            time_call_h->addWidget(lab_e1);
            time_call_h->addWidget(callTimehValue);
            time_call_h->addWidget(lab2);
            time_call_h->addWidget(callTimemValue);
           // time_call_h->addWidget(lab_e2);
            time_call_h->setAlignment(Qt::AlignLeft);
            time_lab->setLayout(time_call_h);

            vert_callt_layout->addWidget(time_lab);
            groupBoxtime->setLayout(vert_callt_layout);
            vert_time_layout->addLayout(time_now_lay);
            vert_time_layout->addWidget(groupBoxtime);
            QHBoxLayout *hor_butt_layout= new QHBoxLayout;
            timeConfigSaveButton = new QPushButton("Save");
            hor_butt_layout->addWidget(timeConfigSaveButton);
            connect(timeConfigSaveButton, SIGNAL(clicked()),this,SLOT(timeConfigSave()));
            connect(timeConfigSaveButton, SIGNAL(clicked()),this,SLOT(timeConfigUpdate()));
            timeConfigQuitButton = new QPushButton("Quit");
            hor_butt_layout->addWidget(timeConfigQuitButton);
            vert_time_layout->addLayout(hor_butt_layout);
            connect(timeConfigQuitButton, SIGNAL(clicked()),this,SLOT(timeConfigQuit()));
        rightWidget->setLayout(vert_time_layout);
        horizontalConfigLayout->addWidget(rightWidget);
        timeConfigUpdate();
    }
    void HttpDaemon::timeConfig_rbox(int i){
        if(each_hour->isChecked())
        {
            callTimehValue->setEnabled(false);
        }
        else if(each_day->isChecked())
        {
            callTimehValue->setEnabled(true);
        }
        else if(twice_a_day->isChecked())
        {
            callTimehValue->setEnabled(true);
        }
    }

    void HttpDaemon::timeConfigUpdate()
    {

        timeNowValue->setText(QDateTime::currentDateTime().toString("dd/MM/yy hh:mm:ss"));
        if(hh_appel>24)
        {
            twice_a_day->setChecked(true);
            callTimehValue->setText (QString::number(hh_appel-25).rightJustified(2,'0'));
            callTimemValue->setText (QString::number(mm_appel).rightJustified(2,'0') );
        }
        else if(hh_appel==24)
        {
            each_hour->setChecked(true);
            callTimehValue->setText ("");
            callTimemValue->setText (QString::number(mm_appel).rightJustified(2,'0') );
        }
        else
        {
            each_day->setChecked(true);
            callTimehValue->setText (QString::number(hh_appel).rightJustified(2,'0'));
            callTimemValue->setText (QString::number(mm_appel).rightJustified(2,'0') );
        }

    }

    void HttpDaemon::timeConfigSave()
    {
        if(each_hour->isChecked())
        {
            hh_appel=24;
            mm_appel=callTimemValue->text().toUShort();
        }
        else if(each_day->isChecked())
        {
            hh_appel=callTimehValue->text().toUShort();
            mm_appel=callTimemValue->text().toUShort();
        }
        else if(twice_a_day->isChecked())
        {
            hh_appel=25+callTimehValue->text().toUShort();
            mm_appel=callTimemValue->text().toUShort();
        }

        update_config();
    }

    void HttpDaemon:: mvConfig()
    {

        time_config=false;
        config_ongo=false;

        if (rightWidget!=NULL)
        {
            horizontalConfigLayout->removeWidget(rightWidget);
            delete rightWidget;
        }
        rightWidget = new QWidget;
        rightVLayout = new QVBoxLayout;
        QHBoxLayout *hb = new QHBoxLayout;
        QLabel *lab1 = new QLabel("Add Wireless System:");
        hb->addWidget(lab1);
        systemAddEdit = new QLineEdit();
        hb->addWidget(systemAddEdit);
        mvAddButton = new QPushButton( "Add");
        hb->addWidget(mvAddButton);
        connect(mvAddButton, SIGNAL(clicked()),this,SLOT(mvConfigAdd()));
        connect(mvAddButton, SIGNAL(clicked()),this,SLOT(mvConfigUpdate()));

        rightVLayout->addLayout(hb);

        QLabel *lab2 = new QLabel("Recorded Systems");
        rightVLayout->addWidget(lab2);
        systemsListBox = new QListView( httpconfig );
        rightVLayout->addWidget(systemsListBox);

        QHBoxLayout *hb2 = new QHBoxLayout;
        mvConfigButton = new QPushButton( "Config");
        hb2->addWidget(mvConfigButton);
        connect(mvConfigButton, SIGNAL(clicked()),this,SLOT(mvConfigConfig()));

        mvDelButton = new QPushButton( "Del");
        hb2->addWidget(mvDelButton);
        connect(mvDelButton, SIGNAL(clicked()),this,SLOT(mvConfigDel()));
        connect(mvDelButton, SIGNAL(clicked()),this,SLOT(mvConfigUpdate()));

        mvQuitButton = new QPushButton( "Quit");
        hb2->addWidget(mvQuitButton);
        connect(mvQuitButton, SIGNAL(clicked()),this,SLOT(mvConfigQuit()));

        rightVLayout->addLayout(hb2);

        rightWidget->setLayout(rightVLayout);
        horizontalConfigLayout->addWidget(rightWidget);
        mvConfigUpdate();
    }

    void HttpDaemon::mvConfigUpdate()
    {
        //QString VarString="";
        listSysView.clear();
        for (int i=0;i<(nb_sys);i++)
        {
            if(!nb_sys) break;
            if(!sys_radio[i])
                listSysView.append("Wired System");
            else listSysView.append("Radio system nr : "+QString::number(sys_radio[i],16));// +' ' + VarString  );
        }
        systemsListBox->setModel(new QStringListModel(listSysView));
        systemsListBox->setSelectionMode(QAbstractItemView::SingleSelection);

        QModelIndex index = systemsListBox->model()->index(0,0);
        systemsListBox->setCurrentIndex(index);
    }

    void HttpDaemon::mvConfigAdd()
    {
        sys_radio[nb_sys]=systemAddEdit->text().toInt(0,16);
        is_actif[nb_sys]=true;
        last_address[nb_sys]=0;
        m_radio_ex[nb_sys]=0;
        nb_mod[nb_sys]=0;
        nb_mod2[nb_sys++]=0;
        update_config();
    }

    void HttpDaemon::mvConfigConfig()
    {
        timeout_config=59;
        time_config=false;
        config_ongo=true;
        change_statut("Config Mode"+QString::number(timeout_config));
        QModelIndex index = systemsListBox->currentIndex();
        radioSelIndex = index.row();

        if (rightWidget!=NULL)
        {
            horizontalConfigLayout->removeWidget(rightWidget);
            delete rightWidget;
        }
        rightWidget = new QWidget;
        QHBoxLayout *hb1 = new QHBoxLayout;

        rightVLayout = new QVBoxLayout;
        wModuleEdit = new QLineEdit();
        if(sys_radio[radioSelIndex])
        {
            QHBoxLayout *hb2 = new QHBoxLayout;
            QLabel *lab1 = new QLabel("Wireless Module:");
            hb2->addWidget(lab1);
            hb2->addWidget(wModuleEdit);
            rightVLayout->addLayout(hb2);
        }

        QHBoxLayout *hb3 = new QHBoxLayout;
        QLabel *lab2 = new QLabel("Concentrator:");
        hb3->addWidget(lab2);
        centralEdit = new QLineEdit();
        hb3->addWidget(centralEdit);
        rightVLayout->addLayout(hb3);

        QHBoxLayout *hb4 = new QHBoxLayout;
        QLabel *lab3 = new QLabel("Name:");
        hb4->addWidget(lab3);
        centralNameEdit = new QLineEdit();
        hb4->addWidget(centralNameEdit);
        rightVLayout->addLayout(hb4);

        enableUpload = new QCheckBox("Enable Upload");
        rightVLayout->addWidget(enableUpload);
        connect(enableUpload, SIGNAL(stateChanged(int)),this,SLOT(mvUploadChanged(int)));

        QHBoxLayout *hb5 = new QHBoxLayout;
        QLabel *lab4 = new QLabel("Records to upload:");
        hb5->addWidget(lab4);
        dataToLoadEdit = new QLineEdit();
        hb5->addWidget(dataToLoadEdit);
        rightVLayout->addLayout(hb5);

        QHBoxLayout *hb8 = new QHBoxLayout;
        QLabel *lab7 = new QLabel("Current Data Pointer:");
        hb8->addWidget(lab7);
        currentPointerEdit = new QLineEdit();
        hb8->addWidget(currentPointerEdit);
        rightVLayout->addLayout(hb8);


        resetDataButton = new QPushButton("Reset Current Data Pointer");
        rightVLayout->addWidget(resetDataButton);
        connect(resetDataButton, SIGNAL(clicked()),this,SLOT(mvResetData()));
        connect(resetDataButton, SIGNAL(clicked()),this,SLOT(mvModuleUpdate()));

        QHBoxLayout *hb6 = new QHBoxLayout;
        searchModuleButton = new QPushButton("Search Modules");
        hb6->addWidget(searchModuleButton);
        connect(searchModuleButton, SIGNAL(clicked()),this,SLOT(mvSearch()));
        //connect(searchModuleButton, SIGNAL(clicked()),this,SLOT(mvModuleUpdate()));

        searchMoreButton = new QPushButton("Search More");
        hb6->addWidget(searchMoreButton);
        connect(searchMoreButton, SIGNAL(clicked()),this,SLOT(mvSearchMore()));
        //connect(searchMoreButton, SIGNAL(clicked()),this,SLOT(mvModuleUpdate()));
        rightVLayout->addLayout(hb6);

        moduleQuitButton = new QPushButton("Quit");
        connect(moduleQuitButton, SIGNAL(clicked()),this,SLOT(mvModuleQuit()));
        rightVLayout->addWidget(moduleQuitButton);

        hb1->addLayout(rightVLayout);

        QVBoxLayout *hb7 = new QVBoxLayout;
        QLabel *lab5 = new QLabel("Modules:");
        hb7->addWidget(lab5);

        modulesListView = new QListView;
        hb7->addWidget(modulesListView);

        hb1->addLayout(hb7);
        rightWidget->setLayout(hb1);
        horizontalConfigLayout->addWidget(rightWidget);
        //mvSearch();
        mvModuleUpdate();
    }

    void HttpDaemon::mvConfigDel()
    {
        timeout_config=59;
        QModelIndex index = systemsListBox->currentIndex();
        radioSelIndex=index.row();
        if(!sys_radio[radioSelIndex])
        {
            QMessageBox::critical(rightWidget,"Can't delete wired system","Wired system can't be deleted");
            return;
        }
        else
        {
            for (int i=radioSelIndex;i<nb_sys;i++)
            {
                sys_radio[i]=sys_radio[i+1];
                is_actif[i]=is_actif[i+1];
                nb_mod[i]=is_actif[i+1];
                for (int j=0;j<nb_mod[i];j++)
                    moduleList[i][j]=moduleList[i+1][j];
            }
        }
        nb_sys--;
        update_config();
    }

    void HttpDaemon::mvModuleUpdate()
    {
        timeout_config=59;
        // Remplit les valeurs
        enableUpload->blockSignals(true);
        if(!is_actif[radioSelIndex])   // Bit6
            enableUpload->setChecked(false);
        else
            enableUpload->setChecked(true);
        enableUpload->blockSignals(false);

        listModView.clear();
        for (int i=0;i<nb_mod[radioSelIndex];i++)
        {
            listModView.append(QString::number(moduleList[radioSelIndex][i].serialNb,16).rightJustified(8,'0'));
        }
        modulesListView->setModel(new QStringListModel(listModView));
        if(sys_radio[radioSelIndex])wModuleEdit->setText(QString::number(sys_radio[radioSelIndex],16));


        update_addAPI(sys_radio[radioSelIndex]);
        updateMemoryInfo(radioSelIndex);
        centralEdit->setText(QString::number(serialCom->getCentralSN(),16).rightJustified(8,'0'));



         centralNameEdit->setText(serialCom->getCentralName());

         QString Varstring="";
         if(memoryPointer[radioSelIndex]<last_address[radioSelIndex])
         {
             if(memoryOverflow[radioSelIndex]>0) //si overflow
             {
                 Varstring=QString::number((endOfMemory[radioSelIndex]-last_address[radioSelIndex]+memoryPointer[radioSelIndex]));
             }
             else
             {
                 Varstring=QString::number(memoryPointer[radioSelIndex]);
             }
         }
         else Varstring=QString::number((memoryPointer[radioSelIndex]-last_address[radioSelIndex]));
         dataToLoadEdit->setText(Varstring);
         currentPointerEdit->setText(QString::number(last_address[radioSelIndex]));
    }

    void HttpDaemon::mvConfigQuit()
    {

        closeQuit();
    }

    void HttpDaemon::mvResetData()
    {
        last_address[radioSelIndex]=0;
        mvModuleUpdate();
    }

    void HttpDaemon::mvSearch()
    {
        timeout_config=59;
        initModuleDetection(radioSelIndex);
        waitFor(50);
        refreshTableValues(radioSelIndex);
        update_config();
        mvModuleUpdate();

    }

    void HttpDaemon::mvSearchMore()
    {
        timeout_config=59;
        refreshTableValues(radioSelIndex);
        update_config();
        mvModuleUpdate();
    }

    void HttpDaemon::mvUploadChanged(int state)
    {
        timeout_config=59;
      /*  QByteArray configQByteArray;
        if (!state)
            configQByteArray.push_back(char(0));
        else
            configQByteArray.push_back(char(255));
        serialCom->WriteEthernetModuleRam(0x333+radioSelIndex,configQByteArray);
        configQByteArray.clear();
        serialCom->WriteEthernetModuleSpecial(0x22,configQByteArray);
        waitFor(300);*/
    }

    void HttpDaemon::mvModuleQuit()
    {
        timeout_config=59;
        config_ongo=false;
        change_statut("Web Server ON");
        mvConfig();

    }

    void HttpDaemon::clearMemory(uint8_t _current_sys)
    {
        update_addAPI(sys_radio[_current_sys]);
        // Clear overflow
        bool ok=serialCom->writeByteAtWithRetry(serialCom->getCentralSN(),0x01000014,0x00,3);
        if(!ok) qDebug()<<"error clearing overflow";

          // Clear address pointer
        for(int i=0;i<3;i++)
        {
            ok=ok&&serialCom->writeByteAtWithRetry(serialCom->getCentralSN(),0x01000010+uint32(i),0x00,3);
        }
        if(!ok) qDebug()<<"error clearing address pointer";
        else qDebug()<<"memory cleared";
    }

    void HttpDaemon::closeQuit()
    {
        if (rightWidget!=NULL)
        {
            horizontalConfigLayout->removeWidget(rightWidget);
            delete rightWidget;
            rightWidget = new QWidget;
            horizontalConfigLayout->addWidget(rightWidget);
        }
    }

    void HttpDaemon::button_quit_clicked()
    {
        //change_statut("Config Mode");
        close_request=true;
        waitFor(500);
        emit closingWindow();
    }
    void HttpDaemon::change_statut(QString new_statut)
    {
#ifdef _RPI_
      if(wiring_init_ok)
      {
      new_statut+=" ";
      lcd_statut_size=new_statut.length();
      for(int i=0;i<40;i++)
      {
          if(new_statut.length()>i)
             current_statut[i]= new_statut.at(i).toAscii();
          else current_statut[i]=0;
      }
      current_i2_scroll=0;
      }
#endif
    }

     void HttpDaemon::change_label(QString newlabel)
     {
     current_lab=newlabel;
      ftp_state->setText(newlabel);
      qDebug()<<newlabel;
#ifdef _RPI_
      QString lcd_lab=newlabel;
      lcd_lab+="    ";
      lcd_label_size=lcd_lab.length();
      for(int i=0;i<64;i++)
      {
          if(lcd_label_size>i)
             current_label[i]= lcd_lab.at(i).toAscii();
          else
             current_label[i]=lcd_lab.at(i-lcd_label_size).toAscii();
      }
      current_i_scroll=0;
#endif
     }
#ifdef _RPI_
     void HttpDaemon::update_lcd()
     {
         QString line1_str="Network "+i_face[current_ip_id]+":";
         LCDclear();
         QString Line0="v"+QString::number(VERSION_SOFT)+" "+QTime::currentTime().toString("hh:mm:ss");
         for(int i=0;i<14;i++)
         {
             if(Line0.length()>i)
                line0[i]= Line0.at(i).toAscii();
             else line0[i]='\0';
             if(interfaces>0)
             {
                 if(line1_str.length()>i)
                    line1[i]= line1_str.at(i).toAscii();
                 else line1[i]='\0';
             }
         }
         if(lcd_label_size>15)
         {
             if(++current_i_scroll>=(lcd_label_size*6/nb_pix_scroll))
             current_i_scroll=0;
         }
         line0[15]='\0';
         line1[15]='\0';
         line2[15]='\0';
         line3[15]='\0';
         LCDdrawstring(2,0, line0);
         if(interfaces<1)
         {
             LCDdrawstring(2,10, "No Interfaces");
         }
         else
         {
             LCDdrawstring(0,10, line1);
             LCDdrawstring(0,19, ip[current_ip_id]);
         }

         LCDdrawstring_c(current_i_scroll*nb_pix_scroll,30, current_label);
         LCDdrawstring_c(0,40, current_statut);
         LCDdisplay();
     }
 #endif


     void HttpDaemon::reset_pointer(uint8_t _current_sys)
     {
         update_addAPI(sys_radio[_current_sys]);
         if (serialCom->readBytesAtWithRetry(serialCom->getCentralSN(),0x01000010,1,3))
         {
             if (serialCom->getReceivedData()[4])
             {
                 uint32_t memPointer=serialCom->getReceivedData()[0]   //24bits, bigEndian
                         +uint32(serialCom->getReceivedData()[1]<<8)
                         +uint32(serialCom->getReceivedData()[2]<<16);
                 if (serialCom->getReceivedData()[16]==2) {
                     if ((memPointer+36)>FINMEMOIRE2)
                         last_address[_current_sys] = 36;
                     else
                         last_address[_current_sys] = memPointer+36;
                 }
                 else
                 {
                     if ((memPointer+36)>FINMEMOIRE1)
                         last_address[_current_sys] = 36;
                     else
                         last_address[_current_sys] = memPointer+36;
                 }
             }
             else
                 last_address[_current_sys] = 0;
         }
         update_config();
     }
void HttpDaemon::errorCom()
{
    qDebug()<<"Error COM";
   change_label("Error COM");
}

void HttpDaemon::noerror()
{
    qDebug()<<"No more Error COM";
    change_label("No more Error COM");
}
