#ifndef HTTP_SERVER_H
#define HTTP_SERVER_H
#include <QtNetwork>
 #include <QNetworkInterface>
#include <QWidget>
#include "common.h"
#include "manageserialport.h"
#include "myFtp.h"
#ifdef _RPI_
#include <string.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <arpa/inet.h>
#endif
#define MAX_HTTP_CONNECTIONS 30
#define MAXINTERFACES 5
#define ALL_MODULE 0x00000000
#define NBSYSTEM_MAX 16
#define NBMODULE_MAX 32
#define FINMEMOIRE1 0x3C000
#define FINMEMOIRE2 0x7E000
#define ALL_CENTRAL 0x01000000
#define MAXDATA 65535
#define DELAI_UP 300
#define NB_RETRY_TO_FIND_MODULES 2  //nb of tries with no module found before ending search
#define VER 102
// HttpDaemon is the the class that implements the simple HTTP server.
class HttpDaemon : public QTcpServer
{
    Q_OBJECT

public:
    HttpDaemon(quint16 port,ManageSerialPort *_serialPort,bool ftp_req,bool invalid_setting, QObject* parent = 0);
#ifdef _RPI_
    uint16_t lcd_label_size;
    char current_label[64];
#endif
        QString current_lab;

    void incomingConnection(int socket);
     void tryToOpenPort();
    void pause();

    void resume();
    QWidget *httpconfig;
    void change_label(QString newlabel);


  //  bool send_file(QTcpSocket* socket);
signals:
    void closingWindow();
public slots:
    void errorCom();
    void noerror();
    void process_ftp(bool error);
    void each_sec();
    void networkConfig();
    void networkUpdate();
    void ftpSendNow();
    void ftpServerConfig();
    void ftpServerUpdate();
    void timeConfig();
    void timeConfig_rbox(int i);
    void timeConfigUpdate();
    void timeConfigSave();
    void timeConfigQuit();
    void mvConfig();
    void mvConfigUpdate();
    void mvConfigAdd();
    void mvConfigConfig();
    void mvConfigDel();
    void mvConfigQuit();
    void networkConfigSave();
    void network_index_changed(int _index);
    void networkConfigQuit();
    void ftpConfigSave();
    void ftpConfigQuit();
    void mvResetData();
    void mvSearch();
    void mvSearchMore();
    void mvModuleQuit();
    void mvModuleUpdate();
    void mvUploadChanged(int state);
    #ifdef _RPI_
    void timer_lcd();
    #endif

private slots:
    void button_quit_clicked();
    void readClient();
    void discardClient();

private:
    uint16_t timeout_ftp;
    uint8_t timeout_config;
    bool data_over65k;
    bool time_config;
    #ifdef _RPI_
    int nb_pix_scroll;
    int inter_lcd;
    bool wiring_init_ok;
    char current_statut[64];
    uint8_t current_ip_id;
    char line0[16],line1[16],line2[16],line3[16],line4[16],line5[16];
    void update_lcd();
    QTimer *timerscroll;
    int16_t current_i_scroll,current_i2_scroll;
    uint16_t lcd_statut_size;
    #endif
    char ip[MAXINTERFACES][16];
    uint8_t sec10;
    int interfaces;
    void change_statut(QString new_statut);
    QString i_face[MAXINTERFACES];
    bool close_request;
    bool busy_http;
    void updateIP(char *select_iface);
    void refresh_inter();
    bool daily_req_ok;
    QDate date_tmp;
    uint16_t count_sec;
    QLabel *ftp_state;
    myFtp* ftp;
    QByteArray DataRead;
    int DHCPmem;
    int radioSelIndex;
    QString HTTP_rep,PDC_rep;

    QString currentIP,mask_addr,broadcast_addr,MAC_adress;
   //GUI
   QStringList listSysView;
   QStringList listModView;

   void closeQuit();
   QWidget *rightWidget;

   void fillWindow();
   QGroupBox *groupBoxconfig;
   QPushButton *disable_server;
   QHBoxLayout *horizontalConfigLayout;
   QVBoxLayout *normalConfigLayout;
   QPushButton *networkConfigButton;
   QPushButton *ftpSendNowButton;
   QPushButton *ftpServerConfigButton;
   QPushButton *timeConfigButton;
   QPushButton *mvConfigButton;
   QGridLayout *rightlayout;
   QVBoxLayout *rightVLayout;

   QComboBox *currentIface;
   QLineEdit *currentIPValue;
   QLineEdit *maskValue;
   QLineEdit *gatewayValue;
   QLineEdit *macAddrValue;
   QPushButton *networkConfigSaveButton;
   QPushButton *networkConfigQuitButton;

   QLineEdit *ftpServerNameValue;
   QLineEdit *ftpUserNameValue;
   QLineEdit *ftpPasswordValue;
   QLineEdit *ftpDirectoryValue;
   QLineEdit *ftpLastResultValue;
   QLineEdit *ftpLastErrorValue;
   QCheckBox *checkDHCP;
   QPushButton *ftpConfigSaveButton;
   QPushButton *ftpConfigQuitButton;

   QLineEdit *callTimehValue;
   QLineEdit *callTimemValue;
   QLineEdit *timeNowValue;
   QRadioButton *each_day;
   QRadioButton *twice_a_day;
   QRadioButton *each_hour;
   QPushButton *timeConfigSaveButton;
   QPushButton *timeConfigQuitButton;

   QLineEdit *systemAddEdit;
   QListView *systemsListBox;
   QPushButton *mvAddButton;
   QPushButton *mvDelButton;
   QPushButton *mvQuitButton;

   QLineEdit *wModuleEdit;
   QLineEdit *centralEdit;
   QLineEdit *centralNameEdit;
   QCheckBox *enableUpload;
   QLineEdit *dataToLoadEdit;
   QLineEdit *currentPointerEdit;
   QPushButton *resetDataButton;
   QPushButton *searchModuleButton;
   QPushButton *searchMoreButton;
   QPushButton *moduleQuitButton;
   QListView *modulesListView;
    int ftp_statut;
    void update_config();
    QHostAddress host_add[MAX_HTTP_CONNECTIONS];
    uint8_t current_sysh[MAX_HTTP_CONNECTIONS];
    uint8_t nb_host;
    uint8_t current_lineh[MAX_HTTP_CONNECTIONS];
    uint8_t current_voieh[MAX_HTTP_CONNECTIONS];
    uint32_t endOfMemory[NBSYSTEM_MAX];
    uint32_t memoryPointer[NBSYSTEM_MAX];
    bool memoryOverflow[NBSYSTEM_MAX];
    Module_serv moduleList[NBSYSTEM_MAX][NBMODULE_MAX];
    uint16_t sys_radio[NBSYSTEM_MAX];
    bool is_actif[NBSYSTEM_MAX];
    uint8_t nb_mod[NBSYSTEM_MAX];
    uint8_t nb_mod2[NBSYSTEM_MAX];
    uint32_t last_address[NBSYSTEM_MAX];
    uint16_t periode[NBSYSTEM_MAX];
     bool always_header;
    uint8_t mem;
    QString pdc_file_name;
    uint8_t hh_appel,mm_appel;
    QString FTP_ServerName,FTP_UserName,FTP_Password,FTP_Rep;
    uint8_t lignetodelete;
    uint8_t current_sys;
    //uint8_t voie;
   // uint8_t ligne;
    QTimer *Timer1;
    bool initModuleDetection(uint8_t i_sysradio);
    int autodetectRetry;
    int nbRemainingRetryToFindModule;
    bool endOfFindingModules;
    bool centralDetected;
    int fetchModuleDetectionResult(uint8_t i_sysradio);
    bool addFoundModuleOnList(uint32 _moduleSN,uint8_t i_sysradio);
    void refreshTableValues(uint8_t i_sysradio);
    uint32_t  now_address;

    //int value[6];
   // uint8_t phase;
    //uchar format[6];
    unsigned int periodes[19];
    //QString VarString;
    bool config_ongo;
    uchar central2;
    uint8_t SysEnvoi;
    bool m_radio_ex[NBSYSTEM_MAX];

 QSettings *settingFile;

    ManageSerialPort *serialCom;
   // QFile  local_file;
    bool disabled;
   // QString file_ext;
uint8_t handle_nr;

uint8_t nb_sys;



// CGI Command Codes
#define CGI_CMD_RECONFIG	('Z')
// CGI Variable codes. - There could be 00h-FFh variables.
// NOTE: When specifying variables in your dynamic pages (.cgi),
//       use the hexadecimal numbering scheme and always zero pad it
//       to be exactly two characters.  Eg: "%04", "%2C"; not "%4" or "%02C"
#define VAR_STACK_VERSION	(0x01)	// Stack constants
#define VAR_STACK_DATE		(0x02)
#define VAR_DATE_TIME		(0x03)
#define VAR_MAC_ADDRESS         (0x06)	// Stack configuration variables
#define VAR_SERIAL_NUMBER       (0x07)
#define VAR_IP_ADDRESS          (0x08)
#define VAR_SUBNET_MASK         (0x09)
#define VAR_GATEWAY_ADDRESS     (0x0A)
#define VAR_DHCP	        (0x0B)	// Use this variable when the web page is updating us
#define VAR_DHCP_TRUE           (0x0B)	// Use this variable when we are generating the web page
#define VAR_DHCP_FALSE          (0x0C)	// Use this variable when we are generating the web page

#define VAR_RAZ_LIGNE		(0x0F)
#define VAR_SNRADIO		(0x10)
#define VAR_NOM_CONCENTRATEUR	(0x11)
#define VAR_ACTIF		(0x12)
#define VAR_NBSYS		(0x13)
// Menu Array
#define VAR_NBMOD		(0x14)
#define VAR_SNMODULES		(0x15)
#define VAR_MESURESP		(0x16)
#define VAR_SNRADIO2		(0x17)
#define VAR_SNCONCEN2		(0x18)
// Menu Data
#define VAR_NOM_CONCENTRATEUR2	(0x19)
#define VAR_SNCONCEN3		(0x20)
#define VAR_PERIODE		(0x21)
#define VAR_DATE_CONCENTRATEUR	(0x22)
#define VAR_NBDATA		(0x23)
#define VAR_FREEMEM		(0x24)
#define VAR_HEURE_APPEL		(0x25)
#define VAR_MIN_APPEL		(0x26)
#define VAR_FTP_SERV		(0x27)
#define VAR_FTP_USER		(0x28)
#define VAR_FTP_PASS		(0x29)
#define VAR_FTP_REP		(0x30)
#define VAR_DATE_CARTE		(0x31)
#define VAR_SNTP_SERV		(0x32)
#define VAR_FTP_RESPONSE	(0x33)
#define VAR_NB_DATASENT		(0x34)
#define VAR_TIME_ZONE		(0x35)
#define VAR_HEADER		(0x36)
#define VAR_MODULE		(0x37)
#define VAR_CHANNEL		(0x38)
#define VAR_PHASE		(0x39)
#define VAR_SENSORSN		(0x40)
#define VAR_SENSORCH		(0x41)
#define VAR_NBLIGNES		(0x42)
#define VAR_MODULETYPE		(0x43)
#define VAR_SENSORTYPE		(0x44)
#define VAR_VERSION		(0x45)
#define VAR_TYPE_CONNECTION     (0x46)
#define VAR_M_RADIO_EXIST       (0x47)

// CGI Command codes (CGI_CMD_DIGOUT).
#define CMD_ACTIF_ON		("on")
#define CMD_ACTIF_OFF		("off")
#define CMD_ACTIF_NO		("no")


    // Each dynamic variable within a CGI file should be preceeded with this character.
QString HTTP_VAR_ESC_STRING;
QString HTTP_PERCENT;
    // HTTP File Types
    enum
    {
    HTTP_TXT=0,
    HTTP_HTM,
    HTTP_HTML,
    HTTP_CGI,
    HTTP_XML,
    HTTP_GIF,
    HTTP_PNG,
    HTTP_JPG ,
    HTTP_JAVA,
    HTTP_WAV ,
    HTTP_UNKNOWN  ,
    };

#define FILE_TYPES_SIZE 11
    QStringList httpFiles;



    // Content entry order must match with those "HTTP File Types" define's.
    QStringList httpContents;

    // HTTP FSM states for each connection.
    typedef enum _SM_HTTP
    {
        SM_HTTP_IDLE = 0u,
        SM_HTTP_GET,
        SM_HTTP_NOT_FOUND,
        SM_HTTP_GET_READ,
        SM_HTTP_GET_PASS,
        SM_HTTP_GET_DLE,
        SM_HTTP_GET_HANDLE,
        SM_HTTP_GET_HANDLE_NEXT,
        SM_HTTP_GET_VAR,
        SM_HTTP_HEADER,
        SM_HTTP_DISCARD
    } SM_HTTP;

    // Supported HTTP Commands
    typedef enum _HTTP_COMMAND
    {
        HTTP_GET = 0u,
        HTTP_POST,
        HTTP_NOT_SUPPORTED,
        HTTP_INVALID_COMMAND
    } HTTP_COMMAND;

    // HTTP Connection Info - one for each connection.
    typedef struct _HTTP_INFO
    {
        int socket;
        QString Filename;
        SM_HTTP smHTTP;
        //uint8_t smHTTPGet;
        QString VarString;
        uint8_t voie;
        uint8_t ligne;
        int32_t value[6];
        uint8_t phase;
        uchar format[6];
        uint8_t VarGet;
        uint8_t fileType;
        uchar command;
        uint8_t current_sys;
        uint8_t sensor_ch;
        uint16_t sensor_sn;
        uint8_t SensorType;
        QStringList variable;
        //uint16_t variable;
    } HTTP_INFO;

    typedef uint8_t HTTP_HANDLE;


    typedef enum
    {
        HTTP_NOT_FOUND = 0u,
        HTTP_NOT_AVAILABLE,
        HTTP_ONGOING_FTP
    } HTTP_MESSAGES;

    typedef enum _envoi_ftp	{
        ENVOI_IDLE = 0,
        ENVOI_START,
        ENVOI_ENTETE,
        ENVOI_CREEFICHIER,
        ENVOI_FTPDONE
    } send_ftp;
    QDataStream pdc;
    // Following message order must match with that of HTTP_MESSAGES enum.
    QStringList HTTPMessages;

    // Standard HTTP messages.
    QString HTTP_OK_STRING;// = "HTTP/1.1 200 OK\r\nContent-type: ";
    QString HTTP_OK_NO_CACHE_STRING;// = "HTTP/1.1 200 OK\r\nDate: Wed, 05 Apr 2006 02:53:05 GMT\r\nExpires: Wed, 05 Apr 2006 02:52:05 GMT\r\nCache-control: private\r\nContent-type: ";

    QString HTTP_HEADER_END_STRING;// = "\r\n\r\n";


    typedef struct _infoc { //size 0x1E
                    uint8_t nom[16];
                    uint32_t SN;
                    uint32_t Nbdata;
                    uint8_t periode;
                    uint8_t overflow;
                    uint8_t NbMod;
                    uint8_t Version;
                    uint8_t Reserved0;
                    uint8_t Mem;
                    }infoc;

                            // 255 normal - 254 radio 6 - 253 module T - 252 module P
                            // 250 Radio 48
    typedef struct _infom	{ //size 0x7A
                            uint32_t SN;
                            uint8_t TypeMod;
                            uint8_t Version;
                            uint8_t NomVoies[96];
                            uint8_t Coefs[12];		// Coef mult et Div
                            uint8_t Phases[6];
                            uint8_t Reserved1;
                            uint8_t Mem;

                            }infom;
    typedef struct _infomw	{	//size 0x7A					// Cas du module Radio
                            uint32_t SN;
                            uint8_t TypeMod;
                            uint8_t Version;
                            uint8_t NomVoies[96];
                            uint16_t  SensorsSN[6];
                            uint8_t SensorsCh[6];
                            uint8_t NumLigne;		// Numro de ligne6
                            uint8_t Mem;
                            }infomw;

    infoc infoc1;
    infom infom1;
    infomw infomw1;

    // HTTP Command Strings
    QString  HTTP_GET_STRING;// = "GET";

    // Default HTML file.
    QString HTTP_DEFAULT_FILE_STRING;// = "INDEX.HTM";
    uint8_t HTTPParse(QString httpData, HTTP_INFO *ph);
    void HTTPGetVar(uint8_t var,HTTP_INFO* ph);
    void mesure_puissance(HTTP_INFO* ph);
    void update_module(HTTP_INFO* ph);
    void HTTPExecCmd(HTTP_INFO* ph);
    bool update_addAPI(uint16_t newadd);
    bool open_and_send_file(HTTP_INFO *ph,QTcpSocket* socket);
    bool initenvoiFTP();
    bool envoiFTP_next();
    bool updateMemoryInfo(uint16_t _current_sys);
    //uint8_t HttpDaemon::envoi_create_file(char ligne, char mem);
    HTTP_INFO HCB[MAX_HTTP_CONNECTIONS+1];
    uint16_t decode_var(QString _variable);
    bool lit2(uint32_t snm2,uint32_t adress , uint8_t _i);
    void clearMemory(uint8_t _current_sys);
    void reset_pointer(uint8_t _current_sys);
    uint8_t downloadCampaign();

};



#endif // HTTP_SERVER_H
