#include "mainwindow.h"
#define VERSION_SOFT 312
bool refreshIsPaused;
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent)
{

        config_pass_ok=false;
        connect_cfg_opened=false;
        ad_ok=true;
        //ftp_req=false;
       // mode_server=false;
        first_connect=true;
        //simple_http=NULL;
        settingFile=NULL;
        serialCom=NULL;
        commonRefreshTimer=NULL;
        connectionDialogWindow = NULL;
        advConfigWindow = NULL;
        gprsConfigWindow = NULL;
        ethernetConfigWindow=NULL;
        mainFrame = NULL;
        configMenu = NULL;
        fileMenu = NULL;
        display_mode=0;
        //server=NULL;
        refreshIsPaused=false;
        relayWindow=NULL;
        pauseRefreshAction=NULL;
            displayTimer = new QTimer();
        //create Serial Com (not open)
        serialCom = new ManageSerialPort;
        invalid_setting_file=false;
        if(check_setting_file(QString(DEFAULT_DIR)+"config.ini"))
        {
            if(check_setting_file(QString(DEFAULT_DIR)+"config.ini.old"))
            {
                qDebug()<<"no valid setting file";
                invalid_setting_file=true;
            }
            else
            { //fichier config.ini bon, on le copie  la place de fichier config.ini.old
                QFile(QString(DEFAULT_DIR)+"config.ini.old").copy(QString(DEFAULT_DIR)+"config.ini") ;
            }
        }

        settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);

        if(settingFile->contains("DISPLAY/TITLE1"))
        {

            display_mode=1;
        }
        qDebug()<<"display mode"<<display_mode;

        delete settingFile;
        settingFile=NULL;
        commonRefreshTimer = new RefreshTimer;

        if(!display_mode)
        {
            init_window();
        }
        else
        {
           init_display();
        }






}

void MainWindow::init_window()
{
    display_mode=0;
    displayTimer->stop();
    // setWindowState(windowState() ^ Qt::WindowFullScreen);
    settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
     if(settingFile->contains("WINDOW_POS/MAIN_WIN_X")&&
                settingFile->contains("WINDOW_POS/MAIN_WIN_Y"))
        {
            int maxX=QApplication::desktop()->width();
            int maxY=QApplication::desktop()->height();
            int posX=settingFile->value("WINDOW_POS/MAIN_WIN_X").toInt();
            int posY=settingFile->value("WINDOW_POS/MAIN_WIN_Y").toInt();
            if(((maxX-posX-100)>0)&&((maxY-posY-70)>0)&&(posX>0)&&(posY>0))this->move(posX,posY);
            else  this->move(0,0);
        }
     delete settingFile;
     settingFile=NULL;

     setWindowTitle("MV MultiVoies - OmgaWatt v"+QString::number(VERSION_SOFT));
     setWindowIcon(QIcon(QString(DEFAULT_DIR)+"icon/MVicon.png"));
     comStatus = new QLabel("<img src=""icon/unknownsignal.png""></img><font color= orange><b>COM ?</b></font>",this);
     comStatus->setHidden(true);
     addStatusIcon();
     addMenus();
     moduleList = new vector<Module>;
     setFixedHeight(800);
     //init refresh timer

     //init central Form
     mainFrame = new ManageModule(serialCom, commonRefreshTimer, moduleList);
     connect(mainFrame,SIGNAL(ad_ok()),this,SLOT(auto_d_ok()));
     connect(mainFrame,SIGNAL(eraseCentralInTitle()),this,SLOT(clearTitleCentralDisplay()));
     connect(this,SIGNAL(advancedUserModeEnabled()),mainFrame,SLOT(switchToAdvancedUserMode()));
    // connect(serialCom,SIGNAL(centralSNfound()),this,SLOT(centralSNupdated()));
     show();
     ad_ok=false;
     QWidget *MainWidget=new QWidget;
     QVBoxLayout  *MainLayout = new QVBoxLayout;
     connectionDialogWindow = new ConnectionDialog(serialCom);
     MainLayout->addWidget(connectionDialogWindow);
     MainLayout->addWidget(mainFrame);
     MainWidget->setLayout(MainLayout);
     setCentralWidget(MainWidget);
     connect(connectionDialogWindow,SIGNAL(configurationClosed()),this,SLOT(returnFromConnectionDialog()));
     tryToOpenPort();

}

void MainWindow::refresh_display()
{
        // This method update the line values
        bool ok=true;
        if(serialCom->isOpen())
        {
            ok=serialCom->readBytesAtWithRetry(sn_display,0x1E0,2,2);
            for(int currentChannel=0; currentChannel<6; currentChannel++)
            {
                int16 powerValue=peekUint16FromUcharTabBigEndian(serialCom->getReceivedData(),2*currentChannel);
                //not uint16 because of signed values
                powerValue= int16(powerValue*coef_mul[currentChannel]/coef_div[currentChannel]);
                qDebug()<<QString::number(powerValue)+" W";
                power_channel[currentChannel]->setText(QString::number(powerValue)+" W");
            }
        }
        else for(int currentChannel=0; currentChannel<6; currentChannel++)
                power_channel[currentChannel]->setText("-1 W");

}


void MainWindow::init_display()
{
    bool ok;

    settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    if(settingFile->contains("COM/COM_PORT")&&settingFile->contains("COM/COM_TYPE"))
    {
        qDebug()<<"File and data found";
       // if(serialCom==NULL) serialCom = new ManageSerialPort();
        qDebug()<<"type of connection : "<<settingFile->value("COM/COM_TYPE").toInt();
        QString portName=settingFile->value("COM/COM_PORT").toString();

        serialCom->open(portName,settingFile->value("COM/COM_TYPE").toInt());

    //    if(serialCom->isOpen())
     //   {
            sn_display=0;
            QWidget *mainwidg= new QWidget();

          /*  QPixmap bkgnd(QString(DEFAULT_DIR)+"icon/background.png");
            bkgnd = bkgnd.scaled(this->size(), Qt::IgnoreAspectRatio);
            QPalette palette;
             palette.setBrush(QPalette::Background, bkgnd);*/
             mainwidg->setStyleSheet("background-color: black;background-image:url(\""+QString(DEFAULT_DIR)+"icon/background.png\"); background-repeat:no-repeat");

            QPushButton *quit = new QPushButton("X",mainwidg);
            quit->setStyleSheet("background-color: black;  color: grey;  font-weight: bold;");
            connect(quit,SIGNAL(clicked(bool)),this,SLOT(close()));

            QStringList pos;

            if(settingFile->contains("DISPLAY/EXIT_POS"))
            {
                pos=settingFile->value("DISPLAY/EXIT_POS").toString().split(";");
                if(pos.size()==2)
                {
                    quit->move(pos[0].toInt(),pos[1].toInt());
                }
            }

            QFontDatabase::addApplicationFont("icon/Exo2.0.ttf");
            QLabel *title1 = new QLabel("",mainwidg);
            QFont font( "Exo 2.0", 12, QFont::Bold);
            if(settingFile->contains("DISPLAY/SN_MODULE"))
            {
                 sn_display=settingFile->value("DISPLAY/SN_MODULE").toString().toInt(&ok,16);
            }
            qDebug()<<QString::number(sn_display,16);
            title1->setFont(font);
            if(settingFile->contains("DISPLAY/TITLE1_FONT_SIZE"))
            {
                 font.setPointSize(settingFile->value("DISPLAY/TITLE1_FONT_SIZE").toInt());
            }
            title1->setFont(font);

            if(settingFile->contains(("DISPLAY/TITLE1_FONT_COLOR")))
            {
                title1->setStyleSheet("color: #"+settingFile->value("DISPLAY/TITLE1_FONT_COLOR").toString()+";background:transparent");
            }
            else title1->setStyleSheet("background:transparent");

            if(settingFile->contains("DISPLAY/TITLE1"))
            {
                  title1->setText(settingFile->value("DISPLAY/TITLE1").toString());

            }
            QLabel *title2 = new QLabel("",mainwidg);
            if(settingFile->contains("DISPLAY/TITLE2"))
                  title2->setText(settingFile->value("DISPLAY/TITLE2").toString());

            QFont font2( "Exo 2.0", 12, QFont::Bold);
            if(settingFile->contains("DISPLAY/TITLE2_FONT_SIZE"))
            {

                 font2.setPointSize(settingFile->value("DISPLAY/TITLE2_FONT_SIZE").toInt());

            }
            title2->setFont(font);

            if(settingFile->contains(("DISPLAY/TITLE2_FONT_COLOR")))
            {
                title2->setStyleSheet("color: #"+settingFile->value("DISPLAY/TITLE2_FONT_COLOR").toString()+";background:transparent");
            }
            else title2->setStyleSheet("background:transparent");

            if(settingFile->contains("DISPLAY/TITLE1_POS"))
            {
                pos=settingFile->value("DISPLAY/TITLE1_POS").toString().split(";");
                if(pos.size()==2)
                {
                    title1->move(pos[0].toInt(),pos[1].toInt());
                }
            }

            if(settingFile->contains("DISPLAY/TITLE2_POS"))
            {
                pos=settingFile->value("DISPLAY/TITLE2_POS").toString().split(";");
                if(pos.size()==2)
                {
                    title2->move(pos[0].toInt(),pos[1].toInt());
                }
            }




            QFont font3( "Exo 2.0", 12, QFont::Bold);
            if(settingFile->contains("DISPLAY/CHAN_FONT_SIZE"))
            {
                 font3.setPointSize(settingFile->value("DISPLAY/CHAN_FONT_SIZE").toInt());
            }




            for (int i=0;i<6;i++)
            {
                channel_id[i]=new QLabel("QString::number(i)",mainwidg);
                if(settingFile->contains("DISPLAY/CHAN"+QString::number(i+1)+"_ID"))
                {
                     channel_id[i]->setText(settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_ID").toString());
                }
                channel_title[i]=new QLabel("Voie "+QString::number(i)+": ",mainwidg);
                if(settingFile->contains("DISPLAY/CHAN"+QString::number(i+1)+"_TITLE"))
                {
                     channel_title[i]->setText(settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_TITLE").toString());
                }
                power_channel[i]= new QLabel("                ",mainwidg);
                channel_title[i]->setFont(font3);
                channel_id[i]->setFont(font3);
                power_channel[i]->setFont(font3);
                if(settingFile->contains(("DISPLAY/CHAN"+QString::number(i+1)+"_FONT_COLOR")))
                {
                    power_channel[i]->setStyleSheet("color: #"+settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_FONT_COLOR").toString()+";background:transparent");
                    channel_title[i]->setStyleSheet("color: #"+settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_FONT_COLOR").toString()+";background:transparent");
                    channel_id[i]->setStyleSheet("color: #"+settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_FONT_COLOR").toString()+";background:transparent");
                }
                if(settingFile->contains("DISPLAY/CHAN"+QString::number(i+1)+"_POS"))
                {
                    pos=settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_POS").toString().split(";");
                    if(pos.size()==2)
                    {
                       power_channel[i]->move(pos[0].toInt(),pos[1].toInt());
                    }
                }

                if(settingFile->contains("DISPLAY/CHAN"+QString::number(i+1)+"_ID_POS"))
                {
                    pos=settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_ID_POS").toString().split(";");
                    if(pos.size()==2)
                    {
                       channel_id[i]->move(pos[0].toInt(),pos[1].toInt());
                    }
                }

                if(settingFile->contains("DISPLAY/CHAN"+QString::number(i+1)+"_TITLE_POS"))
                {
                    QFontMetrics fm(font3);
                    int width=fm.width(channel_title[i]->text());

                    pos=settingFile->value("DISPLAY/CHAN"+QString::number(i+1)+"_TITLE_POS").toString().split(";");
                    if(pos.size()==2)
                    {
                       channel_title[i]->move(pos[0].toInt()-(width/2),pos[1].toInt());
                    }
                }


               // verticalLayout->addWidget(power_channel[i]);
            }


            if(serialCom->readBytesAtWithRetry(sn_display,0x01000080,4,3))
            {
                qDebug()<<"module found";
                for(int channelIndex=0;channelIndex<6;channelIndex++)
                {
                    coef_mul[channelIndex]=serialCom->getReceivedData()[2*channelIndex];
                    coef_div[channelIndex]=serialCom->getReceivedData()[(2*channelIndex)+1];
                }
            }else
            for(int channelIndex=0;channelIndex<6;channelIndex++)
            {
                coef_mul[channelIndex]=1;
                coef_div[channelIndex]=1;
            }

       /*     verticalLayout->addWidget(normal_mode);

            mainwidg->setLayout(verticalLayout);*/
            this->setCentralWidget(mainwidg);
            setWindowState(Qt::WindowFullScreen);
            connect(displayTimer,SIGNAL(timeout()),this,SLOT(refresh_display()));

            show();

            displayTimer->start(1000);
          //  return;
     //   }
    }


 //   qDebug()<<"port not open";
  //  init_window();

}

MainWindow::~MainWindow()
{   //Destructor
    delete serialCom;
    if(!display_mode)
    {
    delete commonRefreshTimer;
    delete settingFile;
    delete moduleList;
    }
}

int MainWindow::check_setting_file(QString filename)
{
    int retour=0;
    settingFile = new QSettings(filename,QSettings::IniFormat);
    if(!settingFile->contains("WINDOW_POS/MAIN_WIN_X"))
        retour=2;
    if(!settingFile->contains("HTTP_SERV/HTTP_ENABLE"))
        retour=2;
     if(!settingFile->contains("COM/COM_PORT"))
         retour=2;
     delete settingFile;
     return retour;
}

void MainWindow::addMenus()
{ //add menu bar for configurations windows
    fileMenu = menuBar()->addMenu("&File");

    QAction *quitAction = fileMenu->addAction("&Exit");
    quitAction->setShortcut(QKeySequence("Ctrl+Q"));
    quitAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/exit.png"));
    connect(quitAction, SIGNAL(triggered()), qApp, SLOT(quit()));

    configMenu = menuBar()->addMenu("&Configuration");

    QAction *connectionConfigAction = configMenu->addAction("&Connection Configuration");
    connectionConfigAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/port.png"));
   // connect(connectionConfigAction,SIGNAL(triggered()),this,SLOT(openConnectionWindow()));

    QAction *advancedConfigAction = configMenu->addAction("&Advanced Configuration");
    advancedConfigAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/tools.png"));
    connect(advancedConfigAction,SIGNAL(triggered()),this,SLOT(openAdvancedConfigWindow()));



/*
    if(mode_server)
    {
    QAction *server_http = configMenu->addAction("&Enable Http server");

    connect(server_http,SIGNAL(triggered()),this,SLOT(openHttpserver()));
    }
    else
    {*/
        QAction *relay_action = configMenu->addAction("&Relay Configuration");
        relay_action->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/radio.png"));
        connect(relay_action,SIGNAL(triggered()),this,SLOT(openRelayWindow()));
        QAction *gprsConfigAction = configMenu->addAction("&GPRS Configuration");
        gprsConfigAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/simCard.png"));
        connect(gprsConfigAction,SIGNAL(triggered()),this,SLOT(openGprsConfigWindow()));

        QAction *ethernetConfigAction = configMenu->addAction("&Ethernet Configuration");
        ethernetConfigAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/ethernet.png"));
        connect(ethernetConfigAction,SIGNAL(triggered()),this,SLOT(openEthernetConfigWindow()));
  //  }
    pauseRefreshAction = menuBar()->addAction("&Pause Refresh");
    pauseRefreshAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/play.png"));
    connect(pauseRefreshAction,SIGNAL(triggered()),this,SLOT(switchPauseRefresh()));

}

void MainWindow::addStatusIcon()
{ //create the label used as Com icon
    comStatus->move(200,22);
    comStatus->setFixedSize(250,15);
    comStatus->raise();
     comStatus->setHidden(false);
    // signal for switching state
    connect(serialCom,SIGNAL(errorCom()),this,SLOT(displayErrorOfCommunication()));
    connect(serialCom,SIGNAL(noErrorCom()),this,SLOT(displayNoErrorOfCommunication()));
 //   connect(serialCom,SIGNAL(comclose()),this,SLOT(displayComClose()));
 //  connect(serialCom,SIGNAL(comopen()),this,SLOT(com_open()));

}

//*******************
// Init Methods
//*******************

void MainWindow::tryToOpenPort()
{
    connectionDialogWindow->tryToOpenConnection();
    //Try to open serial port, launch connection window if cannot open
    /*settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    if(settingFile->contains("COM/COM_PORT")&&settingFile->contains("COM/COM_TYPE"))
    {
        qDebug()<<"File and data found";
       // if(serialCom==NULL) serialCom = new ManageSerialPort();
        qDebug()<<"type of connection : "<<settingFile->value("COM/COM_TYPE").toInt();
        QString portName=settingFile->value("COM/COM_PORT").toString();

        serialCom->open(portName,settingFile->value("COM/COM_TYPE").toInt());

        if(!serialCom->isOpen()){
            qDebug()<<"port not open";
   //         openConnectionWindow();
        }
        else //port opened properly
        {

            returnFromConnectionDialog();   //=after connection procedure

        }
    }
    else
    {
      qDebug()<<"No value on the configuration file";
     // openConnectionWindow();
    }
    delete settingFile;
    settingFile=NULL;*/
}

//*******************
// Slots
//*******************


/*
void MainWindow::openConnectionWindow()
{   //launch the connection dialog
    if(mainFrame!=NULL)
    {
        mainFrame->disableWindow();
        mainFrame->closeRightPanel();
    }
    connect_cfg_opened=true;
    comStatus->setText("<img src=""icon/unknownsignal.png""></img><font color= orange><b>COM ?</b></font>");
    if(connectionDialogWindow==NULL) connectionDialogWindow = new ConnectionDialog(serialCom);
    connect(connectionDialogWindow,SIGNAL(configurationClosed()),this,SLOT(returnFromConnectionDialog()));

    connectionDialogWindow->show();
}*/

void MainWindow::openAdvancedConfigWindow()
{   //Allow advanced mode and launch test window
    //Ask for a password + check :
    delete advConfigWindow;
    advConfigWindow=NULL;
    bool okWindow = false;

    QString password ;
    if(config_pass_ok)
    {
        password=ADVMODE_PASSWORD;
        okWindow = true;
    }
    else password = QInputDialog::getText(this,"Password","Restricted functions.<br>Please enter password.",
                                QLineEdit::Normal, QString(), &okWindow);
    if (okWindow && (password==ADVMODE_PASSWORD))   //advanced mode OK
    {
       config_pass_ok=true;
     advConfigWindow = new AdvancedConfigWindow(serialCom,moduleList);
        emit advancedUserModeEnabled();
        if(mainFrame!=NULL) mainFrame->disableWindow();
        advConfigWindow->refreshCursorPosition();
        advConfigWindow->show();
        connect(advConfigWindow,SIGNAL(closingWindow()),this,SLOT(returnFromAdvConfig()));
    }
}

void MainWindow::openGprsConfigWindow()

{   // launch gprs configuration window
    delete gprsConfigWindow;
    gprsConfigWindow=NULL;
    gprsConfigWindow = new GprsConfig(serialCom, commonRefreshTimer, moduleList);
    if(mainFrame!=NULL) mainFrame->disableWindow();
    connect(gprsConfigWindow,SIGNAL(closingWindow()),this,SLOT(returnFromGprs()));
    gprsConfigWindow->initWindow();
}

void  MainWindow::openEthernetConfigWindow()
{
    delete ethernetConfigWindow;
    ethernetConfigWindow=NULL;
    ethernetConfigWindow = new EthernetConfig(serialCom);
    if(mainFrame!=NULL) mainFrame->disableWindow();
    connect(ethernetConfigWindow,SIGNAL(closingWindow()),this,SLOT(returnFromEthernetConfigWindow()));
    ethernetConfigWindow->show();
    LastDL=serialCom->address_API;
    settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    bool ok;
    if(settingFile->contains("COM/ADDRESS_ETH"))
    {
        QString addAPI=settingFile->value("COM/ADDRESS_ETH").toString();
        serialCom->address_API=addAPI.toUInt(&ok,16);
    }
    else serialCom->address_API=0x0002; //default value
    delete settingFile;
}

void  MainWindow::openRelayWindow()
{

    delete relayWindow;
    relayWindow=NULL;
    if(mainFrame!=NULL) mainFrame->disableWindow();
    if(relayWindow==NULL) relayWindow = new frame_relay(serialCom);
    connect(relayWindow,SIGNAL(relayClosed()),this,SLOT(returnFromRelayWindow()));
    relayWindow->show();
}
/*
void MainWindow::req_ftp()
{
    ftp_req=true;
    openHttpserver();
}

void  MainWindow::openHttpserver()
{
    if(advConfigWindow!=NULL)
    advConfigWindow->deleteLater();
    advConfigWindow=NULL;
    if(connectionDialogWindow!=NULL);
    delete connectionDialogWindow;
    connectionDialogWindow=NULL;
    add_api=serialCom->address_API;
    clearTitleCentralDisplay();
    while(!ad_ok) waitFor(20);
    waitFor(200);
    if(mainFrame!=NULL)
    {
    //    switchPauseRefresh();
     //   waitFor(500);
        if(!refreshIsPaused)
        {
            switchPauseRefresh();
        }
        waitFor(200);
        delete mainFrame;

    }
    setFixedWidth(560);
    mainFrame=NULL;

    waitFor(200);
    if(simple_http!=NULL)
    {
        delete simple_http;
    }
    simple_http=NULL;


     comStatus->setHidden(true);
     menuBar()->setHidden(true);
     menuBar()->setEnabled(false);
     pauseRefreshAction->setVisible(false);



    server = new HttpDaemon(80,serialCom,ftp_req,invalid_setting_file);
     connect(server,SIGNAL(closingWindow()),this,SLOT(returnFromserver()));
#ifdef _TTY_POSIX_
    if(current_label.size()>0)
        server->change_label(current_label);
#endif
    ftp_req=false;
    setCentralWidget(server->httpconfig);
    show();

}

void  MainWindow::returnFromserver()
{

    current_label=server->current_lab;
    delete server;
    server=NULL;
    serialCom->address_API=add_api;
    simple_http =new HttpSimple(80);
    setFixedWidth(1000);
    moduleList = new vector<Module>;
    //disconnect(serialCom,SIGNAL(centralSNfound()));
    disconnect(serialCom,SIGNAL(comclose()));
    disconnect(serialCom,SIGNAL(comopen()));
    disconnect(serialCom,SIGNAL(errorCom()));
    disconnect(serialCom,SIGNAL(noErrorCom()));

    addStatusIcon();
    refreshIsPaused=true;
     menuBar()->setHidden(false);
     menuBar()->setEnabled(true);
    pauseRefreshAction->setVisible(true);
    //init refresh timer
    commonRefreshTimer = new RefreshTimer;

    commonRefreshTimer->stop();

    //init central Form
    ad_ok=false;
    mainFrame = new ManageModule(serialCom, commonRefreshTimer, moduleList);
    connect(mainFrame,SIGNAL(ad_ok()),this,SLOT(auto_d_ok()));
    connect(mainFrame,SIGNAL(eraseCentralInTitle()),this,SLOT(clearTitleCentralDisplay()));
    connect(mainFrame,SIGNAL(timeout_cfg()),this,SLOT(mouve_mouse()));
    connect(this,SIGNAL(advancedUserModeEnabled()),mainFrame,SLOT(switchToAdvancedUserMode()));
    setCentralWidget(mainFrame);
    show();
    bool ok=true;
    settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    if(settingFile->contains("COM/ADDRESS_API"))
    {
        serialCom->address_API=settingFile->value("COM/ADDRESS_API").toString().toULongLong(&ok,16);
    }
    delete settingFile;
    tryToOpenPort();
    connect(simple_http,SIGNAL(req_ftp()),this,SLOT(req_ftp()));
    connect(simple_http,SIGNAL(timeout_cfg()),this,SLOT(timeout_server()));
    connect(this,SIGNAL(timer_config_reinit()),simple_http,SLOT(reinit_timeout()));
    switchPauseRefresh();
}*/

void  MainWindow::returnFromEthernetConfigWindow()
{
//    serialCom->changeDL(QString::number(LastDL,16).toInt());    //
refresh_pause_button();
    serialCom->address_API=LastDL;
    waitFor(100);
    if(serialCom!=NULL && mainFrame!=NULL) //Security
     {
         if(!refreshIsPaused)
         {
             mainFrame->setEnabled(true);
             mainFrame->enableWindowAndStartTimerAgain();
         }
         else mainFrame->connect_timer();
     }
}

void MainWindow::returnFromAdvConfig()
{   // return to main window, after closing gprs or adv config
    if(serialCom!=NULL && mainFrame!=NULL) //Security
     {
        refresh_pause_button();
         if(!refreshIsPaused)
         {
             mainFrame->setEnabled(true);
             mainFrame->enableWindowAndStartTimerAgain();
         }
         else mainFrame->connect_timer();
     }
}

void MainWindow::returnFromGprs()
{   // return to main window, after closing gprs or adv config
    if(serialCom!=NULL && mainFrame!=NULL) //Security
     {
        refresh_pause_button();
         if(!refreshIsPaused)
         {
             mainFrame->setEnabled(true);
             mainFrame->enableWindowAndStartTimerAgain();
         }
         else mainFrame->connect_timer();
     }
}

void MainWindow::returnFromConnectionDialog()
{   // initiate connection, after closing connection dialog or after tryToOpenPort
    connect_cfg_opened=false;
    if(serialCom->isOpen())
    {
        connect(serialCom,SIGNAL(comclose()),this,SLOT(displayComClose()));
        connect(serialCom,SIGNAL(comopen()),this,SLOT(com_open()));
        mainFrame->setEnabled(true);
        mainFrame->initCentralDetection();
        if(refreshIsPaused)
            switchPauseRefresh();

    }
    else    //serial port not ready
    {
        QMessageBox::critical(this,"Device not ready","Unable to open COM Port, please check configuration.");
        close();
    }
}


void MainWindow::returnFromRelayWindow(){
    if(serialCom->isOpen())
    {
            refresh_pause_button();
        if(!refreshIsPaused)
        {
            mainFrame->setEnabled(true);
            mainFrame->enableWindowAndStartTimerAgain();
        }
        else mainFrame->connect_timer();
    }
    else    //serial port not ready
    {
        QMessageBox::critical(this,"Device not ready","Unable to open COM Port, please check configuration.");
        close();
    }
}

void MainWindow::switchPauseRefresh()
{
    if(refreshIsPaused)
    {
        //un-pause
        commonRefreshTimer->restartAfterPause();
        refreshIsPaused=false;
      /*  pauseRefreshAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/play.png"));
        pauseRefreshAction->setText("&Pause Refresh");

        //enable window
        fileMenu->setEnabled(true);
        configMenu->setEnabled(true);
        mainFrame->setEnabled(true);*/
    }
    else    //refresh not paused
    {
        //pause
        commonRefreshTimer->stop();
        refreshIsPaused=true;
       /* pauseRefreshAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/pause.png"));
        pauseRefreshAction->setText("&Refresh Again");

        //disable window
        fileMenu->setDisabled(true);
        configMenu->setDisabled(true);
        mainFrame->setDisabled(true);*/
    }
    refresh_pause_button();
}

void MainWindow::clearTitleCentralDisplay()
{   //no central, display in title
 //   setWindowTitle("MV MultiVoies - OmgaWatt");
}

void MainWindow::displayErrorOfCommunication()
{   // error of com : set red NO COM icon
    comStatus->setText("<img src=""icon/nosignal.png""></img><font color= red><b>NO COM</b></font>");
    comStatus->raise();
}

void MainWindow::displayNoErrorOfCommunication()
{   // no more error of com : set green COM icon
    if(serialCom->getTypeofconnection()==1) comStatus->setText("<img src=""icon/signal.png""></img><font color= green><b>COM OK</b></font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  RSSI : -"+QString::number(serialCom->rssi)+" dbm");
    else comStatus->setText("<img src=""icon/signal.png""></img><font color= green><b>COM OK</b></font> ");
    comStatus->raise();
}

void MainWindow::displayComClose(){
    if(connect_cfg_opened) return;
    comStatus->setText("<img src=""icon/nosignal.png""></img><font color= red><b>COM DISCONNECTED</b></font>");
    comStatus->raise();
    serialCom->close();
    qDebug()<<"COM disc";
    if(!refreshIsPaused)
        switchPauseRefresh();
    //refreshIsPaused=false;
    //switchPauseRefresh();
  //  pauseRefreshAction->setEnabled(false);
}

void MainWindow::com_open()
{
        if(connect_cfg_opened) return;
        qDebug()<<"port detect";

        refreshIsPaused=true;
        switchPauseRefresh();
        tryToOpenPort();
        serialCom->init_no_com();
        pauseRefreshAction->setEnabled(true);

}

void MainWindow::closeEvent(QCloseEvent *event)
{
    int response=QMessageBox::Yes;
 /*   if(mode_server) response=QMessageBox::warning(this,"Exit",
                                      "Are you sure you want to close the application (server will be disable until restart of application)"
                                      ,QMessageBox::Yes|QMessageBox::No,QMessageBox::No);*/
        if(response==QMessageBox::No)
        {
          event->ignore();
        }
        else
        {
         /*   if(mode_server)
            {
                if(server!=NULL)
                    delete server;
                waitFor(250);
          #ifdef _TTY_POSIX_
                LCDclear();
                LCDdrawstring_c(0,0, "  SERVER OFF");
                LCDdrawstring_c(0,10,"Please restart");
                LCDdrawstring_c(0,19,"Multivoies_V2");
                LCDdrawstring_c(0,28,"or power cycle");
                LCDdrawstring_c(0,37,"  the server");
                LCDdisplay();
          #endif
          }*/
    settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    settingFile->setValue("WINDOW_POS/MAIN_WIN_X",QVariant(QString::number(this->pos().x())));
    settingFile->setValue("WINDOW_POS/MAIN_WIN_Y",QVariant(QString::number(this->pos().y())));
    delete settingFile;
    settingFile=NULL;
    qDebug()<<"close app";

        }
}

void MainWindow::refresh_pause_button()
{
    if(refreshIsPaused)
    {
        pauseRefreshAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/pause.png"));
        pauseRefreshAction->setText("&Refresh Again");
        comStatus->setText("<img src=""icon/nosignal.png""></img><font color= red><b>PAUSE</b></font>");
        //disable window
            fileMenu->setDisabled(true);
          //  configMenu->setDisabled(true);
            mainFrame->setDisabled(true);
    }
    else
    {
        pauseRefreshAction->setIcon(QIcon(QString(DEFAULT_DIR)+"icon/play.png"));
        pauseRefreshAction->setText("&Pause Refresh");

        fileMenu->setEnabled(true);
       // configMenu->setEnabled(true);
        mainFrame->setEnabled(true);
    }
}

void MainWindow::keyPressEvent(QKeyEvent *event)
{
    if(display_mode&&(event->key() == Qt::Key_Escape))
        init_window();
    if(display_mode&&(event->key() == Qt::Key_Q))
        this->close();
}
