#include "manageserialport.h"

//***************************
// Constructor & Destructor
//***************************


ManageSerialPort::ManageSerialPort()
{   //Constructor
#ifdef _TTY_POSIX_
    pinMode(0, OUTPUT);
    pinMode(1, OUTPUT);
    pinMode(1, OUTPUT);
    digitalWrite(0, LOW);
    digitalWrite(1, LOW);
    digitalWrite(11, LOW);
#endif

    button_clicked=false;
    centralSN=ALL_CENTRAL;
    errorComCounter=0;
    baud_xstick=0;
    typeOfConnection=radio802;
    address_API=0xFFFF;
    read_serial_data=false;
    interrupt_com=false;
    currentpl=0;
    port.setQueryMode(QextSerialPort::Polling);
    flag_stop_rx=0;
  //  settingFile = NULL;
    no_com=true;
 //   settingFile = new QSettings("config.ini",QSettings::IniFormat);
    timer1=new QTimer;
    connect(timer1,SIGNAL(timeout()),this,SLOT(timeout_timer1()));



#ifndef NO_GUI
        QextSerialEnumerator* enumerator = new QextSerialEnumerator();

        enumerator->setUpNotifications();
        connect(enumerator, SIGNAL(deviceDiscovered(const QextPortInfo &)),
                   this, SLOT(onDeviceAttached(const QextPortInfo &)));
        connect(enumerator, SIGNAL(deviceRemoved(const QextPortInfo &)),
                   this, SLOT(onDeviceRemoved(const QextPortInfo &)));
#endif

}

ManageSerialPort::~ManageSerialPort()
{   //Destructor

    //Un-comment for performance debug :
    //displayRegPerf();

    if (port.isOpen()) port.close();
    qDebug()<<"Objet ManageSerialPort dtruit";
}


uint8_t ManageSerialPort::read_chan()
{
    qDebug()<<"read_chan";
    int retour_chan=0;
    QByteArray _data_to_send;
    _data_to_send[0]=0x37;
    bool rx_ok=false;
    int n_try=3;
    do
    {
    write_serial_data(_data_to_send,0);

    if(receiveFrameAPI_withADD(0xFFFF),1);
    {
        if(getAllReceivedData()[0]==0x37)
        {
            int cur_index_channel=getAllReceivedData()[1];
            if((cur_index_channel>=11) && (cur_index_channel<27))
            {
                retour_chan=cur_index_channel;
                rx_ok=true;
            }

        }
        qDebug()<<n_try;
    }
    }while((--n_try)&&!rx_ok);
    qDebug()<<"chan "<<retour_chan;
    return retour_chan;
}

//**********************
// Get Info from file
//**********************

void ManageSerialPort::setTimeoutConfig()
{   //get timeout info form ini file
    QSettings settingFile(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    timeoutBase= 60;    //default
    if(typeOfConnection==infrared) timeoutBase=30;

    if(settingFile.contains("COM_TIMEOUT/BASE")) timeoutBase=settingFile.value("COM_TIMEOUT/BASE").toInt();

    //bluetooth //TODO : check
    if(typeOfConnection==bluetooth) timeoutBase=timeoutBase*3;

    timeoutCoeffOver4=2;   //default
    if(settingFile.contains("COM_TIMEOUT/COEFF_OVER_4")) timeoutCoeffOver4=settingFile.value("COM_TIMEOUT/COEFF_OVER_4").toInt();
    bool ok=true;
    if(settingFile.contains("COM/ADDRESS_API"))
    {
        QString addAPI=settingFile.value("COM/ADDRESS_API").toString();
        address_API=addAPI.toULongLong(&ok,16);
    }
}

//***************
// Serial Port
//***************

void ManageSerialPort::close()
{   //close port
    if(port.isOpen()) port.close();
   // timer_refresh_serial->stop();
}


bool ManageSerialPort::isOpen()
{   //close port
    return port.isOpen();
   // timer_refresh_serial->stop();
}



bool ManageSerialPort::open(QString portname, int _typeOfConnection)
{   //open port specified, and init with type
    receivedChars.clear();
    if(_typeOfConnection>=0&&_typeOfConnection<7) typeOfConnection=connectionType(_typeOfConnection);
    else
    {
        qDebug()<<"error connection Type";
        typeOfConnection=radio802;
    }
    if(!baud_xstick)
    {
        setBaudrate();
    }
    else baud_xstick=0;
    //setBaudrate();  //get baudrate from type of connection

    //modify the port settings on your own
    #ifdef _TTY_POSIX_
    port.setPortName(portname);
       if(portname.contains("USB"))
        {
            if(baudrate==BAUD250000)
            {
                if (port.isOpen()) port.close();
             //   qDebug()<<"custom baudrate";
                QString setserial = "setserial";
                QStringList arguments;
                    arguments<<"-a"<<portname<<"spd_cust"<<"divisor"<<"96";
                    QProcess myProcess;
                    myProcess.start(setserial, arguments);
                if (!myProcess.waitForFinished())
                    return false;
                qDebug()<<myProcess.readAllStandardError();
                qDebug()<<myProcess.readAllStandardOutput();
            }
        }


    #else   //windows
        // /!\ For port >COM9, use name convention "\\\\.\\COM10" (supported <10)
        if(portname.startsWith("COM",Qt::CaseInsensitive)) port.setPortName("\\\\.\\"+portname);
        else port.setPortName(portname);

    #endif //_TTY_POSIX


    if(!port.open(QIODevice::ReadWrite))// | QIODevice::Unbuffered))
    {
        qDebug()<<"Error opening port !";
        return false;
    }

    //Init the serial port
    #ifdef _TTY_POSIX_
    if(portname.contains("USB"))
     {
         if(baudrate==BAUD250000)
         {
             port.setBaudRate(BAUD38400);
         }
         else port.setBaudRate(baudrate);
     }
    else port.setBaudRate(baudrate);
    #else
    port.setBaudRate(baudrate);
    #endif
   // qDebug()<<"baud"<<baudrate;
    port.setDataBits(DATA_8);   //8 bits
    port.setParity(PAR_NONE);   //no parity
    port.setStopBits(STOP_1);   //1 stop bit
    port.setFlowControl(FLOW_OFF);  //no flow control
    port.setTimeout(-1);             // TODO ? useless ?
    receptionTimeout=80;
    setTimeoutConfig();
    port.read(port.bytesAvailable());   //In order to flush port
   // timer_refresh_serial->start(1);
    if(typeOfConnection==radio868)
    {
        return update_add_api_868();
    }

    return true;
}

bool ManageSerialPort::update_add_api_868(){
    bool com_ok=false;
    QByteArray pl_to_send;
    QByteArray dh_add=read_register("SH",0);
    QByteArray dl_add=read_register("SL",0);
    pl_to_send.resize(1);
    currentpl=1;
    rssi_868=0;
    n_rssi_868=0;
    do
    {
    pl_to_send[0]=currentpl;
        write_register("PL",0,pl_to_send);
        int n_try=5;
        do
        {
            com_ok=write_register("PL",address_API,pl_to_send);
            if(com_ok)
            {
                com_ok=write_register("DH",address_API,dh_add);
                if(com_ok) com_ok=write_register("DL",address_API,dl_add);
            }

            qDebug()<<"try to reach system"<<QString::number(address_API,16)<<"with PL :"<<currentpl<<"try nr :"<<2-n_try<<"result"<<com_ok;
        }while((--n_try)&&!com_ok);
        currentpl+=2;
    }while((currentpl<4)&&!com_ok);
    currentpl-=2;
    if(!com_ok)
    {
        currentpl=1;
        qDebug()<<"cannot reach system "<<QString::number(address_API,16);
        return false;
    }
    else
    {
        if(currentpl>3) currentpl=3;
        qDebug()<<"system"<<QString::number(address_API,16)<<"com ok, PL = "<<(currentpl);
    }
    return true;
}

void ManageSerialPort::setBaudrate()
{   //select baudrate from connection type

 //   QSettings settingFile("config.ini",QSettings::IniFormat);
    int br;
    QSettings settingFile(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    if(typeOfConnection==radio802||typeOfConnection==wirelesslog)
    {
        if(settingFile.contains("COM/BR_RADIO"))
        {
            br=settingFile.value("COM/BR_RADIO").toInt();
           // qDebug()<<"baudrate radio"<<br;
            if(br==111111) baudrate=BAUD111111;
            if(br==250000) baudrate=BAUD250000;
            if(br==1000000) baudrate=BAUD1000000;
        }
        else
        baudrate=BAUD250000;

    }
    else
    {
        if(typeOfConnection==wired)
             baudrate=BAUD500000;
        else baudrate=BAUD115200;
    }
}

void ManageSerialPort::setBaud111()
{   //select baudrate from connection type
    baud_xstick=true;
    baudrate=BAUD111111;
  //  qDebug()<<"baudrate"<<baudrate;
}

bool ManageSerialPort::test_xstick()
{   //return current Destination of XStick, by AT commands

    // init AT mode
    QByteArray arrayToSend;
    arrayToSend.resize(3);
    arrayToSend[0] = 0x2b; //+
    arrayToSend[1] = 0x2b; //+
    arrayToSend[2] = 0x2b; //+
    waitFor(50);
    sendQByteArray(arrayToSend);
    waitFor(50);
    QByteArray receivedChars;
    if(port.bytesAvailable()>0)
        receivedChars=port.read(port.bytesAvailable());
    else
    {
        qDebug()<<"no bytes received from +++";
        return false;
    }
    if(!receivedChars.startsWith(0x4F)) //test received
    {
        qDebug()<<"not responding OK";
        return false;
    }
    waitFor(100);
    return true;
}



bool ManageSerialPort::config_xstick()  // Value en BCD
{
    QByteArray arrayToSend;
    QByteArray receivedChars;
    //Send ATAP1
    arrayToSend.clear();
    arrayToSend.push_back(0x41); //A
    arrayToSend.push_back(0x54); //T
    arrayToSend.push_back(0x41); //A
    arrayToSend.push_back(0x50); //P
    arrayToSend.push_back(0x31); //1
    arrayToSend.push_back(0x0D);
    if(!sendQByteArray(arrayToSend))
    {
        qDebug()<<"error sending  AT";
        return false;
    }
    waitFor(50);

    receivedChars.clear();
    if(port.bytesAvailable()>0)
        receivedChars=port.read(port.bytesAvailable());
    else
    {
        qDebug()<<"no bytes received from AT";
        return false;
    }
    if(!receivedChars.startsWith(0x4F))
    {
        qDebug()<<"not responding OK";
        return false;
    }
    waitFor(100);

    //Send ATBD3D090
    arrayToSend.clear();
    arrayToSend.push_back(0x41); //A
    arrayToSend.push_back(0x54); //T
    arrayToSend.push_back(0x42); //B
    arrayToSend.push_back(0x44); //D
    arrayToSend.push_back(0x33); //3
    arrayToSend.push_back(0x44); //D
    arrayToSend.push_back(0x30); //0
    arrayToSend.push_back(0x39); //9
    arrayToSend.push_back(0x30); //0
    arrayToSend.push_back(0x0D);
    if(!sendQByteArray(arrayToSend))
    {
        qDebug()<<"error sending  AT";
        return false;
    }
    waitFor(50);

    receivedChars.clear();
    if(port.bytesAvailable()>0)
        receivedChars=port.read(port.bytesAvailable());
    else
    {
        qDebug()<<"no bytes received from AT";
        return false;
    }
    if(!receivedChars.startsWith(0x4F))
    {
        qDebug()<<"not responding OK";
        return false;
    }
    waitFor(100);


    //ATWR,CN   //exit AT mode and save config
    arrayToSend.clear();
    arrayToSend.push_back(0x41); //A
    arrayToSend.push_back(0x54); //T
    arrayToSend.push_back(0x57); //W
    arrayToSend.push_back(0x52); //R
    arrayToSend.push_back(0x2C); //,
    arrayToSend.push_back(0x43); //C
    arrayToSend.push_back(0x4E); //N
    arrayToSend.push_back(0x0D);

    if(!sendQByteArray(arrayToSend))
    {
        qDebug()<<"error sending ATWR,CN";
        return false;
    }
    waitFor(100);
    //Check response
    receivedChars.clear();
    receivedChars=port.read(port.bytesAvailable());
    if(receivedChars.size()<6)  //6 char = OK OK
    {
        qDebug()<<"error OK from ATWR,CN";
        return false;
    }
    return true;
}

//**********************
//  Getters & Setters methods
//**********************

uchar *ManageSerialPort::getReceivedData() {    // return the data read
    return receptionFrame.getData();

}
uchar *ManageSerialPort::getAllReceivedData(){
    return receptionFrame.getAllData();
}

int ManageSerialPort::getReceivedDataLength() { //return length of data read
    return receptionFrame.getDataLength();
}

int ManageSerialPort::getReceivedLength() { //return length of data read
    return receptionFrame.getLength();
}



//Central
uint32 ManageSerialPort::getCentralSN(){    //return central SN
    return centralSN;
}

QString ManageSerialPort::getCentralName(){ //return central name
    return QString::fromStdString(centralName);
}

bool ManageSerialPort::setModuleName(uint32 _serialNb, uint32 _address, QString _newName)
{
    //send a new name to a module / sensor
    bool ok=true;
    uchar charToSend;
    string newNameString=_newName.toStdString();
    uint32 index=0;
    uint8_t nb_retry=MAX_SUCCESSIVE_ERROR_COM;
    while(index<newNameString.size()&&index<16&&--nb_retry)
    {
        charToSend=uchar(newNameString.at(index));
        ok = ok && writeByteAtWithRetry(_serialNb,_address+index,charToSend,5);
        if(!ok) qDebug()<<"erreur send char :"<<charToSend;
        index++;
    }
    ok = ok && writeByteAtWithRetry(_serialNb,_address+index,0x00,3);   //add a 0x00 to end string

    if(_serialNb==centralSN)
        centralDetection();

    return ok;
}


//**********************
//  Read/Write methods
//**********************

bool ManageSerialPort::readBytesAt(uint32 _serialNb, uint32 _address, uchar _nbPacketsToRead)
{
    port.readAll();
    receivedChars.clear();
    //Read [_nbPacketsToRead]x8bytes from [_address] of module [_serialNb]
    //Send asking and receive response
    transmissionFrame.address_API=address_API;
    transmissionFrame.typeOfConnection=typeOfConnection;
    receptionFrame.erase();

    // set timeout from length
    if(_nbPacketsToRead<9)
        receptionTimeout=timeoutBase*(0.75+_nbPacketsToRead/4);
    else receptionTimeout=timeoutBase;
    if(typeOfConnection==radio868) receptionTimeout=timeoutBase*5;


    if(!sendReadFrame(_serialNb,_address,_nbPacketsToRead))
        {
            qDebug()<<"sending error";
            return false;
        }
    //Receive
    if(!receiveFrame())
    {
        qDebug()<<"receiveFrame error (readBytesAt)";
        return false;
    }
    //process error
    int error=receptionFrame.validateReceived(_serialNb,_address,_nbPacketsToRead);
    if(error!=0)
    {
        qDebug()<<"read validation error nb "<<error;
        return false;
    }
    //if no error, reset error com
    return true;
}

bool ManageSerialPort::writeByteAtS(uint32 _serialNb, uint32 _address, uchar _dataToWrite)
{
    port.readAll();
    receivedChars.clear();
    //Write [_dataToWrite] byte to module [_serialNb] at [_address].
    //Send command and check received response
    transmissionFrame.address_API=address_API;
    transmissionFrame.typeOfConnection=typeOfConnection;
    receptionFrame.erase();
    receptionTimeout=timeoutBase*2;
    if(typeOfConnection==radio868) receptionTimeout=timeoutBase*15;

    //send

    if(!sendWriteFrameS(_serialNb,_address,_dataToWrite))
    {
        qDebug()<<"sending error";
        return false;
    }

    if(!receiveFrame())
    {
       // qDebug()<<"receiveFrame error (readBytesAt)";
        return false;
   }

    //check
    int error=receptionFrame.validateReceived(_serialNb,_address,1);
    if(receptionFrame.getData()[0])
    {

        error=9;
    }
    switch(error)
    {
    case 0: //no error
        break;

    case 9:
        if((typeOfConnection==infrared)&&(_serialNb&0x01FFFFFF)) // si central et com irda --> retour vide normal
        {
        }
        else
        {
            qDebug()<<"write error : validation byte != 0";
            return false;
        }
        break;

    default:
       // qDebug()<<"write validation : error nb "<<error;
        return false;
        break;
    }

    return true;
}


bool ManageSerialPort::writeByteAt(uint32 _serialNb, uint32 _address, uchar _dataToWrite)
{
    port.readAll();
    receivedChars.clear();
    //Write [_dataToWrite] byte to module [_serialNb] at [_address].
    //Send command and check received response
    transmissionFrame.address_API=address_API;
    transmissionFrame.typeOfConnection=typeOfConnection;
    receptionFrame.erase();
    receptionTimeout=timeoutBase*2;
    if(typeOfConnection==radio868) receptionTimeout=timeoutBase*15;

    //send

    if(!sendWriteFrame(_serialNb,_address,_dataToWrite))
    {
        qDebug()<<"sending error";
        return false;
    }

    if(!receiveFrame())
    {
       // qDebug()<<"receiveFrame error (readBytesAt)";
        return false;
   }

    //check
    int error=receptionFrame.validateReceived(_serialNb,_address,1);
    if(receptionFrame.getData()[0])
    {

        error=9;
    }
    switch(error)
    {
    case 0: //no error
        break;

    case 9:
        if((typeOfConnection==infrared)&&(_serialNb>0x01000000)) // si central et com irda --> retour vide normal
        {
        }
        else
        {
            qDebug()<<"write error : validation byte != 0";
            return false;
        }
        break;

    default:
       // qDebug()<<"write validation : error nb "<<error;
        return false;
        break;
    }

    return true;
}


bool ManageSerialPort::write4BytesAt(uint32 _serialNb, uint32 _address, uchar _dataToWrite[4])
{
    port.readAll();
    receivedChars.clear();
    //Write [_dataToWrite] byte to module [_serialNb] at [_address].
    //Send command and check received response
    transmissionFrame.address_API=address_API;
    transmissionFrame.typeOfConnection=typeOfConnection;
    receptionFrame.erase();
    receptionTimeout=timeoutBase*2;

    //send

    if(!sendWriteFrame4(_serialNb,_address,_dataToWrite))
    {
        qDebug()<<"sending error API";
        return false;
    }

    if(!receiveFrame())
    {
       // qDebug()<<"receiveFrame error (readBytesAt)";
        return false;
    }

    //check
    int error=receptionFrame.validateReceived(_serialNb,_address,1);
    if(receptionFrame.getData()[0])
    {
        qDebug()<<"write error : validation byte != 0";
        error=9;
    }
    if(error!=0)
    {
        qDebug()<<"write validation : error nb "<<error;
        return false;
    }

    return true;
}


bool ManageSerialPort::readBytesAtWithRetry(uint32 _serialNb, uint32 _address, uchar _nbPacketsToRead, uint32 nbOfRetry)
{

    //Read [_nbPacketsToRead]x8bytes from [_address] of module [_serialNb] with [nbOfRetry] retries (using readBytesAt)


        bool ok=true;
        for(uint32 retryIndex=0;retryIndex<nbOfRetry;retryIndex++)
        {
            ok=readBytesAt(_serialNb, _address, _nbPacketsToRead);
            if(ok)
            {
                if(typeOfConnection==radio868)
                {
                    QByteArray rrsi_array;
                    rrsi_array.resize(1);
                    rrsi_array=read_register("DB",0);
                    rssi_868+=rrsi_array.at(0);
                    n_rssi_868++;
                }
               // qDebug()<<"no error com";
                emit noErrorCom();
                return true;
            }
            //else qDebug()<<"readBytes, retry nb "<<retryIndex<<" failed";

            if(typeOfConnection==radio868)
            {
                QByteArray pl_to_send;
                pl_to_send.resize(1);
                if(currentpl==1) currentpl=3;
                else currentpl=1;
                pl_to_send[0]=currentpl;
                write_register("PL",0,pl_to_send); //ecriture PL en local
                int n_try=2;
                do
                {
                    ok=write_register("PL",address_API,pl_to_send);//ecriture PL distant
                }while(!ok&&(--n_try));
                qDebug()<<"test with PL"<<currentpl<<" result"<<ok<<"nb of try :"<<(2-n_try);
                qDebug()<<QString::number(read_register("PL",address_API).at(0),16);
            }

        }

        if(!ok)
        {

             emit errorCom();
            return false;
        }

       // qDebug()<<"no error com";
        emit noErrorCom();
        return true;
}


bool ManageSerialPort::writeByteAtWithRetry(uint32 _serialNb, uint32 _address, uchar _dataToWrite, uint32 nbOfRetry)
{
    //Write [_dataToWrite] byte to module [_serialNb] at [_address], with [nbOfRetry] retries
        bool ok=true;
        for(uint32 retryIndex=0;retryIndex<nbOfRetry;retryIndex++)
        {
            ok=writeByteAt( _serialNb, _address, _dataToWrite);
            if(ok)
            {
                if(typeOfConnection==radio868)
                {
                QByteArray rrsi_array;
                rrsi_array.resize(1);
                rrsi_array=read_register("DB",0);
                rssi_868+=rrsi_array.at(0);
                n_rssi_868++;
                }
             //  qDebug()<<"no error com";
                emit noErrorCom();
                return true;
            }
            else qDebug()<<"writeByte, retry nb "<<retryIndex<<" failed";
            if(typeOfConnection==radio868)
            {
                QByteArray pl_to_send;
                pl_to_send.resize(1);
                if(currentpl==1) currentpl=3;
                else currentpl=1;
                pl_to_send[0]=currentpl;
                write_register("PL",0,pl_to_send); //ecriture PL en local
                int n_try=2;
                do
                {
                ok=write_register("PL",address_API,pl_to_send);//ecriture PL distant
                }while(!ok&&(--n_try));
                qDebug()<<"test with PL"<<currentpl<<" result"<<ok<<"nb of try :"<<(2-n_try);
            }
        }
        if(!ok)
        {
           /* if(!no_com)
            {
                qDebug()<<"error com emitted";
                emit errorCom();    //Display error com but don't block directly
                no_com=true;
            }*/
            emit errorCom();
            return false;
        }
        emit noErrorCom();
        return true;
}



bool ManageSerialPort::writeByteAtWithRetryS(uint32 _serialNb, uint32 _address, uchar _dataToWrite, uint32 nbOfRetry)
{
    //Write [_dataToWrite] byte to module [_serialNb] at [_address], with [nbOfRetry] retries
        bool ok=true;
        for(uint32 retryIndex=0;retryIndex<nbOfRetry;retryIndex++)
        {
            ok=writeByteAtS( _serialNb, _address, _dataToWrite);
            if(ok)
            {
             //  qDebug()<<"no error com";
                emit noErrorCom();
                return true;
            }
            else qDebug()<<"writeByte, retry nb "<<retryIndex<<" failed";
        }
        if(!ok)
        {
           /* if(!no_com)
            {
                qDebug()<<"error com emitted";
                emit errorCom();    //Display error com but don't block directly
                no_com=true;
            }*/
            emit errorCom();
            return false;
        }
        emit noErrorCom();
        return true;
}


bool ManageSerialPort::write4BytesAtWithRetry(uint32 _serialNb, uint32 _address, uchar _dataToWrite[4], uint32 nbOfRetry)
{
    //Write [_dataToWrite] byte to module [_serialNb] at [_address], with [nbOfRetry] retries
        bool ok=true;
        for(uint32 retryIndex=0;retryIndex<nbOfRetry;retryIndex++)
        {
            ok=write4BytesAt( _serialNb, _address, _dataToWrite);
            if(ok) return true;
            else qDebug()<<"writeByte, retry nb "<<retryIndex<<" failed";
        }
        if(!ok)
        {
          /*  if(!no_com) {
                qDebug()<<"error com emitted";
                emit errorCom();    //Display error com but don't block directly
                no_com=true;
            }*/
            emit errorCom();
            return false;
        }
        emit noErrorCom();
        return true;
}


bool ManageSerialPort::writeByteDontCheckResponse(uint32 _serialNb, uint32 _address, uchar _dataToWrite)
{
    bool ok;
    //Write [_dataToWrite] byte to module [_serialNb] at [_address], by only sending order, do not check if done

    ok=sendWriteFrame(_serialNb,_address,_dataToWrite);
   // qDebug()<<clock()<<"writeByteDontChkRspse, wait : "<<timeoutBase*2<<"ms";
    waitFor(timeoutBase*2);    // In order to be sure frame is not overwrited
   // qDebug()<<clock()<<"writeByteDontChkRspse, wait finished";
    return ok;
}

bool ManageSerialPort::sendFrame()
{
    //Send transmissionFrame to serial port
 QByteArray arrayToSend;
 arrayToSend = QByteArray::fromRawData(reinterpret_cast<const char*>(transmissionFrame.getFrame()), transmissionFrame.getLength());
//debugDisplayQByteArray(arrayToSend);
if(typeOfConnection==infrared) {    //insert FF FF FF
        for(int i=0; i<3; i++) arrayToSend.insert(0,0xFF);
    }
    return sendQByteArray(arrayToSend);
}

bool ManageSerialPort::sendQByteArray(QByteArray _arrayToSend)
{
    //Send [_arrayToSend] to serial port
    if(!port.isOpen())
    {
        qDebug()<<"/!\\ sendFrame : Port not open !";
        return false;
    }
    //port.read(port.bytesAvailable());   //In order to flush port
    qint64 returnValue=port.write(_arrayToSend);

    if(returnValue<0)
    {
        qDebug()<<"/!\\ Error sending value";
        return false;
    }
    return true;
}

bool ManageSerialPort::sendframe_wdataack(uint32_t serialNumber, uchar function, uchar param[],uint16_t add_api){
    transmissionFrame.makeframe_wdata(serialNumber,function,param,add_api);
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }

    return true;
}

bool ManageSerialPort::sendframe_wdata(uint32_t serialNumber, uchar function, uchar param[],uint16_t sn_relay){
    transmissionFrame.makeframe_wdata(serialNumber,function,param,sn_relay);
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }
    return true;
}
/*
bool ManageSerialPort::sendframe_calibrate(uint32_t serialNumber, uchar function, uchar param[],uint16_t add_api){
    transmissionFrame.makeframe_calibrate(serialNumber,function,param,add_api);
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }
    return true;
}
*/

bool ManageSerialPort::sendReadFrame(uint32 _serialNumber, uint32 _address, uchar _nbToRead)
{
    // Make a reading frame and send it
    transmissionFrame.makeReadFrame(_serialNumber, _address, _nbToRead);
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }
    return true;
}

bool ManageSerialPort::sendWriteFrame(uint32 _serialNumber, uint32 _address, uchar _dataToWrite)
{
    // Make a writing frame and send it
    transmissionFrame.makeWriteFrame(_serialNumber, _address, _dataToWrite);
 //   transmissionFrame.display();
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }
    return true;
}

bool ManageSerialPort::sendWriteFrameS(uint32 _serialNumber, uint32 _address, uchar _dataToWrite)
{
    // Make a writing frame and send it
    transmissionFrame.makeWriteFrameS(_serialNumber, _address, _dataToWrite);
 //   transmissionFrame.display();
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }
    return true;
}

bool ManageSerialPort::sendWriteFrame4(uint32 _serialNumber, uint32 _address, uchar _dataToWrite[4])
{
    // Make a writing frame and send it
    transmissionFrame.makeWriteFrame4(_serialNumber, _address, _dataToWrite);
    if(!sendFrame())
    {
        qDebug()<<"/!\\ Emission problem";
        return false;
    }
    return true;
}

int ManageSerialPort::readframe_wmodule(uint16_t add_api,uint16_t timeout)
{
    int return_code=0;
    int error=0;

    if(!receiveFrameAPI_withADD(add_api,timeout))
        return_code=0;
    else
    {
        switch(getAllReceivedData()[0])
        {
        case 0xC0: //trame param d'un capteur
            sensor_receive_date_time=current_time;
            error=receptionFrame.validateReceivedwdata(); //verification CRC
            if(error!=0)
            {
                qDebug()<<"write validation auto : error nb "<<error;
                return_code=0;
                break;
            }
            return_code=3;
            break;

        case 0x31: //trame avec liste rssi des capteurs
            return_code=4;
            break;

        case 0x32: //trame d'un relais avec liste ack des capteurs
            return_code=5;
            break;

         case 0x45: //page dl
            if((getReceivedLength()==1057+5)||(getReceivedLength()==1056+5))
                return_code=1;
            else if((getReceivedLength()==529+5)||(getReceivedLength()==528+5))
                return_code=2;
            else return_code=0;
            break;

        default:
            return_code=0;
            break;
        }
    }
    return return_code;
}

bool ManageSerialPort::receiveFrame()
{
    switch(typeOfConnection)
    {
        case radio802:
        case radio868:
            return receiveFrameAPI_withADD(address_API);
            break;
        default:
            return receiveFrame_std();
    }
}

bool ManageSerialPort::receiveFrame_std()
{
    //Wait for response frame and check if correct
    bool incompleteFrame = true;
    qint64 numBytesAvailable = 0;
    bool startCharEncountered = false;
    QByteArray receivedFrameChars;      // Chars which are in the frame (between C0 and C1, included)
    QByteArray receivedChars;
    bool timeoutExpired= false;
    flag_timeout_timer1=false;
    timer1->start(receptionTimeout);
    int n=20000;
    //wait because response may not arrive directly
//    waitFor(1);

    do  //reading retry loop (to : not incompleteFrame or timeoutExpired)
    {
        numBytesAvailable=port.bytesAvailable();
        if(numBytesAvailable>0)
        {
            receivedChars.clear();
            receivedChars=port.read(numBytesAvailable);

            if(receivedChars.size()<=0)
            {
                qDebug()<<"/!\\ error in number of bytes read";
                break;
            }
            for(int receivedBytesCursor=0; receivedBytesCursor<receivedChars.length();receivedBytesCursor++)
            {
                if(startCharEncountered)    //start already done, rest of frame
                {
                    receivedFrameChars.append(receivedChars.at(receivedBytesCursor));
                    if(receivedChars.at(receivedBytesCursor)==char(END_OF_FRAME))
                    {
                        incompleteFrame=false;
                        break;
                    }
                    if(receivedChars.at(receivedBytesCursor)==char(START_OF_FRAME))
                    {
                        receivedFrameChars.clear();
                        receivedFrameChars.append(char(START_OF_FRAME));
                    }
                }
                else    //not startCharEncountered, looking for startChar
                {
                    if(receivedChars.at(receivedBytesCursor)==char(START_OF_FRAME))
                    {
//                        qDebug()<<"START_OF_FRAME !";
                        receivedFrameChars.append(char(START_OF_FRAME));
                        startCharEncountered=true;
                    }
                }
            }// end of for (decoding receive loop)
        }// end of if Bytes Availables

        //process timeout
        if(!--n)
        {
            n=20000;
            refresh_events();
        }

        if(!flag_timeout_timer1 && incompleteFrame) waitForUs(10);   //TODO : change if too long
    } while(incompleteFrame && !flag_timeout_timer1);// end of while


//    qDebug()<<">>> Reception complete expire in : "<<long((clock()-timeStartingReception)*1000/CLOCKS_PER_SEC)<<"ms";



    //Debug for timeout :
    if(incompleteFrame || flag_timeout_timer1)
    {
       /* if(receivedFrameChars.size()>0)
        {
            QString debugLine = "Timeout, display receivedFrameChars (l="+QString::number(receivedFrameChars.size())+") : ";
            for(int i=0; i<receivedFrameChars.size(); i++)
            {
                debugLine += QString::number(uchar(receivedFrameChars.at(i)),16).rightJustified(2,'0')+" ";
            }
            debugLine+="\r\n";
            QByteArray readall=port.readAll();
            for(int i=0; i<readall.size(); i++)
            {
                debugLine += QString::number(uchar(readall.at(i)),16).rightJustified(2,'0')+" ";
            }
            qDebug()<<debugLine<<numBytesAvailable;
        }
        else qDebug()<<"display receivedFrameChars : empty";*/
    }

    //Set reception frame with received chars :
    receptionFrame.erase();
    //receptionFrame.display();
    if(receivedFrameChars.length()==0||timeoutExpired||incompleteFrame)
        return false;
    else
    {
        receptionFrame.changeFrame(receivedFrameChars.data(),receivedFrameChars.length());
        return true;
    }

}

bool ManageSerialPort::receiveFrameAPI_withADD(uint64_t add_api)
{
    return receiveFrameAPI_withADD(add_api,receptionTimeout);
}


bool ManageSerialPort::receiveFrameAPI_withADD(uint64_t add_api, uint16_t timeout)
{
    receptionFrame.erase();
    QByteArray receivedFrameChars=receive_data_API(add_api,timeout);
    if(!receivedFrameChars.length())
    {
        return false;
    }
    else
    {
        receptionFrame.changeFrame(receivedFrameChars.data(),receivedFrameChars.length());
        return true;
    }
}


QByteArray ManageSerialPort::receive_data_API(uint64_t add_api)
{
    return receive_data_API(add_api,receptionTimeout);
}

QByteArray ManageSerialPort::receive_data_API(uint64_t add_api, uint16_t timeout)
{
    //Wait for response frame and check if correct
    bool incompleteFrame = true;
    qint64 numBytesAvailable = 0;
    bool startCharEncountered = false;

    QByteArray receivedFrameChars;  // chars sans la couche API (7E | LENGTH | HEADER |[receivedFrameChars]| CS)
    QByteArray receivedCharsAPI;

    uint16_t pointeur_data_api=0;
    uint16_t checksum=0;
    uint16_t length_data=0;
    receivedFrameChars.clear();
    receivedCharsAPI.clear();
    int receivedbufferCursor=0;
    timer1->stop();
    flag_timeout_timer1=false;
    timer1->start(timeout);
    rx_source_address=0;
    bool error_frame;

    do  //reading retry loop (to : not incompleteFrame or timeoutExpired)
    {
        error_frame=false;
        numBytesAvailable=port.bytesAvailable();

        if(numBytesAvailable>0)
        {
            receivedChars.append(port.read(numBytesAvailable));
        }
        if(receivedChars.size()<0)
        {
            qDebug()<<"/!\\ error in number of bytes read";
            error_frame=true;
            break;
        }

        while(receivedChars.length()>receivedbufferCursor)
        {
            if(startCharEncountered)    //start already done, rest of frame
            {
                receivedCharsAPI.append(receivedChars.at(receivedbufferCursor));
                if( pointeur_data_api==2)
                {
                    hi(length_data)=receivedCharsAPI.at(1);
                    lo(length_data)=receivedCharsAPI.at(2);
                    if(!length_data||(length_data>1100))
                    {
                       qDebug()<<"Error : frame size > 1100 or 0 ";
                       debugDisplayQByteArray(receivedCharsAPI);
                       receivedCharsAPI.clear();
                       length_data=0;
                       startCharEncountered=false;
                       error_frame=true;
#ifdef _TTY_POSIX_
    digitalWrite(1, HIGH);
#endif
                       receivedChars.remove(0,receivedbufferCursor+1);
                       receivedbufferCursor=0;
#ifdef _TTY_POSIX_
    digitalWrite(1, LOW);
#endif
                       break;
                    }

                }
                if((pointeur_data_api>2)&&(pointeur_data_api<(length_data+3))) checksum+=receivedCharsAPI.at(pointeur_data_api); //compute checksum

                if(pointeur_data_api==3)
                {
                     if((receivedCharsAPI.at(3)!=char(0x90))&&(receivedCharsAPI.at(3)!=char(0x81)))
                     {
                         qDebug()<<"Error cmd != 0x90 or 0x81";
                         receivedCharsAPI.clear();
                         length_data=0;
                         startCharEncountered=false;
                         receivedChars.remove(0,receivedbufferCursor+1);
                         receivedbufferCursor=0;
                         error_frame=true;
                         break;
                     }
                }

                if((pointeur_data_api==(length_data+3))&&(pointeur_data_api>2)) //fin de trame api
                {
                    if(receivedCharsAPI.at(pointeur_data_api)==char(0x00FF-(checksum&0x00FF))) //check checksum
                    {

                            if(receivedCharsAPI.at(3)==char(0x90))
                            {

                                uint16_t add_api_rx;
                                hi(add_api_rx)=(uint8_t)receivedCharsAPI.at(10);
                                lo(add_api_rx)=(uint8_t)receivedCharsAPI.at(11);
                                if(((add_api&0xFFFF)!=0xFFFF)&&((add_api&0xFFFF)!=add_api_rx))
                                {
                                    qDebug()<<"error address, frame address : "<<QString::number(add_api_rx,16)<<" , address requested : "<<QString::number(add_api,16);
                                    length_data=0;
                                    receivedCharsAPI.clear();
                                    startCharEncountered=false;
                                    receivedChars.remove(0,receivedbufferCursor+1);
                                    receivedbufferCursor=0;
                                    error_frame=true;
                                    break; //check address_api
                                }
                                else
                                {
                                    incompleteFrame=false;
                                    rssi=receivedCharsAPI.at(12);
                                    receivedFrameChars.append(receivedCharsAPI.right(receivedCharsAPI.length()-15));
                                    receivedFrameChars.remove(receivedFrameChars.length()-1,1); //on enlve le checksum
                                    receivedChars.remove(0,receivedbufferCursor+1);
                                    receivedbufferCursor=0;
                                    break;
                                }

                            }
                            else if(receivedCharsAPI.at(3)==char(0x81))
                            {
                                    uint16_t add_api_rx;
                                    hi(add_api_rx)=(uint8_t)receivedCharsAPI.at(4);
                                    lo(add_api_rx)=(uint8_t)receivedCharsAPI.at(5);
                                    if(((uint16_t)(add_api&0xFFFF)!=0xFFFF)&&((uint16_t)(add_api&0xFFFF)!=add_api_rx))
                                    {
                                        qDebug()<<"error address, frame address : "<<QString::number(add_api_rx,16)<<" , address requested : "<<QString::number(add_api,16);
                                        receivedCharsAPI.clear();
                                        length_data=0;
                                        startCharEncountered=false;
                                        receivedChars.remove(0,receivedbufferCursor+1);
                                        receivedbufferCursor=0;
                                        error_frame=true;
                                        break; //check address_api
                                    }
                                    else
                                    {
                                        incompleteFrame=false;
                                        rx_source_address=add_api_rx;
                                        rssi=receivedCharsAPI.at(6);
                                        receivedFrameChars.append(receivedCharsAPI.right(receivedCharsAPI.length()-8));
                                        receivedFrameChars.remove(receivedFrameChars.length()-1,1);
#ifdef _TTY_POSIX_
    digitalWrite(1, HIGH);
#endif
                                        receivedChars.remove(0,receivedbufferCursor+1);
                                        receivedbufferCursor=0;
#ifdef _TTY_POSIX_
    digitalWrite(1, LOW);
#endif
                                        break;
                                    }
                            }
                    }
                    else
                    {

                        qDebug()<<"bad checksum"<<QString::number((uchar)receivedCharsAPI.at(pointeur_data_api),16)<<QString::number((uchar)(0x00FF-(checksum&0x00FF)),16);
                        length_data=0;
                        debugDisplayQByteArray(receivedCharsAPI);
                        debugDisplayQByteArray(receivedChars);
                        receivedCharsAPI.clear();
                        startCharEncountered=false;
                        receivedChars.remove(0,receivedbufferCursor+1);
                        receivedbufferCursor=0;
                        error_frame=true;
                        break; //bad checksum
                    }
                }
                pointeur_data_api++;

            }
            else    //not startCharEncountered, looking for startChar
            {
                if(receivedChars.at(receivedbufferCursor)==char(START_OF_FRAME_API))
                {
                    startCharEncountered=true;
                    receivedCharsAPI.append(receivedChars.at(receivedbufferCursor));
                    pointeur_data_api=1;
                }
            }
            receivedbufferCursor++;
        }// end of while (decoding receive loop)

        if(!error_frame)
        {
            refresh_events();
            if(!flag_timeout_timer1 && incompleteFrame && !numBytesAvailable)
            {
               waitFor(1); //attente 1ms, evite la saturation du proc
            }
        }

    }while(incompleteFrame && !flag_timeout_timer1);// end of while
    timer1->stop();
#ifdef _TTY_POSIX_
    digitalWrite(1, LOW);
#endif
    if(receivedCharsAPI.size()>0)
    {
        if(flag_timeout_timer1||incompleteFrame)
        {
            qDebug()<<"incomplete frame,timeout"<<flag_timeout_timer1<<"start:"<<startCharEncountered<<"pointer:"<<pointeur_data_api;

            debugDisplayQByteArray(receivedCharsAPI);
        }
     //   else qDebug()<<"complete frame";
    //    debugDisplayQByteArray(receivedCharsAPI);
    }


    return  receivedFrameChars;
}



//********************
// Central ID
//********************
bool ManageSerialPort::centralDetection()
{

    //detect the central (ask for SN + name)
    bool ok=readBytesAtWithRetry(ALL_CENTRAL,0x01000000,1,4);
    if(!ok)
    {
        qDebug()<<"error of Central SN reading";
        errorComCounter=0; //to retry next time;
        emit errorCom();    //Display error com but don't block directly
        return false;
    }

    centralSN=peekUint32FromUcharTabLittleEndian(receptionFrame.getData(),0);

    ok=ok & readBytesAtWithRetry(centralSN,0x01000020,2,4);
    if(!ok)
    {
        qDebug()<<"error of Central name reading";
        errorComCounter=0;
        emit errorCom();    //Display error com but don't block directly
        return false;
    }
    // set name
    for(uint32 i =0; i<16;i++)
    {
        if(receptionFrame.getData()[i]!=(0x00)&&receptionFrame.getData()[i]!=(0xFF))
            centralName[i]=receptionFrame.getData()[i];
        else
        {
            centralName[i]='\0'; //clear next char
            break;
        }
    }
    centralName[16]='\0';
    emit noErrorCom();    //Display error com but don't block directly
    return true;
}

QByteArray ManageSerialPort::ReadEthernetModuleRam(uint16 Address,uint32 nb)
{
    QByteArray arrayToSend;
    QByteArray receivedChars;
    arrayToSend.resize(4);
    arrayToSend[0] = 0x08;
    arrayToSend[1] = Address & 0xff;
    arrayToSend[2] = Address >> 8;
    arrayToSend[3] = nb;
    //transmissionFrame.makeAPI3(arrayToSend,address_API);
    bool ok=false;
    bool ok1,ok2=false;
    int i=2;
    do
    {
        if(!sendFrame())
        {
            qDebug()<<"/!\\ Emission problem";
            ok1= false;
        }
        else ok1=true;

        receivedChars=receive_data_API(address_API);
        if(!receivedChars.length())
        {
            qDebug()<<"/!\\ Reception problem r_eth_ram";
            ok2= false;
        }
        else ok2=true;
        ok=ok2&ok1;
        i--;
    }while(!ok&&(i>=0));

    return receivedChars;
}

QByteArray ManageSerialPort::ReadEthernetModuleFlash(uint32 Address,uint32 nb)
{
    QByteArray arrayToSend;
    QByteArray receivedChars;
    arrayToSend.resize(5);
    arrayToSend[0] = 0x0A;
    arrayToSend[1] = Address & 0xff;
    arrayToSend[2] = Address >> 8;
    arrayToSend[3] = Address >> 16;
    arrayToSend[4] = nb;
   // transmissionFrame.makeAPI3(arrayToSend,address_API);
    bool ok=false;
    bool ok1,ok2=false;
    int i=2;
    do
    {
        if(!sendFrame())
        {
            qDebug()<<"/!\\ Emission problem";
            ok1= false;
        }
        else ok1=true;

        receivedChars=receive_data_API(address_API);
        if(!receivedChars.length())
        {
            qDebug()<<"/!\\ Reception problem r_eth_flash";
            ok2= false;
        }
        else ok2=true;
        ok=ok2&ok1;
        i--;
    }while(!ok&&(i>=0));


    return receivedChars;
}

bool ManageSerialPort::WriteEthernetModuleRam(uint16 Address,QByteArray DataToWrite)
{
    QByteArray arrayToSend;
    QByteArray receivedChars;

    if ((DataToWrite.length()>0) && (DataToWrite.length()<=32))
        arrayToSend.resize(5+DataToWrite.length());
        arrayToSend[0] = 0x07;
        arrayToSend[1] = Address & 0xff;
        arrayToSend[2] = Address >> 8;
        arrayToSend[3] = DataToWrite.length();
        arrayToSend[4] = 0x55;
        for (int i=0;i<DataToWrite.length();i++)
               arrayToSend[5+i] = DataToWrite.at(i);

       // transmissionFrame.makeAPI3(arrayToSend,address_API);
        bool ok=false;
        bool ok1,ok2=false;
        int i=2;
        do
        {
            if(!sendFrame())
            {
                qDebug()<<"/!\\ Emission problem";
                ok1= false;
            }
            else ok1=true;

            receivedChars=receive_data_API(address_API);
            if(!receivedChars.length())
            {
                qDebug()<<"/!\\ Reception problem W_eth_ram";
                ok2= false;
            }
            else  if(receivedChars.at(0)==0x01)ok2=true;
            ok=ok2&ok1;
            i--;
        }while(!ok&&(i>=0));

    return ok;
}


bool ManageSerialPort::WriteEthernetModuleSpecial(uchar Command,QByteArray DataToWrite)
{
    QByteArray arrayToSend;
    QByteArray receivedChars;

    if ((DataToWrite.length()>0) && (DataToWrite.length()<=32))
        arrayToSend.resize(3+DataToWrite.length());
        arrayToSend[0] = 0x09;
        arrayToSend[1] = Command;
        arrayToSend[2] = 0x55;
        for (int i=0;i<DataToWrite.length();i++)
               arrayToSend[3+i] = DataToWrite.at(i);

        //transmissionFrame.makeAPI3(arrayToSend,address_API);
        bool ok=false;
        bool ok1,ok2=false;
        int i=2;
        do
        {
            if(!sendFrame())
            {
                qDebug()<<"/!\\ Emission problem";
                ok1= false;
            }
            else ok1=true;
            waitFor(200);
            receivedChars=receive_data_API(address_API);
            if(!receivedChars.length())
            {
                qDebug()<<"/!\\ Reception problem W_eth_sp";
                ok2= false;
            }
            else  if(receivedChars.at(0)==0x01)ok2=true;
            ok=ok2&ok1;
            i--;
        }while(!ok&&(i>=0));


    return ok;
}
bool ManageSerialPort::write_serial_data(QByteArray DataToWrite,uint8_t _n_try){
    bool ok=false;
    uint8_t n_try=_n_try;
    transmissionFrame.makeSimpleAPIFrame(DataToWrite);
    do ok=sendFrame();
    while(!ok&&(n_try--));
    return ok;
}

//********************
// Debug
//********************

void ManageSerialPort::displayReception()
{
    // Debug : display the recpetion frame
    qDebug()<<"Reception frame :";
    receptionFrame.display();
}

void ManageSerialPort::displayRegPerf()
{
    //Debug : Performance monitor : display all communcation, with R/W, time and success
    qDebug()<<"**********************************";
    qDebug()<<" Reception Performances : ";
    qDebug()<<"**********************************";
    for(uint i=0;i<perfRegister.size();i++)
    {
        QString debugLine;
        for(uint j=0; j<perfRegister.at(i).size();j++)
        {
            debugLine+=QString::number(perfRegister.at(i).at(j))+" ";
        }
        qDebug()<<debugLine;
    }
}

int ManageSerialPort::getTypeofconnection(){
    return typeOfConnection;
}

void ManageSerialPort::stop_rx(){
    flag_stop_rx=1;
}
#ifndef NO_GUI


void ManageSerialPort::onDeviceRemoved(const QextPortInfo &a){

    QSettings settingFile(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    QString port_name=settingFile.value("COM/COM_PORT").toString();
    qDebug()<<"port disconnect : "<<a.portName<<port_name;
    if(a.portName==port_name){

        emit comclose();
    }
}

void ManageSerialPort::onDeviceAttached(const QextPortInfo &a)
{
    QSettings settingFile(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    QString port_name=settingFile.value("COM/COM_PORT").toString();
    qDebug()<<"port discovered : "<<a.portName<<port_name;
     if(a.portName==port_name){
         emit comopen();
     }
}


#endif
void ManageSerialPort::init_no_com()
{
    no_com=true;
}

bool ManageSerialPort::read_data_relay(uint16_t function, uint8_t f_size,uint16_t add_API){
    QByteArray _data;
    _data.append(function);
    transmissionFrame.makeFrameAPI(_data,add_API);
    bool ok=false;
    bool ok1,ok2=false;
    int i=2;
    do{
        if(!sendFrame())
        {
            qDebug()<<"/!\\ Emission problem";
            ok1= false;
        }
        else ok1=true;

        if(!receiveFrameAPI_withADD(add_API))
        {
            qDebug()<<"/!\\ Reception problem";
            ok2= false;
        }
        else ok2=true;
        ok=ok2&ok1;
        i--;
    }while(!ok&&i>=0);
    if(!ok)return false;

    //if no error, reset error com
    return true;
}

bool ManageSerialPort::write_data_relay(uint8_t function, uint16_t data_to_send[8],uint16_t add_API)
{
    QByteArray _data;
    _data.append(function);
     for(int i=0;i<8;i++){
           _data.append(hi(data_to_send[i]));
            _data.append(lo(data_to_send[i]));
     }
    transmissionFrame.makeFrameAPI(_data,add_API);
    bool ok=false;
    bool ok1,ok2=false;
    int i=2;
    do{
        if(!sendFrame())
        {
            qDebug()<<"/!\\ Emission problem";
            ok1= false;
        }
        else ok1=true;

        if(!receiveFrameAPI_withADD(add_API))
        {
            qDebug()<<"/!\\ Reception problem";
            ok2= false;
        }
        else ok2=true;
        ok=ok2&ok1;
        i--;
    }while(!ok&&i>=0);
     if(!ok)return false;
    //if no error, reset error com
    return true;
}

uint8_t ManageSerialPort::get_dongle_version()
{
    QByteArray _data_to_send;
    _data_to_send[0]=0xA1;
    write_serial_data(_data_to_send,0);
    QByteArray receivedchar;
    flag_timeout_timer1=false;
    timer1->start(200);
    do
    {
        waitFor(1);
        if(port.bytesAvailable()==1){
            receivedchar.append(port.readAll());
            timer1->stop();
            return receivedchar.at(0);
        }
    }while(!flag_timeout_timer1);
    timer1->stop();
    return 0;
}



int ManageSerialPort::program_dongle(QString filename){
    QByteArray datatosend;
    QByteArray receivedchar;
    receivedchar.clear();
    uint8_t unlock_ack[4]={ 0x69, 0xD3, 0xD2, 0x26 };
    uint8_t  unlock_seq[4] ={ 0xB2, 0xA5, 0x65, 0x4B };
    //uint8_t  nak_seq[4] = { 0x2D, 0x59, 0x5A, 0xB2 };
    uint8_t  ack_seq[4] = { 0x4D, 0x5A, 0x9A, 0xB4 };


    QFile  srec_file(filename);
    if(!srec_file.open((QIODevice::ReadOnly | QIODevice::Text))){
        //QMessageBox::critical(this,"Error Opening File","The file can't be opened");
        qDebug()<<"The file can't be opened";
        emit update_program_status("Error Opening File");
        return 1;
    }


    datatosend.clear();
    datatosend.push_back(0x99);
    datatosend.push_back(0xAA);
    datatosend.push_back(0x77);
    write_serial_data(datatosend,2);
    datatosend.clear();
    if(port.isOpen()) port.close();
    port.setBaudRate(BAUD38400);//set baudrate to 38400
    if(!port.open(QIODevice::ReadWrite))// | QIODevice::Unbuffered))
    {
        qDebug()<<"Error opening port !";
        emit update_program_status("Error opening port !");
        srec_file.close();
        return 2;
    }
    port.write(0);
    waitFor(100);
    bool ack_ok=false;
    for(int i=0;i<4;i++) datatosend.push_back(uint8_t(unlock_seq[i]));
    int n_try=30;
    emit update_program_status("Wait for dongle response");
    do
    {
        ack_ok=false;
        port.write(datatosend);
        flag_timeout_timer1=false;
        timer1->start(200);
        do
        {
            waitFor(1);
            if(port.bytesAvailable()>=4){
                receivedchar.append(port.readAll());
                ack_ok=true;
                for(int i=0;i<4;i++){
                    if(uint8_t(receivedchar.at(i))!=unlock_ack[i]) ack_ok=false;
                }
            }
       refresh_events();
        }while(!ack_ok&&!flag_timeout_timer1);
        timer1->stop();
    }
    while(!ack_ok&&n_try--);
    if(!ack_ok)
    {
        flag_timeout_timer1=false;
        qDebug()<<"Timeout when receiving ack";
        emit update_program_status("Timeout expired");
        srec_file.close();
        return 3;
    }
    uint i=0;
    vector<QByteArray> lines;
    while (!srec_file.atEnd()) {
        lines.push_back(srec_file.readLine());
    }
    i=0;
    do{
        datatosend.clear();
        receivedchar.clear();
        QByteArray line = lines.at(i);
        datatosend.push_back(line.at(0));
        datatosend.push_back(line.at(1));
        for(int j=2; j<(line.size()-1);j+=2)
        {
            char const tmp[3] = { line.at(j), line.at(j+1), 0 };
            datatosend.push_back((uint8_t)strtol(tmp, 0, 16));
        }
       // qDebug() << "writing page " << (++i);
        emit update_program_status( "Writing page "+QString::number(++i)+"/"+QString::number(lines.size()));
        port.write(datatosend);

        flag_timeout_timer1=false;
        timer1->start(200);
        ack_ok=false;
        do
        {
            waitFor(1);
            if(port.bytesAvailable()>=4){
                receivedchar.append(port.readAll());
                ack_ok=true;
                for(int i=0;i<4;i++){
                    if(uint8_t(receivedchar.at(i))!=ack_seq[i]) ack_ok=false;
                }
            }
       refresh_events();
        }while(!ack_ok&&!flag_timeout_timer1);
        timer1->stop();
        if(flag_timeout_timer1)
        {
            flag_timeout_timer1=false;
            qDebug()<<"Timeout when sending data";
            emit update_program_status("Error writing page"+QString::number(i));
            srec_file.close();
            return 4;
        }
    } while (i<lines.size()) ;
    emit update_program_status("Device succesfully updated");
    srec_file.close();
    return 0;
}
QByteArray ManageSerialPort::read_register(QString reg, uint64_t dest_adress)
{

    QByteArray default_char;
    default_char.append("E");
    if(!dest_adress) //local
    {
    QByteArray DataToWrite;
    DataToWrite.append(0x08);
    DataToWrite.append(0x52);//R
    DataToWrite.append(reg);//
    write_serial_data(DataToWrite,DataToWrite.size());


    QByteArray receivedchar;
    flag_timeout_timer1=false;
    timer1->start(200);
    do
    {
        waitFor(1);
        if(port.bytesAvailable())
        {
            receivedchar.append(port.readAll());
        }
    }while(!flag_timeout_timer1);
    timer1->stop();
    if(receivedchar.at(7)==0)
        return receivedchar.mid(8,receivedchar.size()-9);
    }

    else
    {
        QByteArray DataToWrite;
        DataToWrite.append(0x17);
        DataToWrite.append(0x01);//R

        DataToWrite.append(h7(dest_adress));
        DataToWrite.append(h6(dest_adress));
        DataToWrite.append(h5(dest_adress));
        DataToWrite.append(h4(dest_adress));
        DataToWrite.append(hhh(dest_adress));
        DataToWrite.append(hh(dest_adress));
        DataToWrite.append(hi(dest_adress));
        DataToWrite.append(lo(dest_adress));
        DataToWrite.append(0xFF); //reserved
        DataToWrite.append(0xFE); //reserved
        DataToWrite.append(0x02); //Apply change

        DataToWrite.append(reg);
        write_serial_data(DataToWrite,DataToWrite.size());
        QByteArray receivedchar;
        flag_timeout_timer1=false;
        timer1->start(200);
        do
        {
            waitFor(1);
            if(port.bytesAvailable())
            {
                receivedchar.append(port.readAll());
            }
        }while(!flag_timeout_timer1);
        timer1->stop();
        if(receivedchar.at(17)==0)
            return receivedchar.mid(18,receivedchar.size()-19);
    }
    return default_char;
}

bool ManageSerialPort::write_register(QString reg, uint64_t dest_adress, QByteArray value)
{

    if(!dest_adress) //local
    {
    QByteArray DataToWrite;
    DataToWrite.append(0x08);
    DataToWrite.append(0x52);//R
    DataToWrite.append(reg);//
    DataToWrite.append(value);
    write_serial_data(DataToWrite,DataToWrite.size());

    QByteArray receivedchar;
    flag_timeout_timer1=false;
    timer1->start(200);
    do
    {
        waitFor(1);
        if(port.bytesAvailable())
        {
            receivedchar.append(port.readAll());
        }
    }while(!flag_timeout_timer1);
    timer1->stop();
    if(receivedchar.at(7)==0)
        return true;
    }

    else
    {
        QByteArray DataToWrite;
        DataToWrite.append(0x17);
        DataToWrite.append(0x01);//R

        DataToWrite.append(h7(dest_adress));
        DataToWrite.append(h6(dest_adress));
        DataToWrite.append(h5(dest_adress));
        DataToWrite.append(h4(dest_adress));
        DataToWrite.append(hhh(dest_adress));
        DataToWrite.append(hh(dest_adress));
        DataToWrite.append(hi(dest_adress));
        DataToWrite.append(lo(dest_adress));
        DataToWrite.append(0xFF); //reserved
        DataToWrite.append(0xFE); //reserved
        DataToWrite.append(0x02); //Apply change
        DataToWrite.append(reg);
        DataToWrite.append(value);
        write_serial_data(DataToWrite,DataToWrite.size());

        QByteArray receivedchar;
         flag_timeout_timer1=false;
        timer1->start(200);
        do
        {
            waitFor(1);
            if(port.bytesAvailable())
            {
                receivedchar.append(port.readAll());
            }
        }while(!flag_timeout_timer1);
        timer1->stop();
        if(receivedchar.at(17)==0)
            return true;
    }
    return false;
}


void ManageSerialPort::timeout_timer1()
{
    flag_timeout_timer1=true;
}
/*
void ManageSerialPort::refresh_serial(){
    if(!read_serial_data) {
        receivedDLChars.append(port.readAll());
    }
}*/

bool ManageSerialPort::send_sensor_firmware(QByteArray datatowrite)
{
    bool ack_ok=false;
    qint64 numBytesAvailable = 0;
    QByteArray receivedChars;
    uint8_t n_try=3;
    long timeout_rx=200;
    bool timeout_expired=false;
    clock_t timeStartingReception=clock();
    do
    {
        port.readAll();//clear uart buffer
        write_serial_data(datatowrite,0);
        receivedChars.clear();
        timeStartingReception=clock();
        do
        {
            waitFor(1);
            numBytesAvailable=port.bytesAvailable();
            if(numBytesAvailable>0)
            {
                receivedChars.clear();
                receivedChars.append(port.read(numBytesAvailable));
                for(int i=0;i<receivedChars.size();i++)
                    if(uint8_t(receivedChars.at(i))==0xDA) ack_ok=true;
            }
            timeout_expired=((long((clock()-timeStartingReception)*1000/CLOCKS_PER_SEC))>=long(timeout_rx));
        }while(!ack_ok&&!timeout_expired);
        qDebug()<<"n_try"<<n_try;
    }while(!ack_ok&&n_try--);
    if(!ack_ok) return false;
    return true;
}
