#include "managewirelessdata.h"
#include <ctime>

#include <QKeyEvent>


managewirelessdata::managewirelessdata(ManageSerialPort *_serialPort, QWidget *parent) :
    QWidget(parent)
{//constructor
    //setWindowFlags(Qt::FramelessWindowHint);
    nb_relay=0;
    current_relay=0xFFFF;
    settingFile=NULL;
    settingFile = new QSettings("config.ini",QSettings::IniFormat);
    exportFile=NULL;
    exportFile = new QSettings("export.ini",QSettings::IniFormat);
    exportFile->clear();
    AdvanceWindow=NULL;
    flag_refresh_relay=false;
    if(settingFile->contains("WINDOW_POS/W_DATA_WIN_X")&&
            settingFile->contains("WINDOW_POS/W_DATA_WIN_Y"))
    {
        int maxX=QApplication::desktop()->width();
        int maxY=QApplication::desktop()->height();
        int posX=settingFile->value("WINDOW_POS/W_DATA_WIN_X").toInt();
        int posY=settingFile->value("WINDOW_POS/W_DATA_WIN_Y").toInt();
        if(((maxX-posX-100)>0)&&((maxY-posY-70)>0))this->move(posX,posY);
    }
    for(int i=0;i<256;i++){
        data_rec_ComboBoxList [i] = new QxtCheckComboBox;
        periode_ComboBoxList [i] = new  QComboBox;
        set_change[i]=0;
        legacy_mode[i]= new QCheckBox;
        periode_change[i]=false;
        data_rec_change[i]=false;
        start_time_change[i]=false;
        current_time_change[i]=false;
        for(int j=0;j<256;j++) sensorItemTable[i][j] = new QTableWidgetItem;
        ecart_sec[i]=0xFFFF;
        sensorList[i].relay_list_size=0;
    }
    timer_refresh_list=new QTimer;
    connect(timer_refresh_list,SIGNAL(timeout()),this,SLOT(refresh_relay()));
    timer_refresh_list->stop();
    timer3= new QTimer(this);
    timer3->connect(timer3,SIGNAL(timeout()),this,SLOT(time_out()));
    timer3->stop();
    timer_dl=new QTimer(this);
    connect(timer_dl,SIGNAL(timeout()),this,SLOT(time_out_dl()));
 /*   timer2= new QTimer(this);
    timer2->connect(timer2,SIGNAL(timeout()),this,SLOT(timeout2()));
    timer2->stop();*/
    serialCom = _serialPort;
    dl_in_progress=false;
    address_api_old=serialCom->address_API;
    fillingSensorTable=false;
  //  setWindowIcon(QIcon("icon/simCard.png"));
    setWindowTitle("Wireless Sensor - Internal Data");
    setWindowModality(Qt::ApplicationModal);
    listTempHygroPulse <<"Temp."<<"Hygro."<<"Pulses";
    listTempPulse <<"Temp1."<<"Temp2."<<"Pulses"<<"Pulses2" ;
    listLamp <<"Light"<<"Switch Count"<<"ON Time";
    listWattmeter <<"U"<<"I"<<"Act. Pow."<<"App. Pow."
                  <<"Act. E."<<"App. E.";

    listPeriode <<"1 sec"<<"2 secs"<<"5 secs"<<"10 secs"<<"15 secs"
                 <<"20 secs"<<"30 secs"<<"1 min" <<"2 mins"<<"5 mins"
                 <<"10 mins"<<"15 mins"<<"1 hour";

    batt_volt<<"~"<<"2.9V"<<"3.0V"<<"3.4V"<<"2.2V"<<"2.3V"<<"2.4V"<<
        "2.5V"<<"2.6V"<<"2.7V"<<"2.8V"<<"3.1V"<<"3.2V"<<"3.3V"<<"3.5V"<<"3.7V";

    batt_volt2<<"~"<<"2.9"<<"3.0"<<"3.4"<<"2.2"<<"2.3"<<"2.4"<<
        "2.5"<<"2.6"<<"2.7"<<"2.8"<<"3.1"<<"3.2"<<"3.3"<<"3.5"<<"3.7";

    fillWindow();
    setTableWidget();
    add_empty_row();
    //connect to apply changes in a cell
    setContextMenuPolicy(Qt::CustomContextMenu);

    connect(sensorTableWidget,SIGNAL(cellChanged(int,int)),this,SLOT(valueChanged(int,int)));
    connect(this,SIGNAL(customContextMenuRequested(QPoint)),this,SLOT(displayContextMenu(QPoint)));
    connect(this,SIGNAL(button_sa_clicked()),serialCom,SLOT(buttonclicked()));
    button_state_sa=0;
    button_state_ad=0;
    folder_ok=false;
    if(settingFile->contains("W_DATA/SET_TIME_DELAY")){
             ecart_set_time=settingFile->value("W_DATA/SET_TIME_DELAY").toInt();
    }
    else ecart_set_time=3;


}

managewirelessdata::~managewirelessdata()
{   //Destructor

}

void managewirelessdata::open_window(){

    dl_start_time->setMinimumDateTime(QDateTime::currentDateTime().addYears(-10));
    dl_start_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(3600));

    dl_end_time->setMinimumDateTime(QDateTime::currentDateTime().addYears(-10));
    dl_end_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(3600));
}

void managewirelessdata::fillWindow(){
    timer1 = new QTimer(this);
    connect(timer1,SIGNAL(timeout()),SLOT(each_sec()));
    timer1->start(500);
    setMinimumSize(1000,600);
    setMaximumSize(1000,2000);
    //setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);




    verticalLayout = new QVBoxLayout;

    QHBoxLayout *Hbox1= new QHBoxLayout;

    QVBoxLayout *Vbox1 =new QVBoxLayout;
    QVBoxLayout *Vbox2 = new QVBoxLayout;
    QVBoxLayout *Vbox3 = new QVBoxLayout;

    QHBoxLayout *Hboxt = new QHBoxLayout;
    QLabel *_current_pc_time = new QLabel("      Current PC Time : ");
    Hboxt->addWidget(_current_pc_time);

    current_pc_time = new QLabel(QDateTime::currentDateTime().toString("dd/MM/yyyy hh:mm:ss"));
    Hboxt->setAlignment(Qt::AlignLeft);
    Hboxt->addWidget(current_pc_time);
    Vbox2->addLayout(Hboxt);

    dl_all_data=new QCheckBox("Download All Data");
    dl_all_data->adjustSize();

    action_box=new QGroupBox("Action for all sensors in the list below");
    action_box->setCheckable(false);
    QVBoxLayout *action_linev=new QVBoxLayout;
    QHBoxLayout *action_line1=new QHBoxLayout;
    settime= new QCheckBox("Set Time");
    settime->setMinimumWidth(dl_all_data->width());
    setperiode= new QCheckBox("Change Recording Period");
    set_data_rec = new QCheckBox("Select Channels to record");
    clrdata=new QCheckBox("Clear all data");
    connect(settime,SIGNAL(stateChanged(int)),this,SLOT(state_change_set_time()));
    connect(set_data_rec,SIGNAL(stateChanged(int)),this,SLOT(state_change_set_data()));
    connect(setperiode,SIGNAL(stateChanged(int)),this,SLOT(state_change_setperiode()));
    connect(clrdata,SIGNAL(stateChanged(int)),this,SLOT(state_change_clrdata()));

    action_line1->addWidget(settime);
    action_line1->addWidget(set_data_rec);
    action_line1->addWidget(setperiode);
    action_line1->addWidget(clrdata);
    action_line1->setAlignment(Qt::AlignLeft);
    action_linev->addLayout(action_line1);

    QHBoxLayout *action_line2=new QHBoxLayout;


    dl_data_between=new QCheckBox("Download data from : ");  
    connect(dl_all_data,SIGNAL(stateChanged(int)),this,SLOT(state_change_dl_all_data()));
    connect(dl_data_between,SIGNAL(stateChanged(int)),this,SLOT(state_change_dl_data_between()));


    dl_start_time = new QDateTimeEdit(QDateTime::currentDateTime());
    dl_start_time->setCalendarPopup(true);
    dl_start_time->setMinimumDateTime(QDateTime::currentDateTime().addYears(-10));
    dl_start_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(7200));
    dl_start_time->setDisplayFormat("dd.MM.yyyy   hh:mm");
    dl_start_time->dateTime().setTimeSpec(Qt::LocalTime);
    QLabel *to=new QLabel(" to ");
    dl_end_time = new QDateTimeEdit(QDateTime::currentDateTime());
    dl_end_time->setCalendarPopup(true);
    dl_end_time->setMinimumDateTime(QDateTime::currentDateTime().addYears(-10));
    dl_end_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(7200));
    dl_end_time->setDisplayFormat("dd.MM.yyyy  hh:mm");
    dl_end_time->dateTime().setTimeSpec(Qt::LocalTime);
    action_line2->addWidget(dl_all_data);
    action_line2->addWidget(dl_data_between);
    action_line2->addWidget(dl_start_time);
    action_line2->addWidget(to);
    action_line2->addWidget(dl_end_time);
    action_line2->setAlignment(Qt::AlignLeft);
    action_linev->addLayout(action_line2);

    QHBoxLayout *Hboxdir= new QHBoxLayout;
    select_folder = new QPushButton("Select files output folder");
    connect(select_folder,SIGNAL(clicked()),this,SLOT(button_select_folder_clicked()));
    saving_folder=new QLineEdit(QDir::currentPath());
    connect(saving_folder,SIGNAL(textEdited(QString)),this,SLOT(folder_changed(QString)));
    if(settingFile->contains("W_DATA/DEST_FOLDER")){
       saving_folder->setText(settingFile->value("W_DATA/DEST_FOLDER").toString());
       folder_for_save.setPath(settingFile->value("W_DATA/DEST_FOLDER").toString());
    }


    Hboxdir->addWidget(select_folder);
    Hboxdir->addWidget(saving_folder);
    //action_linev->addLayout(Hboxdir);

    action_box->setLayout(action_linev);

    Vbox2->addWidget(action_box);
    Vbox2->addLayout(Hboxdir);



    QHBoxLayout *Hbox3= new QHBoxLayout;
    send_action = new QPushButton("Send Action");
    connect(send_action,SIGNAL(clicked()),this,SLOT(button_send_action_clicked()));

    Hbox3->addWidget(send_action);

    Vbox2->addLayout(Hbox3);



    QHBoxLayout *Hbox4= new QHBoxLayout;
    detect_sensor = new QPushButton("Auto-detect and add sensors to list");
    connect(detect_sensor,SIGNAL(clicked()),this,SLOT(button_detect_sensor_clicked()));
    detect_sensor->setFixedWidth(300);
    QHBoxLayout *Hbox6= new QHBoxLayout;
    Import_list = new QPushButton("Import Sensor List");
    connect(Import_list,SIGNAL(clicked()),this,SLOT(button_import_clicked()));
    Import_list->setFixedWidth(300);

    QHBoxLayout *Hbox5= new QHBoxLayout;
    Export_list= new QPushButton("Export Sensor List");
    connect(Export_list,SIGNAL(clicked()),this,SLOT(button_export_clicked()));
    Export_list->setFixedWidth(300);

    Hbox4->setAlignment(Qt::AlignBottom);
    Hbox4->addWidget(detect_sensor);
    Hbox5->addWidget(Export_list);
    Hbox6->addWidget(Import_list);
    Vbox1->addLayout(Hbox5);
    Vbox1->addLayout(Hbox6);
    Vbox1->addLayout(Hbox4);
    Hbox1->addLayout(Vbox1);
    Hbox1->addLayout(Vbox2);
    Hbox1->addLayout(Vbox3);


    verticalLayout->addLayout(Hbox1);


    sensorTableWidget = new QTableWidget(0,12);
    verticalLayout->addWidget(sensorTableWidget);
    relay_status = new QLabel();
    verticalLayout->addWidget(relay_status);
    setLayout(verticalLayout);



}

void managewirelessdata::setTableWidget(){
    // Place columns into sensorTableWidget
    sensorTableWidget->setVisible(true);

    sensorSNTableItem = new QTableWidgetItem("SN");
    sensorTableWidget->setHorizontalHeaderItem(0,sensorSNTableItem);
    sensorTableWidget->setColumnWidth(0,37);

    sensorTypeTableItem= new QTableWidgetItem("Sensor Type");
    sensorTableWidget->setHorizontalHeaderItem(1,sensorTypeTableItem);
    sensorTableWidget->setColumnWidth(1,71);

    sensorVersionTableItem= new QTableWidgetItem("Ver");
    sensorTableWidget->setHorizontalHeaderItem(2,sensorVersionTableItem);
    sensorTableWidget->setColumnWidth(2,26);

    sensorCurrentTimeTableItem= new QTableWidgetItem("Current Time");
    sensorTableWidget->setHorizontalHeaderItem(3,sensorCurrentTimeTableItem);
    sensorTableWidget->setColumnWidth(3,114);

    sensorStartTimeTableItem= new QTableWidgetItem("Start Time");
    sensorTableWidget->setHorizontalHeaderItem(4,sensorStartTimeTableItem);
    sensorTableWidget->setColumnWidth(4,114);

    sensorTypeDataRecTableItem= new QTableWidgetItem("Channels to Record");
    sensorTableWidget->setHorizontalHeaderItem(5,sensorTypeDataRecTableItem);
     sensorTableWidget->setColumnWidth(5,223);

    sensorPeriodeRecTableItem= new QTableWidgetItem("Period");
    sensorTableWidget->setHorizontalHeaderItem(6,sensorPeriodeRecTableItem);
    sensorTableWidget->setColumnWidth(6,75);

    sensorNbPageTableItem= new QTableWidgetItem("#Pages");
    sensorTableWidget->setHorizontalHeaderItem(7,sensorNbPageTableItem);
    sensorTableWidget->setColumnWidth(7,45);

    sensorVbatItem= new QTableWidgetItem("Vbat");
    sensorTableWidget->setHorizontalHeaderItem(8,sensorVbatItem);
    sensorTableWidget->setColumnWidth(8,35);

    sensorRSSITableItem= new QTableWidgetItem("Rssi");
    sensorTableWidget->setHorizontalHeaderItem(9, sensorRSSITableItem);
    sensorTableWidget->setColumnWidth(9,50);

    sensorStatusTableItem= new QTableWidgetItem("Status");
    sensorTableWidget->setHorizontalHeaderItem(10, sensorStatusTableItem);
    sensorTableWidget->setColumnWidth(10,170);

    sensormodeTableItem= new QTableWidgetItem("Mode");
    sensorTableWidget->setHorizontalHeaderItem(11, sensormodeTableItem);
    sensorTableWidget->setColumnWidth(11,35);

    sensorTableWidget->horizontalHeader()->setHighlightSections(false);
    sensorTableWidget->setVerticalScrollMode(QAbstractItemView::ScrollPerItem);
    sensorTableWidget->setAutoScroll(false);
    sensorTableWidget->clearContents();
    sensorTableWidget->setSelectionBehavior(QAbstractItemView::SelectRows);
}

void managewirelessdata::add_empty_row(){

    uint16_t n_row = sensorTableWidget->rowCount();
    sensorTableWidget->setRowCount(n_row+1);
    uint16_t row_index=n_row;
    //QTableWidgetItem *newLine [256];
    Sensor_l currentSensor;

    sensorList[row_index] = currentSensor;

    fillingSensorTable=true;
    // Add empty items, from 0 to 11
    for(uint16 columnIndex=0; columnIndex<11; columnIndex++)
    {
        //create item
        QTableWidgetItem *newItem = new QTableWidgetItem;
        newItem->setTextAlignment(Qt::AlignCenter|Qt::AlignVCenter);
        if(columnIndex!=0){ newItem->setFlags(newItem->flags()
                                & ~Qt::ItemIsEditable & ~Qt::ItemIsSelectable);
            newItem->setText("");
        }
        else {
            newItem->setFlags(newItem->flags() & ~Qt::ItemIsSelectable);
                                        // to let serialNb & sensorName editable
            newItem->setText("");
        }
        sensorItemTable[row_index][columnIndex]=newItem;
        //link table entry with widget :
        sensorTableWidget->setItem(row_index,columnIndex,newItem);
    }

    QxtCheckComboBox * selectdatarecComboBox = new QxtCheckComboBox;


    QCheckBox *select_mode=new QCheckBox;
    legacy_mode[row_index]=select_mode;
    QFrame *frame1=new QFrame;
    QHBoxLayout *select_mode_layout = new QHBoxLayout;
    select_mode_layout->addWidget(select_mode);
    select_mode_layout->setMargin(2);
    select_mode_layout->insertSpacing( 0,5 );
    frame1->setLayout(select_mode_layout);
    sensorTableWidget->setCellWidget(row_index,11,frame1);
    legacy_mode[row_index]->setEnabled(false);
    legacy_old[row_index]=false;
    legacy_changed[row_index]=false;
    connect(legacy_mode[row_index],SIGNAL(stateChanged(int)),this,SLOT(legacy_mode_changed()));

    data_rec_ComboBoxList[row_index]=selectdatarecComboBox;
    data_rec_ComboBoxList[row_index]->setContextMenuPolicy(Qt::NoContextMenu);
    connect(data_rec_ComboBoxList[row_index],SIGNAL(checkedItemsChanged(QStringList)),this,SLOT(datarec_changed()));
    list_datarec[row_index]=data_rec_ComboBoxList[row_index]->checkedItems();
    QFrame *framedata=new QFrame;
    QVBoxLayout *data_r= new QVBoxLayout;
    sensor_data[row_index]= new QLabel();
    sensor_data[row_index]->setStyleSheet("font: 8px;");
    sensor_data[row_index]->setFixedHeight(10);
    sensor_data[row_index]->setText("");
    data_r->addWidget(selectdatarecComboBox);
    data_r->addWidget(sensor_data[row_index]);
    data_r->setContentsMargins(0,0,0,0);
    framedata->setLayout(data_r);
    framedata->setContentsMargins(0,0,0,0);
    sensorTableWidget->setCellWidget(row_index,5,framedata);//selectdatarecComboBox);

    QComboBox * selectperiodeComboBox = new QComboBox;
    periode_ComboBoxList[row_index]=selectperiodeComboBox;

    periode_ComboBoxList[row_index]->setContextMenuPolicy(Qt::NoContextMenu);
    index_periode[row_index]=periode_ComboBoxList[row_index]->currentIndex();
    periode_change[row_index]=false;
    connect(periode_ComboBoxList[row_index],SIGNAL(currentIndexChanged(int)),this,SLOT(periode_changed()));
    sensorTableWidget->setCellWidget(row_index,6,selectperiodeComboBox);
    for(int i=0;i<n_row;i++)
    {
        for(uint16 columnIndex=0; columnIndex<11; columnIndex++)
        {
            sensorItemTable[i][columnIndex]->setFlags( sensorItemTable[i][columnIndex]->flags()
                                                               |Qt::ItemIsSelectable);
        }
    }
    sensorTableWidget->setRowHeight(row_index,35);
    fillingSensorTable=false;
}

void managewirelessdata::state_change_dl_all_data(){
    if(dl_all_data->isChecked()){
       dl_data_between->setChecked(false);
       clrdata->setChecked(false);
       settime->setChecked(false);
       set_data_rec->setChecked(false);
       setperiode->setChecked(false);
    }
}

void managewirelessdata::state_change_dl_data_between(){
    if(dl_data_between->isChecked()){
       dl_all_data->setChecked(false);
       clrdata->setChecked(false);
       settime->setChecked(false);
       set_data_rec->setChecked(false);
       setperiode->setChecked(false);
    }

}

void managewirelessdata::state_change_clrdata(){
    if(clrdata->isChecked()){
       dl_all_data->setChecked(false);
       dl_data_between->setChecked(false);
    }
}

void managewirelessdata::state_change_setperiode(){
    if(setperiode->isChecked()) {
        dl_all_data->setChecked(false);
        dl_data_between->setChecked(false);
    }
}

void managewirelessdata::state_change_set_data(){
    if(set_data_rec->isChecked()){
        dl_all_data->setChecked(false);
        dl_data_between->setChecked(false);
    }

}


void managewirelessdata::state_change_set_time(){
    if(settime->isChecked()) {
        dl_all_data->setChecked(false);
        dl_data_between->setChecked(false);
    }
}


void managewirelessdata::req_detect_sensor(){
    current_relay=0xFFFF;
    for(int p=0;p<nb_relay;p++)
        add_sensor_to_list_relay(0x0000,list_relay[p].serialNb);
    add_sensor_to_list(0);//clear list
    init_color();
    flag_timeout=false;
    timer3->start(10000);
    for(int i=0;i<256;i++)
    {
        sensorList[i].param_received=false;
    }



    waitForUs(100);
    uint16_t max_line;
    //int i_relay=0;
    //nb_relay=0;
    uint32_t sensor_received=0;
    bool end_list=false;
    flag_timeout=false;
    timer3->start(15000); //delai entre 2 envois commande 0x30
    uint8_t n_timeout = 47; //nombre de dlai avant timeout
    int i_row=0;
    add_sensor_to_list_det(0); //pour permettre au dongle de rpondre au ack de tous les capteurs
    waitFor(5);
    QByteArray _data_to_send;
    _data_to_send[0]=0x30;
    bool sensor_exist=false;
    serialCom->write_serial_data(_data_to_send,0); //envoie cmd 0x30
    do{
        int frame_type=0;
         max_line=(sensorTableWidget->rowCount()-1);

         do
         {
             if(!flag_refresh_relay)
             {
             frame_type=serialCom->readframe_wmodule(0xFFFF); //rcupre la trame de param du capteur ou la liste des capteurs d'un relais
             }else waitFor(10);
             QApplication::processEvents();
         }while(!frame_type&&button_state_ad&&!flag_timeout);

         switch(frame_type)
         {
         case 1: //trame param d'un capteur

             sensor_received = (serialCom->getAllReceivedData()[3]<<8)+serialCom->getAllReceivedData()[4];
             qDebug()<<"sensor : "<< QString::number(sensor_received,16).rightJustified(4,'0').toUpper();
             i_row=0;
             sensor_exist=false;
             for(i_row=0;i_row<max_line;i_row++)
             {
                 if(sensor_received==sensorList[i_row].serialNb)
                 {
                     sensor_exist=true;
                     break;
                 }
             }
             if(!sensor_exist)
             {
                 add_sensor_to_list_det(sensor_received); //indique au dongle de ne plus rpondre au ack du capteur
                 sensorItemTable[max_line][0]->setText(QString::number(sensor_received,16).rightJustified(4,'0').toUpper());
                 recup_param(sensor_received,false); //rcupre les paramtres
                 for(int i=0;i<max_line;i++)
                 {
                     if(sensor_received==sensorList[i].serialNb)
                     {
                         sensorList[i].param_received=true;
                         break;
                     }
                 }

             }
             else
             {
                 if(!sensorList[i_row].param_received)
                 {
                     recup_param(sensor_received,false);
                     sensorList[i_row].param_received=true;
                     if(sensorList[i_row].relay_list[0].serialNb)
                         remove_sensor_to_list_relay(sensor_received,sensorList[i_row].relay_list[0].serialNb);
                 }
             }
             break;

         case 2: //liste des capteurs vues par un relais
             uint16_t serial_relay_received=serialCom->rx_source_address;
             bool relay_exist=false;
             int p=0;
             qDebug()<<"relay"<<QString::number(serial_relay_received,16).rightJustified(4,'0').toUpper()<<"rssi"<<serialCom->rssi_sensor;
             for(p=0;p<nb_relay;p++) if(serial_relay_received==list_relay[p].serialNb)
             {
                 relay_exist=true;
                 list_relay[p].rssi=serialCom->rssi_sensor;
                 break;
             }

             end_list=false;
             if(!relay_exist)
             {
                 list_relay[nb_relay].serialNb=serial_relay_received;
                 list_relay[nb_relay].rssi=serialCom->rssi_sensor;
                 nb_relay++;
             }
             QString info_relais="";
             for(p=0;p<nb_relay;p++)
             {
             info_relais+="Relay "+QString::number(p+1)+" , SN : "+QString::number(list_relay[p].serialNb,16).rightJustified(4,'0').toUpper()+
                     ", RSSI : -"+QString::number(list_relay[p].rssi)+" dbm\t";
             }
             relay_status->setText(info_relais);
             int i=0;
             do{
                 max_line=(sensorTableWidget->rowCount()-1);

                 sensor_received = (serialCom->getAllReceivedData()[(i*4)+1]<<8)+serialCom->getAllReceivedData()[(i*4)+2];
                 if(sensor_received!=0x0000)
                 {
                     uint8_t rssi_received=serialCom->getAllReceivedData()[(i*4)+3];
                     sensorItemTable[max_line][0]->setText(QString::number(sensor_received,16).rightJustified(4,'0').toUpper());
                     QApplication::processEvents();
                     waitFor(1);
                     while(fillingSensorTable);
                     max_line=(sensorTableWidget->rowCount()-1);
                     int row=0;
                     for(row=0;row<max_line;row++){
                         if(sensor_received==sensorList[row].serialNb) break;
                     }
                     //sensorItemTable[row][9]->setText("-"+QString::number(rssi_received)+"dbm");
                     uint16_t old_serial_relay=sensorList[row].relay_list[0].serialNb;
                     if(!(!sensorList[row].relay_list[0].serialNb&&(sensorList[row].relay_list[0].rssi<81))
                             &&(rssi_received<sensorList[row].relay_list[0].rssi))
                     {
                         sensorItemTable[row][9]->setText("-"+QString::number(rssi_received)+"dbm");
                         sensorList[row].relay_list[0].serialNb=serial_relay_received;
                         sensorList[row].relay_list[0].rssi=rssi_received;
                     }
                     if(!sensorList[row].param_received&&((((n_timeout&0xF8)>>3)&0x01)==1))
                     {
                         if(old_serial_relay!=sensorList[row].relay_list[0].serialNb) //si deja en ack sur un autre relais (ou direct)
                         {
                             add_sensor_to_list_det(sensor_received);
                             if(old_serial_relay) remove_sensor_to_list_relay(sensor_received,old_serial_relay); //on enleve le capteur du relais si pas en direct
                             add_sensor_to_list_relay(sensor_received,sensorList[row].relay_list[0].serialNb); //on ajoute le capteur au nouveau relais
                         }
                     }
                 }
                 else end_list=true;
                 i++;
                 if(i>63) end_list=true;
                 QApplication::processEvents();
             }while(button_state_ad&&!end_list);
             break;
         }
         QApplication::processEvents();

         if(flag_timeout) //timeout de 15s entre 2 demandes 0x30
         {
             if((n_timeout==39)||(n_timeout==23)||(n_timeout==7))
             {
                 for(i_row=0;i_row<max_line;i_row++)
                 {
                     if(!sensorList[i_row].param_received&&sensorList[i_row].relay_list[0].serialNb)
                     {
                         remove_sensor_to_list_relay(sensorList[i_row].serialNb,sensorList[i_row].relay_list[0].serialNb);
                         remove_sensor_to_list_det(sensorList[i_row].serialNb);
                     }
                 }
             }
             timer3->stop();
             n_timeout--;
             flag_timeout=false;
             timer3->start(15000);
             serialCom->write_serial_data(_data_to_send,0); //envoie cmd 0x30
         }
     }
     while(button_state_ad&&n_timeout);
    timer3->stop();
      for(int i=0;i<256;i++) set_change[i]=0 ;
    if(button_state_ad)
        button_detect_sensor_clicked();
}


void managewirelessdata::req_sendaction()
    {
    current_relay=0xFFFF;
    for(int p=0;p<nb_relay;p++)
        add_sensor_to_list_relay(0x0000,list_relay[p].serialNb);
    flag_dl_interrupt=true;
    add_sensor_to_list(0);//clear list
    int rx_return=0;
    bool rx_ok=false;
    rx_ok_when_dl=false;
    if( !QDir( folder_for_save.absolutePath()).exists() )
    {
        if(!QDir().mkdir(folder_for_save.absolutePath())){
            if(button_state_sa) button_send_action_clicked();
            folder_ok=false;
            QMessageBox::critical(this,"Folder Creation Failed","The folder "+folder_for_save.absolutePath()+" can't be created");
            return ;
        }
        else folder_ok=true;
    }
    else folder_ok=true;
    refresh_relay();
    do
    {
        waitFor(1);
        QApplication::processEvents();
    }
    while(flag_refresh_relay);
    int max_line=(sensorTableWidget->rowCount()-1);
    int nr_sensor=0;
    bool sensor_ok[256];
    for(int l=0;l<256;l++){
        sensor_ok[l]=false;
        sensor_action_finished[l]=false;
        sensorList[l].dl_ongoing=false;
        file_open[l]=false;
    }
    for(int i=0;i<max_line;i++)
    {
        qDebug()<<QString::number(sensorList[i].serialNb,16).rightJustified(4,'0').toUpper()<<" : "
                   <<"sn relay"<<QString::number(sensorList[i].relay_list[0].serialNb,16).rightJustified(4,'0').toUpper()<<"rssi : "<<sensorList[i].relay_list[0].rssi;

        if(sensorList[i].relay_list[0].serialNb!=0) //relais (sinon j=0 pour dongle
        {
            add_sensor_to_list_relay(sensorList[i].serialNb,sensorList[i].relay_list[0].serialNb);
        }
        else add_sensor_to_list(sensorList[i].serialNb);
        nr_sensor++;
        sensorItemTable[i][10]->setTextColor(Qt::black);
        sensorItemTable[i][10]->setText("Wait for sensor response");
    }
    dl_in_progress=false;
    init_color();
    bool change_set=false;
    QString styleSheet = "QComboBox   {  color:   red;   }";

    if(dl_all_data->isChecked()||dl_data_between->isChecked()) {
        for(int i=0;i<max_line;i++) {
            sensorList[i].current_dl_page=0;
            sensorList[i].dl_ongoing=false;
        }
    }

    if(settime->isChecked()) {
        for(int i=0;i<max_line;i++) {sensorItemTable[i][3]->setTextColor(Qt::red);
        current_time_change[i]=true;
        set_change[i]=true;
        }
        change_set=true;
    }
    if(clrdata->isChecked()) {
        for(int i=0;i<max_line;i++) {sensorItemTable[i][4]->setTextColor(Qt::red);
        start_time_change[i]=true;
        set_change[i]=true;
        }
        change_set=true;
    }
    if(set_data_rec->isChecked()) {
        for(int i=0;i<max_line;i++)
        {
            if(data_rec_change[i])
            {
                data_rec_ComboBoxList[i]->setStyleSheet(styleSheet);
                change_set=true;
                set_change[i]=true;
            }
        }
    }
    if(setperiode->isChecked()) {
        for(int i=0;i<max_line;i++)
        {
            if(periode_change[i])
            {
                periode_ComboBoxList[i]->setStyleSheet(styleSheet);
                change_set=true;
                set_change[i]=true;
            }
        }

    }

    for(int i=0;i<max_line;i++)
    {
        if(legacy_changed[i])
        {
            legacy_mode[i]->setStyleSheet(styleSheet);
            change_set=true;
            set_change[i]=true;
        }
    }

    if(change_set) {
        for(int i=0;i<max_line;i++) if(set_change[i])  sensorItemTable[i][0]->setTextColor(Qt::red);
       // set_change[i]=true;
    }
    //for(int i=0;i<nr_sensor;i++)
    bool action_finished=false;

    do
    {
        if(!rx_ok_when_dl)
        {
            do
            {
                if(!flag_refresh_relay)
                {
                    rx_return=serialCom->readframe_wmodule(0xFFFF);
                    switch(rx_return)
                    {
                    case 0:
                        rx_ok=false;
                        break;

                    case 1:
                        rx_ok=true;
                        break;
                    case 2:
                        qDebug()<<"liste relais";
                        update_relay_info();
                        rx_ok=false;
                        break;
                    }

                }
                else waitFor(10);
                QApplication::processEvents();
            }while(!rx_ok&&button_state_sa);
        }
        else {
            //dl_in_progress=false;
            rx_ok=true;
            rx_ok_when_dl=false;
        }
        if(rx_ok)
        {
            uint32_t sensor_received = (serialCom->getAllReceivedData()[3]<<8)+serialCom->getAllReceivedData()[4];
            /*if(serialCom->getAllReceivedData()[53]==0xFF){
               sensor_received+=0x10000;
            }*/
            bool sensor_exist=false;
            int max_line=(sensorTableWidget->rowCount()-1);
            int row=0;
            for(int i=0;i<max_line;i++){
                if(sensor_received==sensorList[i].serialNb) {
                    row=i;
                    sensor_exist=true;
                }
            }
            if(!sensor_exist){
                qDebug()<<"sensor received not in the list sensor received : "<<QString::number(sensor_received,16).rightJustified(4,'0').toUpper();
            }
            else
            {
                if(sensorList[row].relay_list[0].serialNb!=0) //relais (sinon j=0 pour dongle
                {
                    add_current_sensor_relay(sensorList[row].serialNb,sensorList[row].relay_list[0].serialNb);
                }
                else add_current_sensor(sensorList[row].serialNb);
                /*
                if(sensor_received&0x10000) add_current_sensor_relay(sensor_received,sensorList[row].relay.serialNb);
                else add_current_sensor(sensor_received);*/
                qDebug()<<"SN received : "<<QString::number(sensor_received,16).rightJustified(4,'0').toUpper();
                get_data_to_send(sensor_received);
                recup_param(sensor_received,false);
                QApplication::processEvents();
                if(!button_state_sa) break;
                uint8_t etat_dl = send_param(sensor_received);
                current_relay=0xFFFF;
                switch(etat_dl)
                {
                case 0: //erreur sur la trame recue
                    sensorItemTable[row][10]->setTextColor(Qt::red);
                    sensorItemTable[row][10]->setText("Error when applying settings");
                    break;

                case 1:
                    waitFor(50);
                    if(sensorList[row].relay_list[0].serialNb) //relais (sinon j=0 pour dongle
                    {
                        remove_sensor_to_list_relay(sensorList[row].serialNb,sensorList[row].relay_list[0].serialNb);
                    }
                    else remove_sensor_to_list(sensorList[row].serialNb);
                    /*
                    if(sensor_received&0x10000) remove_sensor_to_list_relay(sensor_received,sensorList[row].relay.serialNb);
                    else remove_sensor_to_list(sensor_received);*/
                    sensor_ok[row]=true;
                    sensor_action_finished[row]=true;
                    break;

                case 2:  //interruption dl
                    if(flag_dl_interrupt) //si timeout (echec com plus de 2500ms
                    {
                        refresh_relay();
                        do
                        {
                            waitFor(1);
                            QApplication::processEvents();
                        }
                        while(flag_refresh_relay);
                    }
                    break;
                }
            }
        }

        if(!button_state_sa){
            for(int j=0;j<max_line;j++){
                if(!sensor_ok[j]){
                    sensorItemTable[j][10]->setTextColor(Qt::red);
                    sensorItemTable[j][10]->setText("Action Interrupted by User");
                }
            }
            break;
        }
        action_finished=true;
        for(int i=0;i<nr_sensor;i++){
            if(!sensor_action_finished[i]) action_finished=false;
        }
    }while(!action_finished);

    for(int i=0;i<max_line;i++) {
        start_time_change[i]=false;
        current_time_change[i]=false;
        data_rec_change[i]=false;
        periode_change[i]=false;
        set_change[i]=false;
    }
    if(button_state_sa) button_send_action_clicked();
}


uint8_t managewirelessdata::send_param(uint32_t sensor_nr){

    uint8_t param[17];
    int max_line=(sensorTableWidget->rowCount()-1);
    int row=0;
    for(int i=0;i<max_line;i++){
        if(sensor_nr==sensorList[i].serialNb) row=i;
    }
    current_relay=sensorList[row].relay_list[0].serialNb;
    for (int i=0;i<17;i++) param[i]=0;

    if(settime->isChecked())//&&(abs(ecart_sec[row])>ecart_set_time))
    {
        param[0]+=0x01;
    }

    if(setperiode->isChecked()&&periode_change[row]&&(sensorList[row].periode!=new_per)){
        param[0]+=0x02;
        param[1]=new_per;
    }
    if(clrdata->isChecked())param[0]+=0x04;
    if(dl_data_between->isChecked()){
        param[0]+=0x08;
        QDateTime dl_start_t=dl_start_time->dateTime();
        QDateTime dl_end_t=dl_end_time->dateTime();

        dl_start_t=dl_start_t.toLocalTime();
        dl_end_t=dl_end_t.toLocalTime();

        param[2]=bcdFromDecimal(dl_start_t.date().year()%100);
        param[3]=bcdFromDecimal(dl_start_t.date().month());
        param[4]=bcdFromDecimal(dl_start_t.date().day());
        param[5]=bcdFromDecimal(dl_start_t.time().hour());
        param[6]=bcdFromDecimal(dl_start_t.time().minute());
        param[7]=bcdFromDecimal(dl_start_t.time().second());

        param[8]=bcdFromDecimal(dl_end_t.date().year()%100);
        param[9]=bcdFromDecimal(dl_end_t.date().month());
        param[10]=bcdFromDecimal(dl_end_t.date().day());
        param[11]=bcdFromDecimal(dl_end_t.time().hour());
        param[12]=bcdFromDecimal(dl_end_t.time().minute());
        param[13]=bcdFromDecimal(dl_end_t.time().second());

    }
    if(dl_all_data->isChecked()) param[0]+=0x10;

    if(set_data_rec->isChecked()&&data_rec_change[row]&&(sensorList[row].data_rec!=data_rec_to_send)){
        param[0]+=0x40;
        param[15]=sensorList[row].sensorType;

        param[14]= data_rec_to_send;
    }
   if(legacy_changed[row]){
        param[0]+=0x20;
        qDebug()<<"legacy mode off";
    }
    if((param[0]!=0)&&!sensorList[row].dl_ongoing)
    {//si commande  envoyer
        bool rx_ok=false;
        //bool rx_ok2=false;
        flag_timeout=false;
        timer3->start(2500);
        do
        {
            flag_dl_interrupt=false;
            int n_try=4;
            do{
                if(settime->isChecked()){
                    time_t rawtime;
                    struct tm * timeinfo;
                    time ( &rawtime );
                    timeinfo=localtime(&rawtime);
                    int dst_on= timeinfo->tm_isdst;
                    if(dst_on){
                        param[16]=0;
                    }
                    else {
                        param[16]=1;
                    }
                    uint8_t time64;
                    int msec_tmp;
                    param[8]=ecart_set_time;
                    param[16]=0;
                    msec_tmp=1000-QDateTime::currentDateTime().time().msec();
                    time64 = (msec_tmp&0x3F0)>>4;
                    param[16]+=time64<<1;
                    /*
                    qDebug()<<"msec : "<<msec_tmp;
                    qDebug()<<"time64 : "<<time64;*/
                    param[2]=bcdFromDecimal(QDateTime::currentDateTime().date().year()%100);
                    param[3]=bcdFromDecimal(QDateTime::currentDateTime().date().month());
                    param[4]=bcdFromDecimal(QDateTime::currentDateTime().date().day());
                    param[5]=bcdFromDecimal(QDateTime::currentDateTime().time().hour());
                    param[6]=bcdFromDecimal(QDateTime::currentDateTime().time().minute());
                    param[7]=bcdFromDecimal(QDateTime::currentDateTime().time().second());
                }

                serialCom->sendframe_wdata(sensor_nr,0x0F,param,sensorList[row].relay_list[0].serialNb);
                int rx_return=serialCom->readframe_wmodule(sensor_nr);
                switch(rx_return)
                {
                case 0:
                    rx_ok=false;
                    break;
                case 1:
                    rx_ok=true;
                    break;
                case 2:
                    update_relay_info();
                    rx_ok=false;
                    break;
                }

                QApplication::processEvents();
            }while(!rx_ok&&button_state_sa&&(--n_try));
            flag_dl_interrupt=true;

            if(!rx_ok){
                do{
                    if(!flag_refresh_relay)
                    {
                        int rx_return=serialCom->readframe_wmodule(sensor_nr);
                        switch(rx_return)
                        {
                        case 0:
                            rx_ok=false;
                            break;
                        case 1:
                            rx_ok=true;
                            break;
                        case 2:
                            update_relay_info();
                            rx_ok=false;
                            break;
                        }

                    }
                    else waitFor(10);
                   // rx_ok=serialCom->readframe_wmodule(sensor_nr);
                    QApplication::processEvents();
                }while(!rx_ok&&button_state_sa&&!flag_timeout);
                rx_ok=false;

            }
            QApplication::processEvents();
            if(rx_ok&&(dl_all_data->isChecked()||dl_data_between->isChecked()))
            {
                int start_page_tmp=(serialCom->getAllReceivedData()[25]<<8)+serialCom->getAllReceivedData()[26];
                int end_page_tmp=(serialCom->getAllReceivedData()[27]<<8)+serialCom->getAllReceivedData()[28];
                if((start_page_tmp==0xFFFF)||(end_page_tmp==0xFFFF)) rx_ok=false;
                qDebug()<<"start page : "<<start_page_tmp<<"end page : "<<end_page_tmp;
            }
        }while(!rx_ok&&button_state_sa&&!flag_timeout);
        timer3->stop();
        if(flag_timeout)  //si probleme com
        {
            refresh_relay(); //on rafraichi liste relais
            do
            {
                waitFor(1);
                QApplication::processEvents();
            }
            while(flag_refresh_relay);
        }
        if(rx_ok) recup_param(sensor_nr,true);
        else return 0;
    }
    else {
        recup_param(sensor_nr,true);
    }

    if(dl_all_data->isChecked()||dl_data_between->isChecked()) {
        if(!download_data(sensor_nr)) return 1;
        else return 2;
    }
    return 1;
}

void managewirelessdata::recup_param(uint32_t sensor_nr,bool req_send )
{
    fillingSensorTable=true;
    bool sensor_exist=false;
    bool change_ok=true;
    int max_line=(sensorTableWidget->rowCount()-1);
    int row=0;
    for(int i=0;i<max_line;i++){
        if(sensor_nr==sensorList[i].serialNb) {
            row=i;
            sensor_exist=true;
        }
    }
    if(sensor_exist){
        QString received_data2;
        received_data2.clear();
        sensorItemTable[row][2]->setText(QString::number(serialCom->getAllReceivedData()[33]));
        QDate rec_cur_date(QString::number(serialCom->getAllReceivedData()[6],16).toInt()+2000,QString::number(serialCom->getAllReceivedData()[7],16).toInt(),QString::number(serialCom->getAllReceivedData()[8],16).toInt());
        QTime rec_cur_time(QString::number(serialCom->getAllReceivedData()[9],16).toInt(),QString::number(serialCom->getAllReceivedData()[10],16).toInt(),QString::number(serialCom->getAllReceivedData()[11],16).toInt());
        QDateTime rec_cur_date_time(rec_cur_date,rec_cur_time,Qt::LocalTime);
        sensorList[row].current_time=rec_cur_date_time;
        ecart_sec[row] = rec_cur_date_time.secsTo(QDateTime::currentDateTime());//serialCom->sensor_receive_date_time);
        QDate rec_start_date(QString::number(serialCom->getAllReceivedData()[12],16).toInt()+2000,QString::number(serialCom->getAllReceivedData()[13],16).toInt(),QString::number(serialCom->getAllReceivedData()[14],16).toInt());
        QTime rec_start_time(QString::number(serialCom->getAllReceivedData()[15],16).toInt(),QString::number(serialCom->getAllReceivedData()[16],16).toInt(),QString::number(serialCom->getAllReceivedData()[17],16).toInt());
        QDateTime rec_start_date_time(rec_start_date,rec_start_time,Qt::LocalTime);
        uint8_t legacy_m=serialCom->getAllReceivedData()[43];
        sensorList[row].start_time=rec_start_date_time;

        sensorList[row].periode=serialCom->getAllReceivedData()[18];
        sensorList[row].data_rec=serialCom->getAllReceivedData()[30];
        uchar value=serialCom->getAllReceivedData()[42]&0x0F;
        uint8_t error_pointeur=serialCom->getAllReceivedData()[44];

        if(abs(ecart_sec[row])<=60)
            sensorItemTable[row][3]->setText("Offset : "+QString::number(ecart_sec[row],10)+" s");
        else sensorItemTable[row][3]->setText(rec_cur_date_time.toString("dd/MM/yyyy hh:mm:ss"));
        sensorItemTable[row][4]->setText(rec_start_date_time.toString("dd/MM/yyyy hh:mm:ss"));


        QStringList list;
        list.clear();
        //qDebug()<<sensor_nr<<" datarec : "<<sensorList[row].data_rec<<" ; type : "<<sensorList[row].sensorType;
        QString real_time_data="";
        const QLocale & cLocale = QLocale::c();

        switch(sensorList[row].sensorType){
        case 1:
            if(sensorList[row].data_rec&0x01){
                list<<"Temp1.";
                real_time_data+=QString::number(peekInt16FromUcharTabLittleEndian(serialCom->getAllReceivedData(),34)/100.,'f',1)+" C"+"; ";
            }
            if(sensorList[row].data_rec&0x02) {
                list<<"Temp2.";
                real_time_data+=QString::number(peekInt16FromUcharTabLittleEndian(serialCom->getAllReceivedData(),36)/100.,'f',1)+" C"+"; ";

            }
            if(sensorList[row].data_rec&0x04) {
                list<<"Pulses";
                QString ss = cLocale.toString(double(peekUint32FromUcharTabLittleEndian(serialCom->getAllReceivedData(),38)),'f',0);
                ss.replace(cLocale.groupSeparator(), " ");
                real_time_data+=ss+"; ";

            }
            if(sensorList[row].data_rec&0x08){
                list<<"Pulses2";
                QString ss = cLocale.toString(double(peekUint32FromUcharTabLittleEndian(serialCom->getAllReceivedData(),45)),'f',0);
                ss.replace(cLocale.groupSeparator(), " ");
                real_time_data+=ss;

            }
            break;
        case 2:
            if(sensorList[row].data_rec&0x01){
                list<<"Temp.";
                real_time_data+=QString::number(peekInt16FromUcharTabLittleEndian(serialCom->getAllReceivedData(),34)/100.,'f',1)+" C"+"; ";

            }
            if(sensorList[row].data_rec&0x02){
                list<<"Hygro.";
                real_time_data+=QString::number(peekInt16FromUcharTabLittleEndian(serialCom->getAllReceivedData(),36)/100.,'f',1)+" %"+"; ";

            }
            if(sensorList[row].data_rec&0x04) {
                list<<"Pulses";
                QString ss = cLocale.toString(double(peekUint32FromUcharTabLittleEndian(serialCom->getAllReceivedData(),38)),'f',0);
                ss.replace(cLocale.groupSeparator(), " ");
                real_time_data+=ss;
            }
            break;
        case 3:

            if(sensorList[row].data_rec&0x01)
            {
                list<<"Light";
                real_time_data+=QString::number(peekInt16FromUcharTabLittleEndian(serialCom->getAllReceivedData(),34)*100/256)+" %"+"; ";

            }
            if(sensorList[row].data_rec&0x04) {
                list<<"Switch Count";
                QString ss = cLocale.toString(double(peekUint32FromUcharTabLittleEndian(serialCom->getAllReceivedData(),38)),'f',0);
                ss.replace(cLocale.groupSeparator(), " ");
                real_time_data+=ss+"; ";
            }
            if(sensorList[row].data_rec&0x08){
                list<<"ON Time";
                uint32_t on_time=peekUint32FromUcharTabLittleEndian(serialCom->getAllReceivedData(),45);
                if(on_time>3600) real_time_data+=QString::number(on_time/3600)+" h";
                else real_time_data+=QString::number(on_time)+" s";
            }
            break;
        default:
            break;
        }
        sensor_data[row]->setText(real_time_data);
        list_datarec[row]=list;
       // qDebug()<<list;
        for(int i=0;i<8;i++)data_rec_ComboBoxList[row]->setItemCheckState(i, Qt::Unchecked);
        data_rec_ComboBoxList[row]->setCheckedItems(list);


        switch(sensorList[row].periode){
        case 0:
            periode_ComboBoxList[row]->setCurrentIndex(0);
            break;
        case 1:
            periode_ComboBoxList[row]->setCurrentIndex(1);
            break;
        case 2:
            periode_ComboBoxList[row]->setCurrentIndex(2);
            break;
        case 3:
            periode_ComboBoxList[row]->setCurrentIndex(3);
            break;
        case 4:
            periode_ComboBoxList[row]->setCurrentIndex(4);
            break;
        case 5:
            periode_ComboBoxList[row]->setCurrentIndex(5);
            break;
        case 6:
            periode_ComboBoxList[row]->setCurrentIndex(6);
            break;
        case 7:
            periode_ComboBoxList[row]->setCurrentIndex(7);
            break;
        case 8:
            periode_ComboBoxList[row]->setCurrentIndex(10);
            break;
        case 9:
            periode_ComboBoxList[row]->setCurrentIndex(12);
            break;
        case 10:
            periode_ComboBoxList[row]->setCurrentIndex(8);
            break;
        case 11:
            periode_ComboBoxList[row]->setCurrentIndex(9);
            break;
        case 12:
            periode_ComboBoxList[row]->setCurrentIndex(11);
            break;
        }

        index_periode[row]=periode_ComboBoxList[row]->currentIndex();
        if(clrdata->isChecked()&&(serialCom->getAllReceivedData()[25]==0x80)){
            sensorItemTable[row][7]->setText("0");
            sensorItemTable[row][4]->setText(QDateTime::currentDateTime().addSecs(2).toString("dd/MM/yyyy hh:mm:ss"));
        }
        else sensorItemTable[row][7]->setText(QString::number((serialCom->getAllReceivedData()[19]<<8)+serialCom->getAllReceivedData()[20],10));

        sensorItemTable[row][8]->setTextColor(Qt::blue);
        if((value>3)&&(value<7)) sensorItemTable[row][8]->setTextColor(Qt::red);
        sensorItemTable[row][8]->setText(batt_volt.at(value));
        if(serialCom->getAllReceivedData()[serialCom->getReceivedLength()-1]<128) //trame relaye
        {
            uint8_t rssi_direct= serialCom->getAllReceivedData()[serialCom->getReceivedLength()-1];
            if((sensorList[row].relay_list[0].serialNb)&&((rssi_direct<81)||(rssi_direct<sensorList[row].relay_list[0].rssi)))
            {
                if(!button_state_ad)
                {
                    remove_sensor_to_list_relay(sensor_nr,sensorList[row].relay_list[0].serialNb);
                    add_sensor_to_list(sensor_nr);
                }
                sensorList[row].relay_list[0].serialNb=0;
                sensorList[row].relay_list[0].rssi=rssi_direct;
                sensorItemTable[row][9]->setText("-"+QString::number(rssi_direct)+"dbm");
            }
            else
            {
                sensorItemTable[row][9]->setText("-"+QString::number(serialCom->rssi_sensor)+"dbm");
            }
        }
        else
        {
            if(!sensorList[row].relay_list[0].serialNb)
            {
                sensorList[row].relay_list[0].rssi=serialCom->rssi_sensor; //mise  jour du rssi

            }
            else
            {
                if((serialCom->rssi_sensor<81)||(serialCom->rssi_sensor<sensorList[row].relay_list[0].rssi))
                {
                sensorList[row].relay_list[0].serialNb=0;
                sensorList[row].relay_list[0].rssi=serialCom->rssi_sensor; //mise  jour du rssi
                }
            }
            sensorItemTable[row][9]->setText("-"+QString::number(serialCom->rssi_sensor)+"dbm");
        }

     //
        if(!legacy_m) legacy_mode[row]->setChecked(false);
                else legacy_mode[row]->setChecked(true);
        legacy_old[row]=legacy_mode[row]->isChecked();


        QString styleSheetred = "QComboBox   {  color:   red;   }";
        QString styleSheetblue = "QComboBox   {  color:   blue;   }";
        QString styleSheetgreen = "QComboBox   {  color:   green;   }";
        if(set_change[row]){
            if(req_send){
                if(start_time_change[row]) {
                    start_time_change[row]=false;
                    if(serialCom->getAllReceivedData()[25]!=0x80){
                        sensorItemTable[row][10]->setTextColor(Qt::red);
                        sensorItemTable[row][10]->setText("Error clearing data");
                        sensorItemTable[row][4]->setTextColor(Qt::red);
                        change_ok=false;
                    }
                    sensorItemTable[row][4]->setTextColor(Qt::darkGreen);
                }
                else sensorItemTable[row][4]->setTextColor(Qt::blue);

                if(current_time_change[row]) {
                    current_time_change[row]=false;
                    if(!serialCom->getAllReceivedData()[23])//ecart_sec[row]>4)
                    {
                        qDebug()<<"set_time"<<serialCom->getAllReceivedData()[23];
                        sensorItemTable[row][10]->setTextColor(Qt::red);
                        sensorItemTable[row][10]->setText("Error setting time");
                        sensorItemTable[row][3]->setTextColor(Qt::red);
                        change_ok=false;
                    }
                    else sensorItemTable[row][3]->setTextColor(Qt::darkGreen);
                }
                else sensorItemTable[row][3]->setTextColor(Qt::blue);

                if(data_rec_change[row]&&set_data_rec->isChecked()){
                    data_rec_change[row]=false;
                     qDebug()<<"datarec sent : "<<data_rec_to_send<<"   datarec received : "<<sensorList[row].data_rec;
                    if(data_rec_to_send!=sensorList[row].data_rec){
                        sensorItemTable[row][10]->setTextColor(Qt::red);
                        sensorItemTable[row][10]->setText("Error setting new channel");
                        data_rec_ComboBoxList[row]->setStyleSheet(styleSheetred);
                        change_ok=false;
                    }
                    else data_rec_ComboBoxList[row]->setStyleSheet(styleSheetgreen);
                }
                else data_rec_ComboBoxList[row]->setStyleSheet(styleSheetblue);

                if(periode_change[row]&&setperiode->isChecked()){
                    periode_change[row]=false;

                    if(new_per!=sensorList[row].periode) {
                        sensorItemTable[row][10]->setTextColor(Qt::red);
                        sensorItemTable[row][10]->setText("Error setting new periode");
                        periode_ComboBoxList[row]->setStyleSheet(styleSheetred);
                        change_ok=false;
                    }
                    else periode_ComboBoxList[row]->setStyleSheet(styleSheetgreen);
                }
                else periode_ComboBoxList[row]->setStyleSheet(styleSheetblue);

                if(legacy_changed[row]) legacy_changed[row]=false;

                if(set_change[row]){
                    set_change[row]=false;
                    sensorItemTable[row][0]->setTextColor(Qt::darkGreen);
                }
                else sensorItemTable[row][0]->setTextColor(Qt::blue);
                sensorItemTable[row][1]->setTextColor(Qt::blue);
                sensorItemTable[row][2]->setTextColor(Qt::blue);
                sensorItemTable[row][7]->setTextColor(Qt::blue);
                sensorItemTable[row][9]->setTextColor(Qt::blue);

            }
            else change_ok=false;
        }
        else
        {
            for(int i=0;i<10;i++) if((i!=5)&&(i!=6))sensorItemTable[row][i]->setTextColor(Qt::blue);
            periode_ComboBoxList[row]->setStyleSheet(styleSheetblue);
            data_rec_ComboBoxList[row]->setStyleSheet(styleSheetblue);
            periode_change[row]=false;
            data_rec_change[row]=false;
        }
        if(!dl_in_progress&&!dl_all_data->isChecked()&&!dl_data_between->isChecked()&&!error_pointeur)
        {

            if(button_state_ad) {
                sensorItemTable[row][10]->setTextColor(Qt::darkGreen);
                sensorItemTable[row][10]->setText("Sensor Detected");
            }
            else  if(change_ok) {
                sensorItemTable[row][10]->setTextColor(Qt::darkGreen);
                sensorItemTable[row][10]->setText("Action succesfull");
            }
        }
        if(error_pointeur)
        {
            sensorItemTable[row][10]->setTextColor(Qt::red);
            sensorItemTable[row][10]->setText("Error Pointer != 0");
        }
      }
    fillingSensorTable=false;
}
void managewirelessdata::recup_start_end_page(uint32_t sensor_nr){
    int row=0;
    int max_line=sensorTableWidget->rowCount()-1;
    for(int i=0;i<max_line;i++){
        if(sensor_nr==sensorList[i].serialNb) row=i;
    }
    sensorList[row].start_page=(serialCom->getAllReceivedData()[25]<<8)+serialCom->getAllReceivedData()[26];
    qDebug()<<"start page : "<<sensorList[row].start_page;


    sensorList[row].end_page=(serialCom->getAllReceivedData()[27]<<8)+serialCom->getAllReceivedData()[28];
    qDebug()<<"end : "<<sensorList[row].end_page;
    sensorList[row].data_flash_size=3968;
    //sensorList[row].data_flash_size=(serialCom->getAllReceivedData()[21]<<8)+serialCom->getAllReceivedData()[22];
}

bool managewirelessdata::add_sensor_to_list(uint32_t _sensor_nr){
    QByteArray _data_to_send;
    _data_to_send[0]=0x20;
    _data_to_send[1]=(_sensor_nr>>8)&0x00FF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitForUs(500);
    return ok;
}


bool managewirelessdata::add_sensor_to_list_relay(uint32_t _sensor_nr,uint16_t _relay_sn){
    QByteArray _data_to_send;
   // qDebug()<<"relay_sn"<<QString::number(_relay_sn,16).rightJustified(4,'0').toUpper();
    _data_to_send[0]=0x40;
    _data_to_send[1]=(_sensor_nr>>8)&0x00FF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    _data_to_send[3]=(_relay_sn>>8)&0x00FF;
    _data_to_send[4]=_relay_sn&0x00FF;
   // qDebug()<<"data_to_send"<<QString::number(_data_to_send[3],16).rightJustified(2,'0').toUpper()<<QString::number(_data_to_send[4],16).rightJustified(2,'0').toUpper();
    waitFor(2);
    return serialCom->write_serial_data(_data_to_send,0);
}

bool managewirelessdata::dl_sensor_to_pages(uint32_t _sensor_nr,uint16_t st_page,uint16_t nb_page){
    QByteArray _data_to_send;
    _data_to_send[0]=0x24;
    _data_to_send[1]=(_sensor_nr>>8)&0xFF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    _data_to_send[3]=(st_page>>8)&0xFF;
    _data_to_send[4]=st_page&0x00FF;
    _data_to_send[5]=(nb_page>>8)&0xFF;
    _data_to_send[6]=nb_page&0x00FF; 
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitForUs(500);
    return ok;
}

bool managewirelessdata::dl_sensor_to_pages_relay(uint32_t _sensor_nr,uint16_t st_page,uint16_t nb_page,uint16_t _relay_sn){
    QByteArray _data_to_send;
    _data_to_send[0]=0x44;
    _data_to_send[1]=((_sensor_nr&0xFF00)>>8);
    _data_to_send[2]=_sensor_nr&0x00FF;
    _data_to_send[3]=((_relay_sn&0xFF00)>>8);
    _data_to_send[4]=_relay_sn&0x00FF;
    _data_to_send[5]=(st_page>>8)&0xFF;
    _data_to_send[6]=st_page&0x00FF;
    _data_to_send[7]=(nb_page>>8)&0xFF;
    _data_to_send[8]=nb_page&0x00FF;
   // qDebug()<<"data_to_send"<<QString::number(_data_to_send[3],16).rightJustified(2,'0').toUpper()<<QString::number(_data_to_send[4],16).rightJustified(2,'0').toUpper();

    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitFor(1);
    return ok;

}

bool managewirelessdata::add_current_sensor(uint32_t _sensor_nr){
    QByteArray _data_to_send;
    _data_to_send[0]=0x23;
    _data_to_send[1]=(_sensor_nr>>8)&0xFF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitForUs(500);
    return ok;
}

bool managewirelessdata::add_current_sensor_relay(uint32_t _sensor_nr,uint16_t _relay_sn){
    QByteArray _data_to_send;
    _data_to_send[0]=0x43;
    _data_to_send[1]=(_sensor_nr>>8)&0x00FF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    _data_to_send[3]=(_relay_sn>>8)&0xFF;
    _data_to_send[4]=_relay_sn&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitFor(2);
    return ok;
}

bool managewirelessdata::add_sensor_to_list_det(uint32_t _sensor_nr){
    QByteArray _data_to_send;
    _data_to_send[0]=0x22;
    _data_to_send[1]=(_sensor_nr>>8)&0xFF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitForUs(500);
    return ok;
}

bool managewirelessdata::remove_sensor_to_list_det(uint32_t _sensor_nr){
    QByteArray _data_to_send;
    _data_to_send[0]=0x25;
    _data_to_send[1]=(_sensor_nr>>8)&0xFF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitForUs(500);
    return ok;
}

bool managewirelessdata::remove_sensor_to_list(uint32_t _sensor_nr){
    QByteArray _data_to_send;
    _data_to_send[0]=0x21;
    _data_to_send[1]=(_sensor_nr>>8)&0xFF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitForUs(500);
    return ok;
}

bool managewirelessdata::remove_sensor_to_list_relay(uint32_t _sensor_nr,uint16_t _relay_sn){
    QByteArray _data_to_send;
    _data_to_send[0]=0x41;
    _data_to_send[1]=(_sensor_nr>>8)&0xFF;
    _data_to_send[2]=_sensor_nr&0x00FF;
    _data_to_send[3]=(_relay_sn>>8)&0xFF;
    _data_to_send[4]=_relay_sn&0x00FF;
    bool ok=false;
    ok=serialCom->write_serial_data(_data_to_send,0);
    waitFor(2);
    return ok;
}




void managewirelessdata::closeEvent(QCloseEvent *event)
 { 
    qDebug()<<"folder ok : "<<folder_ok;
    if(folder_ok) {
        settingFile->setValue("W_DATA/DEST_FOLDER",QVariant(folder_for_save.absolutePath()));
        qDebug()<<folder_for_save.absolutePath();
    }
    settingFile->setValue("WINDOW_POS/W_DATA_WIN_X",QVariant(QString::number(this->pos().x())));
    settingFile->setValue("WINDOW_POS/W_DATA_WIN_Y",QVariant(QString::number(this->pos().y())));
    uint8_t nb_sensor = sensorTableWidget->rowCount()-1;
    exportFile->setValue("NB_SENSOR",QVariant(QString::number(nb_sensor,10)));
    for(int i=0;i<nb_sensor;i++){
        uint32_t sensor_nb=sensorList[i].serialNb;
        QString sensor_string_nb=QString::number(sensor_nb,16).rightJustified(4,'0').toUpper();
        exportFile->setValue(sensor_string_nb+"/Type_of_module",sensorItemTable[i][1]->text());
        exportFile->setValue(sensor_string_nb+"/Version",sensorItemTable[i][2]->text());
        exportFile->setValue(sensor_string_nb+"/Start_Time",sensorItemTable[i][4]->text());
        exportFile->setValue(sensor_string_nb+"/Current_Time",sensorItemTable[i][3]->text());
        exportFile->setValue(sensor_string_nb+"/Recording_channels",data_rec_ComboBoxList[i]->checkedItems());
        exportFile->setValue(sensor_string_nb+"/Periode",periode_ComboBoxList[i]->currentText());
        exportFile->setValue(sensor_string_nb+"/Nr._Pages",sensorItemTable[i][7]->text());
        exportFile->setValue(sensor_string_nb+"/Vbat",sensorItemTable[i][8]->text());
        exportFile->setValue(sensor_string_nb+"/Rssi",sensorItemTable[i][9]->text());
        exportFile->setValue(sensor_string_nb+"/Last_Status",sensorItemTable[i][10]->text());
    }

    settime->setChecked(false);
    setperiode->setChecked(false);
    set_data_rec->setChecked(false);
    clrdata->setChecked(false);
    dl_data_between->setChecked(false);
    dl_all_data->setChecked(false);
   if(button_state_sa){
       button_send_action_clicked();
   }
   if(button_state_ad){
      button_detect_sensor_clicked();
   }
   timer1->stop();
   timer3->stop();
   timer_refresh_list->stop();
   timer_dl->stop();
   waitFor(200);
   init_color();
    setVisible(false);
    emit wirelessClosed();
}

void managewirelessdata::reinit_window(){
    timer1->start(500);

    dl_start_time->setDateTime(QDateTime::currentDateTime());
    dl_start_time->setMinimumDateTime(QDateTime::currentDateTime().addYears(-10));
    dl_start_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(7200));

    dl_end_time->setDateTime(QDateTime::currentDateTime());
    dl_end_time->setMinimumDateTime(QDateTime::currentDateTime().addYears(-10));
    dl_end_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(7200));
}

uint8_t managewirelessdata::download_data(uint32_t sensor_nr){
    uint8_t result=1;
    bool sensor_relayed=false;
    int row=0;
    dl_in_progress=true;
    int max_line=sensorTableWidget->rowCount()-1;
    for(int i=0;i<max_line;i++){
        if(sensor_nr==sensorList[i].serialNb) row=i;
    }
    if(!sensorList[row].dl_ongoing) recup_start_end_page(sensor_nr);
    if(sensorList[row].relay_list[0].serialNb!=0){
        sensor_relayed=true;
    }
    uint16_t start_page=sensorList[row].start_page;
    uint16_t end_page=sensorList[row].end_page;
    QTimer *refresh_com=new QTimer;
    int rx_ok=0;
    bool end_dl=false; //fin de telechargement du capteur
    bool packet_receive=false; //fin du paquet de 10 pages
    bool batt_low=false;
    bool update_file_ok=false;

    uint16_t i;
    if(!sensorList[row].dl_ongoing){
        sensorList[row].current_dl_page=start_page;
        sensorList[row].dl_ongoing=true;
    }
    i=sensorList[row].current_dl_page;
    qDebug()<<"Start Page : "<<i;
    int percent=0 ;


    connect(refresh_com,SIGNAL(timeout()),serialCom,SLOT(refresh_serial()));

    do
    {
        uint16_t n_page;
        packet_receive=false;
        if(end_page>=i) n_page=1+end_page-i; //pas d'overflow
        else n_page=(sensorList[row].data_flash_size-i)+end_page+1; //overflow
        uint8_t nr_pages_max_in_packet=10;
        if(n_page<nr_pages_max_in_packet) nr_pages_max_in_packet=n_page;
        if((i+nr_pages_max_in_packet)>=sensorList[row].data_flash_size) nr_pages_max_in_packet=sensorList[row].data_flash_size-i;

        flag_dl_interrupt=false;
        if(sensor_relayed) dl_sensor_to_pages_relay(sensor_nr,i,nr_pages_max_in_packet,sensorList[row].relay_list[0].serialNb);
        else dl_sensor_to_pages(sensor_nr,i,nr_pages_max_in_packet); //demande au dongle nr_pages_max_in_packet pages

        qDebug()<<"req page : "<<i<<";"<<nr_pages_max_in_packet<<";"<<sensor_nr;
        serialCom->clear_buffer();
        refresh_com->start(5);
        serialCom->clear_buffer();
        int n_2pages_packet=0;
        do
        {
            flag_dl_interrupt=false;
            timer_dl->start(5000);
            flag_timeout=false;
            timer3->start(190000);
            do{
                if(!flag_refresh_relay)
                {
                    rx_ok=serialCom->receiveFramedlModuleWireless(sensor_nr);
                }
                else waitFor(10);
                if(!rx_ok) {
                    //
                    qDebug()<<"error com p. : "<<i;
                }
                QApplication::processEvents();
            }while (!rx_ok&&button_state_sa&&!flag_timeout&&!flag_dl_interrupt);
            if(flag_dl_interrupt)
            {
                dl_in_progress=false;
                refresh_com->stop();
                return 1;
            }
            if(flag_timeout||!button_state_sa||batt_low) break;
            if(rx_ok==2) { //trame_param recue
                rx_ok_when_dl=true;
                dl_in_progress=false;
                refresh_com->stop();
                return 1;
            }
            if(rx_ok==3){ //trame recue incomplte
                refresh_com->stop();
                break;
            }
            timer_dl->stop();
            flag_dl_interrupt=false;
            sensorItemTable[row][9]->setText("-"+QString::number(serialCom->rssi_sensor)+"dbm");

            qDebug()<<"i : "<<i;
            i=i+2;
            if(start_page<end_page) percent = 100 * float(1+i-start_page)/float(1+end_page-start_page);
            else
            {
                if(i>=start_page)
                    percent=(1+i-start_page)*100/((sensorList[row].data_flash_size-start_page)+end_page+1);
                else percent= 100*((sensorList[row].data_flash_size-start_page)+i+1)/((sensorList[row].data_flash_size-start_page)+end_page+1);
            }
            if(start_page==end_page) percent=100;
            if(percent>100) percent=100;
            sensorItemTable[row][10]->setTextColor(Qt::black);
            sensorItemTable[row][10]->setText(QString::number(percent,10)+" % downloaded");
            if(i>=sensorList[row].data_flash_size) i=0;
            //if(i>sensorList[row].data_flash_size)i=1;
            update_file_ok=updateFile(sensor_nr);//,nr_pages_max_in_packet);
            sensorList[row].current_dl_page=i;
             n_2pages_packet=n_2pages_packet+1;
            if((n_2pages_packet*2)>=nr_pages_max_in_packet) packet_receive=true;

            if((i==(end_page+2))||(i==(end_page+1))) {
                end_dl=true;
            }
        QApplication::processEvents();
        }while(!packet_receive&&button_state_sa&&!flag_timeout);


        refresh_com->stop();
     QApplication::processEvents();
    }while(!end_dl&&button_state_sa&&!flag_timeout);
    dl_in_progress=false;
    if(!update_file_ok) {
        sensorItemTable[row][10]->setTextColor(Qt::red);
        sensorItemTable[row][10]->setText("Error writing data in file");
    }
    if(end_dl){
        sensorList[row].dl_ongoing=false;
        sensorItemTable[row][10]->setTextColor(Qt::darkGreen);
        sensorItemTable[row][10]->setText("Download Complete");
        sensorItemTable[row][0]->setTextColor(Qt::darkGreen);
        if(sensor_relayed) dl_sensor_to_pages_relay(0,0,0,sensorList[row].relay_list[0].serialNb);
        //if(sensor_relayed)dl_sensor_to_pages_relay(0,0,0,sensorList[row].relay.serialNb);
        if(file_open[row])
        {
        file_open[row]=false;
        tsvFile[row].close();
        //delete tsvFile[row];
       // tsvFile[row]=NULL;
        result=0;
        }
        //sensorItemTable[row][10]->setText("Generating File...");
    }
    if(!button_state_sa){
        dl_sensor_to_pages(0,0,0);
        sensorItemTable[row][10]->setTextColor(Qt::red);
        sensorItemTable[row][10]->setText("Download Interrupted by user");
        if(file_open[row])
        {
        file_open[row]=false;
        tsvFile[row].close();
        //delete tsvFile[row];
       // tsvFile[row]=NULL;
        result=0;
        }
    }
    if(flag_timeout){
        sensorItemTable[row][10]->setTextColor(Qt::red);
        sensorItemTable[row][10]->setText("Connection Timeout");
        if(file_open[row])
        {
        file_open[row]=false;
        tsvFile[row].close();
        //delete tsvFile[row];
       // tsvFile[row]=NULL;
        }
        result=0;
    }

    if(batt_low){
        sensorItemTable[row][10]->setTextColor(Qt::red);
        sensorItemTable[row][10]->setText("Low battery");
        if(file_open[row])
        {
        file_open[row]=false;
        tsvFile[row].close();
        //delete tsvFile[row];
       // tsvFile[row]=NULL;
        }
        result=0;
    }
    return result;
}


void managewirelessdata::time_out(){
    flag_timeout=true;
    timer3->stop();
}
/*
void managewirelessdata::timeout2(){
    flag_timeout2=true;
    timer2->stop();
}*/

void managewirelessdata::each_sec(){
    current_pc_time->setText(QDateTime::currentDateTime().toString("dd/MM/yyyy hh:mm:ss"));
    dl_start_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(7200));
    dl_end_time->setMaximumDateTime(QDateTime::currentDateTime().addSecs(7200));
    if(button_state_sa||button_state_ad)
    {
        if(!toggle){
        if(button_state_sa) send_action->setText("Processing action, Press to interrupt");
        if(button_state_ad) detect_sensor->setText("Ongoing Detection, Press to interrupt");
        toggle=true;
        }
        else {
            if(button_state_sa) send_action->setText("");
            if(button_state_ad) detect_sensor->setText("");
            toggle=false;
        }
    }
    if(((button_state_sa&&flag_dl_interrupt&&!flag_refresh_relay)||button_state_ad)&&toggle) //envoie commande 31 ttes les secs si pas en dl;
    {
        QByteArray _data_to_send;
        current_relay=0xFFFF;
        if(current_relay) //si 0, en direct
        {
            _data_to_send[0]=0x31;
            _data_to_send[1]=(current_relay&0xFF00)>>8;
            _data_to_send[2]=current_relay&0xFF;
            serialCom->write_serial_data(_data_to_send,0); //envoie cmd 0x31
        }
    }
}

bool managewirelessdata::openFile(uint32_t sensor_nr){
    bool ok=true;
    int row=0;
    int max_line=sensorTableWidget->rowCount()-1;
    for(int i=0;i<max_line;i++){
        if(sensor_nr==sensorList[i].serialNb) row=i;
    }

//*****************
//    Open file :

    QDateTime currentDateTime= QDateTime::currentDateTime();
    QString suggestedName=QString::number(sensor_nr,16).rightJustified(4,'0').toUpper()+"_"+currentDateTime.toString("ddMMyy_hhmmss")+".tsv";
    QString pathOfFile=folder_for_save.absolutePath()+"/"+suggestedName;
    qDebug()<<"path : "<<pathOfFile;
    // init file for writing

   // tsvFile[row] = new QFile(pathOfFile);
    tsvFile[row].setFileName ( pathOfFile);
    if(!tsvFile[row].open(QFile::WriteOnly | QFile::Truncate))
    {
        ok=false;
        QMessageBox::critical(this,"File Access Error","The file "+pathOfFile+" can't be created, please verify folder settings");
        sensorItemTable[row][10]->setTextColor(Qt::red);
        sensorItemTable[row][10]->setText("Error Creating File");
        return false;

    }
    file_open[row]=true;
    tsvFile[row].flush();   //erase file
    tsvFileStream[row].setDevice(&tsvFile[row]);   //set target for stream
    return true;

}

bool managewirelessdata::updateFile(uint32_t sensor_nr)//, uint8_t n_pages)
{
    int row=0;
    int max_line=sensorTableWidget->rowCount()-1;
    for(int i=0;i<max_line;i++){
        if(sensor_nr==sensorList[i].serialNb) row=i;
    }
    if((sensorList[row].current_dl_page==1)||!sensorList[row].current_dl_page) {
        qDebug()<<serialCom->getReceivedLength();
        qDebug()<<serialCom->getReceivedDataLength();
    }
//*********************
//    Header lines

    if((sensorList[row].current_dl_page==sensorList[row].start_page)&&!file_open[row])
    //open file and Write  header :
    {
        if(!openFile(sensor_nr)){
            if(button_state_sa) button_send_action_clicked();
            return false;
        }

        QString headerLine="Sensor nr : "+QString::number(sensor_nr,16).rightJustified(4,'0').toUpper();
        headerLine+="  Version "+sensorItemTable[row][2]->text();
        headerLine+="  Type "+sensorItemTable[row][1]->text();
        uint8_t winter_time=serialCom->getAllReceivedData()[7]>>7;
        if(winter_time) headerLine+="  Winter Time";
        else headerLine+="  Summer Time";
        tsvFileStream[row]<<headerLine;
        headerLine.clear();

        headerLine="\r\nTime";
        switch(sensorList[row].sensorType){
        case 1:
            headerLine+="\tTemp\tTemp2\tPulses\tPulses2";
            break;
        case 2:
            headerLine+="\tTemp\tHygro\tPulses";
            break;
        case 3:
            headerLine+="\tLight\tSw ON\tTime ON";
            break;
        }
        headerLine+="\tBattvolt\tPulsesHi\tPulses2Hi";
        tsvFileStream[row]<<headerLine;
        headerLine.clear();
    }

//***********************
//  Write samples loop
    QString lineToWrite;
    uint8_t nb_data_per_ech_max=0;
    switch(sensorList[row].sensorType){
    case 1:
        nb_data_per_ech_max=4;
        break;
    case 2:
        nb_data_per_ech_max=3;
        break;
    case 3:
        nb_data_per_ech_max=3;
        break;

    }

    uint8_t n_max=2;//n_pages;
    if(sensorList[row].current_dl_page==sensorList[row].end_page) n_max=1;
    if(sensorList[row].current_dl_page>=(sensorList[row].data_flash_size-1)) n_max=1;

    for(uint8_t i=0; i<n_max; i++)//each page (528 octets)
        {
            //get date in beginning of page
            QDate dl_date(QString::number(serialCom->getAllReceivedData()[(i*528)+2],16).toInt()+2000,QString::number(serialCom->getAllReceivedData()[(i*528)+3],16).toInt(),QString::number(serialCom->getAllReceivedData()[(i*528)+4],16).toInt());
            //get time
            QTime dl_time(QString::number(serialCom->getAllReceivedData()[(i*528)+5],16).toInt(),QString::number(serialCom->getAllReceivedData()[(i*528)+6],16).toInt(),QString::number(serialCom->getAllReceivedData()[(i*528)+7]&0x7F,16).toInt());
            QDateTime dl_date_time(dl_date,dl_time,Qt::LocalTime);//------------
            //-----------------DEBUG : show Buffer DownloadedValues
         /*/   QString debug_line="Page : "+QString::number(i)+" ";
            for(uint16_t i_test=0;i_test<528;i_test++){
                debug_line+=" "+QString::number(serialCom->getAllReceivedData()[(i*528)+i_test],16);
            }
            qDebug()<<debug_line;*/
            uint8_t n_periode_dl=serialCom->getAllReceivedData()[(i*528)+8]&0x0f;
            uint8_t data_to_rec_page=serialCom->getAllReceivedData()[(i*528)+9];
            uint8_t n_data_per_ech=((data_to_rec_page&0x80)>>7)+((data_to_rec_page&0x40)>>6)+((data_to_rec_page&0x20)>>5)+((data_to_rec_page&0x10)>>4)
            +((data_to_rec_page&0x08)>>3)+((data_to_rec_page&0x04)>>2)+((data_to_rec_page&0x02)>>1)+(data_to_rec_page&0x01);
            uint16_t n_ech_tot=serialCom->getAllReceivedData()[(i*528)+10];
            uint16_t pulses_hi=(serialCom->getAllReceivedData()[(i*528)+11]<<8)+serialCom->getAllReceivedData()[(i*528)+12];
            uint16_t pulses2_hi=(serialCom->getAllReceivedData()[(i*528)+13]<<8)+serialCom->getAllReceivedData()[(i*528)+14];
            uint8_t battvolt=(serialCom->getAllReceivedData()[(i*528)+8])>>4;
            uint16_t pulses_old=0;
            uint16_t pulses2_old=0;
            for(int j=0;j<n_ech_tot;j++){ //each sample
                if(!(dl_data_between->isChecked()
                        &&((dl_date_time<dl_start_time->dateTime())||(dl_date_time>dl_end_time->dateTime()))))
                    {
                    lineToWrite="\r\n"+dl_date_time.toString("dd/MM/yy hh:mm:ss")+"\t"; //add date
                    //qDebug()<<i<<" : "<<lineToWrite;
                    long long value;
                    int l=0;
                    for(int k=0;k<nb_data_per_ech_max;k++){ //manage data in 1 sample
                       if(k==0){
                           switch(sensorList[row].sensorType){
                                case 1:
                                    if(data_to_rec_page&0x01){
                                        value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                        l++;
                                        if(value>32767)value=(value-65536);//pour grer les valeurs ngatives
                                        lineToWrite+=QString::number(float(value)/100,'f',1); //temperature
                                        lineToWrite+="\t";
                                    }
                                    else lineToWrite+="\t";
                                    break;
                                case 2:
                                    if(data_to_rec_page&0x01) {
                                        value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                        l++;
                                        if(value>32767)value=(value-65536);//pour grer les valeurs ngatives
                                        lineToWrite+=QString::number(float(value)/100,'f',1); //temperature
                                        lineToWrite+="\t";
                                    }
                                    else lineToWrite+="\t";
                                    break;
                                case 3:
                                   if(data_to_rec_page&0x01){
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       l++;
                                       lineToWrite+=QString::number(float(value)/255*100,'f',0)+"\t"; //light
                                   }
                                   else lineToWrite+="\t";
                                    break;
                           }
                       }
                           if(k==1) {

                               switch(sensorList[row].sensorType){
                               case 1:
                                   if(data_to_rec_page&0x02){
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       l++;
                                       if(value>32767)value=(value-65536);//pour grer les valeurs ngatives
                                       lineToWrite+=QString::number(float(value)/100,'f',1); //temperature 2
                                       lineToWrite+="\t";
                                   }
                                   else lineToWrite+="\t";
                                   break;
                               case 2:
                                   if(data_to_rec_page&0x02){
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       l++;
                                       lineToWrite+=QString::number(float(value)/100,'f',1)+"\t"; //Hygro
                                   }
                                   else lineToWrite+="\t";
                                   break;
                               case 3:
                                   if(data_to_rec_page&0x04) {
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       if(value<pulses_old) pulses_hi++;
                                       pulses_old=value;
                                       value+=(pulses_hi<<16);
                                       l++;
                                       lineToWrite+=QString::number(value,10)+"\t"; //Sw_ON
                                   }
                                   else lineToWrite+="\t";
                                   break;
                               }
                           }

                           if(k==2) {
                               switch(sensorList[row].sensorType){
                               case 1:
                                   if(data_to_rec_page&0x04) {
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       if(value<pulses_old) pulses_hi++;
                                       pulses_old=value;
                                       value+=(pulses_hi<<16);
                                       l++;
                                       lineToWrite+=QString::number(value,10)+"\t"; //pulses
                                   }
                                   else lineToWrite+="\t";
                                   break;

                               case 2:
                                   if(data_to_rec_page&0x04) {
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       if(value<pulses_old) pulses_hi++;
                                       pulses_old=value;
                                       value+=(pulses_hi<<16);
                                       l++;
                                       lineToWrite+=QString::number(value,10)+"\t"; //pulses
                                   }
                                   else lineToWrite+="\t";
                                   break;

                               case 3:
                                   if(data_to_rec_page&0x08){
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       if(value<pulses2_old) pulses2_hi++;
                                       pulses2_old=value;
                                       value+=(pulses2_hi<<16);
                                       l++;
                                       lineToWrite+=QString::number(value,10)+"\t"; //Time_ON
                                   }
                                   else lineToWrite+="\t";
                                   break;
                               }
                           }

                           if(k==3){
                               switch(sensorList[row].sensorType){
                               case 1:
                                   if(data_to_rec_page&0x08) {
                                       value=(serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2+1]<<8)+serialCom->getAllReceivedData()[(i*528)+16+j*n_data_per_ech*2+l*2];
                                       if(value<pulses2_old) pulses2_hi++;
                                       pulses2_old=value;
                                       value+=(pulses2_hi<<16);
                                       l++;
                                       lineToWrite+=QString::number(value,10)+"\t"; //pulses 2
                                   }
                                   else lineToWrite+="\t";
                                   break;
                               }
                           }
                       }
                    if(battvolt<16)
                    lineToWrite+=batt_volt2.at(battvolt)+"\t"; //debug//------------------------------------------
                    else lineToWrite+="~\t";                   //debug//------------------------------------------
                    lineToWrite+=QString::number(pulses_hi,10)+"\t"; //debug//------------------------------------------
                    lineToWrite+=QString::number(pulses2_hi,10)+"\t"; //debug//------------------------------------------
                    tsvFileStream[row]<<lineToWrite;
                }
                //lineToWrite.clear();
                switch(n_periode_dl){ //calculate the next date
                    case 0:
                        dl_date_time=dl_date_time.addSecs(1);
                        break;
                    case 1:
                        dl_date_time=dl_date_time.addSecs(2);
                        break;
                    case 2:
                        dl_date_time=dl_date_time.addSecs(5);
                        break;
                    case 3:
                        dl_date_time=dl_date_time.addSecs(10);
                        break;
                    case 4:
                        dl_date_time=dl_date_time.addSecs(15);
                        break;
                    case 5:
                        dl_date_time=dl_date_time.addSecs(20);
                        break;
                    case 6:
                        dl_date_time=dl_date_time.addSecs(30);
                        break;
                    case 7:
                        dl_date_time=dl_date_time.addSecs(60);
                        break;
                    case 8:
                        dl_date_time=dl_date_time.addSecs(600);
                        break;
                    case 9:
                        dl_date_time=dl_date_time.addSecs(3600);
                        break;
                    case 10:
                        dl_date_time=dl_date_time.addSecs(120);
                        break;
                    case 11:
                        dl_date_time=dl_date_time.addSecs(300);
                        break;
                    case 12:
                        dl_date_time=dl_date_time.addSecs(900);
                        break;
                }
            }
            QApplication::processEvents();
        }
    return true;
}

void managewirelessdata::valueChanged(int row, int column)
{
    //A cell text changed (serial Nb or name)
    if((column<12) && !fillingSensorTable) //To avoid signal from GUI
    {
        switch(column)
        {
        case 0:
            setSerialNb(row);
            break;
        default:
            //qDebug()<<"Value changed in unauthorized cell !";
            break;
        }
    }
}

void managewirelessdata::copy_sensor(Sensor_l dest,Sensor_l source){
    dest.serialNb=source.serialNb;
    dest.current_time=source.current_time;
    dest.data_rec=source.data_rec;
    dest.periode=source.periode;
    dest.start_time=source.start_time;
    dest.version=source.version;
}

void managewirelessdata::setSerialNb(int _row){
    //To change serial number
    bool ok=true;
    fillingSensorTable=true;
    int max_line;
    max_line=sensorTableWidget->rowCount()-1;
    uint32_t newSerialNb=sensorItemTable[_row][0]->text().toInt(&ok,16);
    sensorItemTable[_row][0]->text().toInt(&ok,10);
    if(!ok||(newSerialNb<=0)){ QMessageBox::critical(this,"Error SN","Serial Number must be a strictly positive integer");
      if(_row<max_line)
          sensorItemTable[_row][0]->setText(QString::number(sensorList[_row].serialNb,16).rightJustified(4,'0').toUpper());
       else sensorItemTable[_row][0]->setText("");
       fillingSensorTable=false;
       return;
    }
    bool sensor_exist=false;
    for(int i=0;i<max_line;i++) if(sensorList[i].serialNb==newSerialNb)sensor_exist=true;
    if(sensor_exist){
        if(_row<max_line)
        sensorItemTable[_row][0]->setText(QString::number(sensorList[_row].serialNb,16).rightJustified(4,'0').toUpper());
        else sensorItemTable[_row][0]->setText("");
        fillingSensorTable=false;
        return;
    }

    uint8_t n_line_to_insert;
    if(_row<max_line) {
        delete_row(_row);
    }
    max_line=sensorTableWidget->rowCount()-1;
      int i=0;
        while((newSerialNb>sensorList[i].serialNb)&&(i<max_line)){
          //  qDebug()<<"sn : "<<i<<" "<<sensorList[i].serialNb;
            i++;
        }
        n_line_to_insert=i;
       // qDebug()<<"n_line : "<<n_line_to_insert;
        for(int i=max_line-1;i>=n_line_to_insert;i--){
            //copy_sensor(sensorList[i+1],sensorList[i]);
            sensorList[i+1]=sensorList[i];
            /*sensorList[i+1].serialNb=sensorList[i].serialNb;
            sensorList[i+1].current_time= sensorList[i].current_time;
            sensorList[i+1].data_rec= sensorList[i].data_rec;
            sensorList[i+1].periode= sensorList[i].periode;
            sensorList[i+1].sensorType= sensorList[i].sensorType;
            sensorList[i+1].start_time= sensorList[i].start_time;
            sensorList[i+1].version= sensorList[i].version;
            sensorList[i+1].start_page= sensorList[i].start_page;
            sensorList[i+1].end_page= sensorList[i].end_page;
            sensorList[i+1].data_flash_size=sensorList[i].data_flash_size;
            sensorList[i+1].relay_list_size= sensorList[i].relay_list_size;
            for(int j=0;j<sensorList[i+1].relay_list_size;j++){
                sensorList[i+1].relay_list[j].serialNb= sensorList[i].relay_list[j].serialNb;
                sensorList[i+1].relay_list[j].rssi= sensorList[i].relay_list[j].rssi;
            }
            sensorList[i+1].i_relay=sensorList[i].i_relay;*/
            periode_ComboBoxList [i+1]->addItems(listPeriode);
            periode_ComboBoxList [i+1]->setCurrentIndex(periode_ComboBoxList [i]->currentIndex());
            periode_ComboBoxList [i+1]->setStyleSheet(periode_ComboBoxList [i]->styleSheet());
            index_periode[i+1]=index_periode[i];
            legacy_mode[i+1]->setChecked(legacy_mode[i]->isChecked());
            legacy_mode[i+1]->setEnabled(legacy_mode[i]->isEnabled());
            sensorItemTable[i+1][0]->setText(sensorItemTable[i][0]->text());
            sensorItemTable[i+1][2]->setText(sensorItemTable[i][2]->text());
            sensorItemTable[i+1][3]->setText(sensorItemTable[i][3]->text());
            sensorItemTable[i+1][4]->setText(sensorItemTable[i][4]->text());
            sensor_data[i+1]->setText(sensor_data[i]->text());
            updateTypeComboBoxList(i+1,0);
            for(int j=0; j<8;j++) data_rec_ComboBoxList[i+1]->setItemCheckState(j,Qt::Unchecked);
            data_rec_ComboBoxList[i+1]->setCheckedItems(data_rec_ComboBoxList[i]->checkedItems());
            data_rec_ComboBoxList[i+1]->setStyleSheet( data_rec_ComboBoxList[i]->styleSheet());
            list_datarec[i+1]=list_datarec[i];

            sensorItemTable[i+1][7]->setText(sensorItemTable[i][7]->text());
            sensorItemTable[i+1][8]->setText(sensorItemTable[i][8]->text());
            sensorItemTable[i+1][9]->setText(sensorItemTable[i][9]->text());
            sensorItemTable[i+1][10]->setText(sensorItemTable[i][10]->text());
            sensorItemTable[i+1][0]->setTextColor(sensorItemTable[i][0]->textColor());
            sensorItemTable[i+1][1]->setTextColor(sensorItemTable[i][1]->textColor());
            sensorItemTable[i+1][2]->setTextColor(sensorItemTable[i][2]->textColor());
            sensorItemTable[i+1][3]->setTextColor(sensorItemTable[i][3]->textColor());
            sensorItemTable[i+1][4]->setTextColor(sensorItemTable[i][4]->textColor());
            sensorItemTable[i+1][7]->setTextColor(sensorItemTable[i][7]->textColor());
            sensorItemTable[i+1][8]->setTextColor(sensorItemTable[i][8]->textColor());
            sensorItemTable[i+1][9]->setTextColor(sensorItemTable[i][9]->textColor());
            sensorItemTable[i+1][10]->setTextColor(sensorItemTable[i][10]->textColor());

        }


    sensorList[n_line_to_insert].relay_list_size= 1;
    sensorList[n_line_to_insert].serialNb=newSerialNb;
    sensorList[n_line_to_insert].relay_list[0].serialNb=0;
    sensorList[n_line_to_insert].relay_list[0].rssi=0xff;
    sensorList[n_line_to_insert].i_relay=0;
    sensorItemTable[n_line_to_insert][0]->setText(QString::number(newSerialNb,16).rightJustified(4,'0').toUpper());
    //Update combobox list from serialNb
     if(newSerialNb!=0)
     {
         updateTypeComboBoxList(n_line_to_insert,1);
         //channelComboBoxList[_row]->showPopup();//Unfold the comboBox (next cell)

     }
     QString styleSheet = "QComboBox   {  color:   black;   }";
     QString styleSheetred = "QComboBox   {  color:   red;   }";
     periode_ComboBoxList[n_line_to_insert]->clear();
     periode_ComboBoxList[n_line_to_insert]->addItems(listPeriode);
     periode_ComboBoxList[n_line_to_insert]->setCurrentIndex(7);//default 1min
     periode_ComboBoxList[n_line_to_insert]->setStyleSheet(styleSheetred);

     index_periode[n_line_to_insert]=periode_ComboBoxList[n_line_to_insert]->currentIndex();
     periode_change[n_line_to_insert]=true;
     list_datarec[n_line_to_insert]=data_rec_ComboBoxList[i]->checkedItems();
     data_rec_change[n_line_to_insert]=true;
     data_rec_ComboBoxList[n_line_to_insert]->setStyleSheet(styleSheetred);


     legacy_mode[n_line_to_insert]->setChecked(true);
     legacy_mode[n_line_to_insert]->setEnabled(true);
     legacy_old[n_line_to_insert]=true;
     legacy_changed[n_line_to_insert]=false;
     sensor_data[n_line_to_insert]->setText("");
     sensorItemTable[n_line_to_insert][2]->setText("");
     sensorItemTable[n_line_to_insert][3]->setText("");
     sensorItemTable[n_line_to_insert][4]->setText("");
     sensorItemTable[n_line_to_insert][7]->setText("");
     sensorItemTable[n_line_to_insert][8]->setText("");
     sensorItemTable[n_line_to_insert][9]->setText("");
     sensorItemTable[n_line_to_insert][10]->setText("");
     for(int i=0;i<11;i++) if((i!=5)&&(i!=6))sensorItemTable[n_line_to_insert][i]->setTextColor(Qt::black);
     add_empty_row();
     fillingSensorTable=false;

}

void managewirelessdata::delete_row(int row){
    fillingSensorTable=true;
    if(row<sensorTableWidget->rowCount()){
        int max_line;
        max_line=sensorTableWidget->rowCount()-1;
        for(int i=row;i<max_line;i++){
             sensorList[i]=sensorList[i+1];
            //copy_sensor(sensorList[i],sensorList[i+1]);
         /*   sensorList[i].serialNb=sensorList[i+1].serialNb;
            sensorList[i].current_time= sensorList[i+1].current_time;
            sensorList[i].data_rec= sensorList[i+1].data_rec;
            sensorList[i].periode= sensorList[i+1].periode;
            sensorList[i].sensorType= sensorList[i+1].sensorType;
            sensorList[i].start_time= sensorList[i+1].start_time;
            sensorList[i].version= sensorList[i+1].version;
            sensorList[i].start_page= sensorList[i+1].start_page;
            sensorList[i].end_page= sensorList[i+1].end_page;
            sensorList[i].data_flash_size=sensorList[i+1].data_flash_size;
            sensorList[i].i_relay=sensorList[i+1].i_relay;
            sensorList[i].relay_list_size= sensorList[i+1].relay_list_size;
            for(int j=0;j<sensorList[i+1].relay_list_size;j++){
                sensorList[i].relay_list[j].serialNb= sensorList[i+1].relay_list[j].serialNb;
                sensorList[i].relay_list[j].rssi= sensorList[i+1].relay_list[j].rssi;
            }*/
            periode_ComboBoxList [i]->addItems(listPeriode);
            periode_ComboBoxList [i]->setCurrentIndex(periode_ComboBoxList [i+1]->currentIndex());
            periode_ComboBoxList[i]->setStyleSheet(periode_ComboBoxList[i+1]->styleSheet());
            updateTypeComboBoxList(i,0);
            index_periode[i]=index_periode[i+1];
            legacy_mode[i]->setChecked(legacy_mode[i+1]->isChecked());
            legacy_mode[i]->setEnabled(legacy_mode[i+1]->isEnabled());

            sensor_data[i]->setText(sensor_data[i+1]->text());


            for(int j=0; j<8;j++) data_rec_ComboBoxList[i]->setItemCheckState(j,Qt::Unchecked);
            data_rec_ComboBoxList[i]->setCheckedItems(data_rec_ComboBoxList[i+1]->checkedItems());
            data_rec_ComboBoxList[i]->setStyleSheet( data_rec_ComboBoxList[i+1]->styleSheet());
            list_datarec[i]=list_datarec[i+1];

            sensorItemTable[i][0]->setText(sensorItemTable[i+1][0]->text());
            sensorItemTable[i][0]->setTextColor(sensorItemTable[i+1][0]->textColor());
            sensorItemTable[i][1]->setTextColor(sensorItemTable[i+1][1]->textColor());
            sensorItemTable[i][2]->setText(sensorItemTable[i+1][2]->text());
            sensorItemTable[i][2]->setTextColor(sensorItemTable[i+1][2]->textColor());
            sensorItemTable[i][3]->setText(sensorItemTable[i+1][3]->text());
            sensorItemTable[i][3]->setTextColor(sensorItemTable[i+1][3]->textColor());
            sensorItemTable[i][4]->setText(sensorItemTable[i+1][4]->text());
            sensorItemTable[i][4]->setTextColor(sensorItemTable[i+1][4]->textColor());
            sensorItemTable[i][7]->setText(sensorItemTable[i+1][7]->text());
            sensorItemTable[i][7]->setTextColor(sensorItemTable[i+1][7]->textColor());
            sensorItemTable[i][8]->setText(sensorItemTable[i+1][8]->text());
            sensorItemTable[i][8]->setTextColor(sensorItemTable[i+1][8]->textColor());
            sensorItemTable[i][9]->setText(sensorItemTable[i+1][9]->text());
            sensorItemTable[i][9]->setTextColor(sensorItemTable[i+1][9]->textColor());
            sensorItemTable[i][10]->setText(sensorItemTable[i+1][10]->text());
            sensorItemTable[i][10]->setTextColor(sensorItemTable[i+1][10]->textColor());

        }
     //   qDebug()<<"sensor removed : "<<sensorList[row].serialNb;
       sensorTableWidget->removeRow(max_line);

       sensorItemTable[max_line-1][1]->setText("");
       for(int i=0;i<11;i++)sensorItemTable[max_line-1][i]->setFlags(sensorItemTable[max_line-1][i]->flags()&~Qt::ItemIsSelectable);
    }

   // fillingSensorTable=false;
}

void managewirelessdata::updateTypeComboBoxList(int _row,bool def)
{   //Refresh elements of the comboBox (type of channel), according to sensor SN

    data_rec_ComboBoxList[_row]->clear(); //clear current elements
    if(sensorList[_row].serialNb!=0)
    {
        if((sensorList[_row].serialNb&0xFFFF)<0x0400
                    || ((sensorList[_row].serialNb&0xFFFF)>0x1299 && (sensorList[_row].serialNb&0xFFFF)<0x3000))
        {//Sensor Type TempHygroPulse
            data_rec_ComboBoxList[_row]->addItems(listTempHygroPulse);
            sensorItemTable[_row][1]->setText("Temp Hygro");
            sensorList[_row].sensorType=2;
            if(def)data_rec_ComboBoxList[_row]->setCheckedItems(QStringList() << "Temp." << "Hygro.");
        }
        else if(((sensorList[_row].serialNb&0xFFFF)>0x0399 && (sensorList[_row].serialNb&0xFFFF)<0x0600)
                    || ((sensorList[_row].serialNb&0xFFFF)>0x2999 && (sensorList[_row].serialNb&0xFFFF)<0x6000))
        {//Sensor Type TempPulse
            data_rec_ComboBoxList[_row]->addItems(listTempPulse);
            sensorItemTable[_row][1]->setText("Temp Pulses");
            sensorList[_row].sensorType=1;
            if(def) data_rec_ComboBoxList[_row]->setCheckedItems(QStringList() << "Temp1." << "Temp2.");
        }
        else if((sensorList[_row].serialNb&0xFFFF)>0x0599 && (sensorList[_row].serialNb&0xFFFF)<0x1300)
        {//Sensor Type Lamp
            data_rec_ComboBoxList[_row]->addItems(listLamp);
            sensorItemTable[_row][1]->setText("Lamp");
            sensorList[_row].sensorType=3;
            if(def) data_rec_ComboBoxList[_row]->setCheckedItems(QStringList() << "Light" << "Switch Count" << "ON Time");
        }

        else if((sensorList[_row].serialNb&0xFFFF)>0x8200 && (sensorList[_row].serialNb&0xFFFF)<0x9999)
        {//Sensor Type Wattmeter
            data_rec_ComboBoxList[_row]->addItems(listWattmeter);
            sensorItemTable[_row][1]->setText("Wattmeter");
            sensorList[_row].sensorType=4;
            if(def) data_rec_ComboBoxList[_row]->setCheckedItems(QStringList() <<"U"<<"I"<<"Act. Pow."<<"App. Pow."
                                                                 <<"Act. E."<<"App. E.");

        }

        else qDebug()<<"error switching SN for channel List";
        list_datarec[_row]=data_rec_ComboBoxList[_row]->checkedItems();
    }
}

void managewirelessdata::displayContextMenu(const QPoint &pos){
    int top_left_table_x=sensorTableWidget->verticalHeader()->viewport()->mapToGlobal(QPoint(0,0)).x();
    int top_left_table_y=sensorTableWidget->horizontalHeader()->viewport()->mapToGlobal(QPoint(0,0)).y();

    int table_width=sensorTableWidget->verticalHeader()->width();
    for(int i=0;i< sensorTableWidget->columnCount();i++) table_width+=sensorTableWidget->columnWidth(i);
    int bottom_right_table_x=1+top_left_table_x+table_width;

    int table_height=sensorTableWidget->horizontalHeader()->height();
    for(int i=0;i< (sensorTableWidget->rowCount()-1);i++) table_height+=sensorTableWidget->rowHeight(i);
    int bottom_right_table_y=1+top_left_table_y+table_height;

    if((mapToGlobal(pos).x()>=top_left_table_x)&&(mapToGlobal(pos).y()>=top_left_table_y)
            &&(mapToGlobal(pos).x()<bottom_right_table_x)&&(mapToGlobal(pos).y()<bottom_right_table_y)&&!button_state_sa&&!button_state_ad)
    {
        bool ok=true;
        QMenu menu(this);
        QAction *u1 = menu.addAction("Remove selected line(s)"); // there can be more than one
        QAction *u2 = menu.addAction("Advanced configuration of this sensor");
        QAction *a = menu.exec(mapToGlobal(pos));
        QModelIndexList list;
        QItemSelectionModel *selectionModel = sensorTableWidget->selectionModel();
        list=selectionModel->selectedRows();
        int n_select=list.count();
        int32_t sensor_to_del [256];
        int row_to_delete=0;
        if (a == u1)
        {
            QString lined="Selected Rows : ";
            for(int i=0; i<n_select;i++){
                sensor_to_del[i]=sensorItemTable[list.at(i).row()][0]->text().toLong(&ok,16);
                lined+=QString::number(sensor_to_del[i],16).rightJustified(4,'0').toUpper()+" ";
               //     delete_row(list.at(i).row());
            }
             for(int i=0; i<n_select;i++){
                 int max_row=sensorTableWidget->rowCount()-1;
                 for(int j=0;j<max_row;j++) if(sensor_to_del[i]==sensorItemTable[j][0]->text().toLong(&ok,16)) row_to_delete=j;
                 if(row_to_delete<max_row) delete_row(row_to_delete);
             }
            sensorTableWidget->clearSelection();
            fillingSensorTable=false;
            qDebug()<<lined;
        }

      if (a == u2)
        {
            QPoint relative_pos;
            relative_pos.setX(mapToGlobal(pos).x()-top_left_table_x);
            relative_pos.setY(mapToGlobal(pos).y()-(top_left_table_y+sensorTableWidget->horizontalHeader()->height()));
            QModelIndex index = sensorTableWidget->indexAt(relative_pos);
            bool okWindow = false;
            QString password = QInputDialog::getText(this,"Password","Restricted functions.<br>Please enter password.",
                                        QLineEdit::Normal, QString(), &okWindow);
            if (okWindow && password==ADVMODE_PASSWORD)   //advanced mode OK
            {

                if(AdvanceWindow==NULL) AdvanceWindow = new AdvanceWirellessSensor(serialCom,sensorList[index.row()]);
               connect(AdvanceWindow,SIGNAL(AdvanceClosed()),this,SLOT(adv_config_closed()));
                AdvanceWindow->show();
            }
        }
    }
}


void managewirelessdata::button_send_action_clicked(){
    if(!button_state_sa){
        if(sensorTableWidget->rowCount()>1) //si presence de capteur dans la liste
        {
        detect_sensor->setEnabled(false);
        sensorTableWidget->setEnabled(false);
        action_box->setEnabled(false);
        timer1->stop();
        timer1->start(500);
        button_state_sa=1;
        send_action->setText("Processing action, Press to interrupt");
        send_action->setStyleSheet("font-weight: bold;color: red");
        sensorTableWidget->clearSelection();
        req_sendaction();
        }
        else QMessageBox::warning(this,"Empty List","The sensor list is empty, please add sensor manually or launch sensor auto-detection");
    }
    else
    {
        timer_refresh_list->stop();
        timer_dl->stop();
        timer3->stop();
        add_sensor_to_list(0x0000);

        for(int p=0;p<nb_relay;p++)
            add_sensor_to_list_relay(0x0000,list_relay[p].serialNb);
        for(int i=0;i<(sensorTableWidget->rowCount()-1);i++)
        {
            if(file_open[i])
            {
            file_open[i]=false;
            tsvFile[i].close();
            //delete tsvFile[row];
           // tsvFile[row]=NULL;
            }
            if(sensorList[i].dl_ongoing) sensorList[i].dl_ongoing=false;
        }
        action_box->setEnabled(true);
        detect_sensor->setEnabled(true);
        sensorTableWidget->setEnabled(true);
        send_action->setText("Send Action");
        send_action->setStyleSheet("color: black");
        button_state_sa=0;
        emit button_sa_clicked();
        restore_color();
    }
}

void managewirelessdata::button_detect_sensor_clicked(){
    if(!button_state_ad){
        timer_refresh_list->stop();
        send_action->setEnabled(false);
        sensorTableWidget->setEnabled(false);
        timer1->stop();
        timer1->start(500);
        button_state_ad=1;
        detect_sensor->setText("Ongoing Detection, Press to interrupt");
        detect_sensor->setStyleSheet("font-weight: bold;color: red");
        sensorTableWidget->clearSelection();
        req_detect_sensor();
    }
    else {
        add_sensor_to_list(0x0000);
        for(int p=0;p<nb_relay;p++)
            add_sensor_to_list_relay(0x0000,list_relay[p].serialNb);
        timer_refresh_list->stop();
        timer3->stop();
        flag_timeout=false;
        send_action->setEnabled(true);
        sensorTableWidget->setEnabled(true);
        button_state_ad=0;
        detect_sensor->setText("Auto-detect and add sensors to list");
        detect_sensor->setStyleSheet("color: black");
        restore_color();
    }

}

void managewirelessdata::button_import_clicked(){
    QString import_list_file = QFileDialog::getOpenFileName(this,"Choose Filename",folder_for_save.absolutePath()+"/list.ini", "Ini file (*.ini)");
    QSettings *import_file=new QSettings( import_list_file,QSettings::IniFormat);

    if(import_file->contains("LIST_SENSOR")) {
        QStringList list_sensor=import_file->value("LIST_SENSOR").toString().split(";", QString::SkipEmptyParts);
        for(int i=0;i<list_sensor.count();i++){
            uint8_t max_line= sensorTableWidget->rowCount()-1;
            sensorItemTable[max_line][0]->setText(list_sensor.at(i));
        }
        int max_line=sensorTableWidget->rowCount()-1;
        for(int i=0;i<max_line;i++){
            index_periode[i]=import_file->value(sensorItemTable[i][0]->text()+"/Periode_index").toInt();
            periode_ComboBoxList[i]->setCurrentIndex(index_periode[i]);
            switch(index_periode[i]){
            case 0:
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
            case 7:
                sensorList[i].periode=index_periode[i];
                break;
            case 8:
                sensorList[i].periode=10;
            case 9:
                sensorList[i].periode=11;
            case 10:
                sensorList[i].periode=8;
            case 11:
                sensorList[i].periode=12;
            case 12:
                sensorList[i].periode=9;
            }
            list_datarec[i]=import_file->value(sensorItemTable[i][0]->text()+"/Recording_channels").toStringList();
            data_rec_ComboBoxList[i]->setCheckedItems(list_datarec[i]);
            sensorList[i].data_rec=import_file->value(sensorItemTable[i][0]->text()+"/Recording_channels_index").toInt();
            periode_change[i]=true;
            data_rec_change[i]=true;
        }
    }
}

void managewirelessdata::button_export_clicked(){
   QString export_list_file = QFileDialog::getSaveFileName(this,"Choose Filename",folder_for_save.absolutePath()+"/list.ini", "Ini file (*.ini)");
   QSettings *export_file=new QSettings( export_list_file,QSettings::IniFormat);
   uint8_t nb_sensor = sensorTableWidget->rowCount()-1;
   export_file->clear();
   export_file->setValue("NB_SENSOR",QVariant(QString::number(nb_sensor,10)));
   QString line_list_sensor="";
   for(int i=0;i<nb_sensor;i++){
       uint32_t sensor_nb=sensorList[i].serialNb;
       QString sensor_string_nb=QString::number(sensor_nb,16).rightJustified(4,'0').toUpper();
       line_list_sensor+=sensor_string_nb+";";
       export_file->setValue(sensor_string_nb+"/Type_of_module",sensorItemTable[i][1]->text());
       export_file->setValue(sensor_string_nb+"/Version",sensorItemTable[i][2]->text());
       export_file->setValue(sensor_string_nb+"/Start_Time",sensorItemTable[i][4]->text());
       export_file->setValue(sensor_string_nb+"/Current_Time",sensorItemTable[i][3]->text());
       export_file->setValue(sensor_string_nb+"/Recording_channels",data_rec_ComboBoxList[i]->checkedItems());
//       export_file->setValue(sensor_string_nb+"/Recording_channels_index",sensorList[i].data_rec);
       export_file->setValue(sensor_string_nb+"/Periode",periode_ComboBoxList[i]->currentText());
//       export_file->setValue(sensor_string_nb+"/Periode_index",periode_ComboBoxList[i]->currentIndex());
       export_file->setValue(sensor_string_nb+"/Nr._Pages",sensorItemTable[i][7]->text());
       export_file->setValue(sensor_string_nb+"/Vbat",sensorItemTable[i][8]->text());
       export_file->setValue(sensor_string_nb+"/Rssi",sensorItemTable[i][9]->text());
       export_file->setValue(sensor_string_nb+"/Last_Status",sensorItemTable[i][10]->text());
   }
   export_file->setValue("LIST_SENSOR",line_list_sensor);

}

void managewirelessdata::periode_changed(){
    if(!fillingSensorTable)
    {
        int max_line=sensorTableWidget->rowCount()-1;
        for(int i=0; i<max_line;i++){
            if(periode_ComboBoxList[i]->currentIndex()!=index_periode[i]) {
                //index_periode[i]=periode_ComboBoxList[i]->currentIndex();
                QString styleSheet = "QComboBox   {  color:   red;   }";
                periode_change[i]=true;
                periode_ComboBoxList[i]->setStyleSheet(styleSheet);
            }
            else {
                if((sensorItemTable[i][2]->text().toInt()>0)&&(sensorItemTable[i][2]->text().toInt()<500)){
                QString styleSheet = "QComboBox   {  color:   black;   }";
                periode_change[i]=false;
                periode_ComboBoxList[i]->setStyleSheet(styleSheet);
                }
            }
        }
    }
}

void managewirelessdata::datarec_changed(){
    if(!fillingSensorTable)
    {
        int max_line=sensorTableWidget->rowCount()-1;
        for(int i=0; i<max_line;i++){
            if(data_rec_ComboBoxList[i]->checkedItems()!=list_datarec[i]){
                QString styleSheet = "QComboBox   {  color:   red;   }";
                data_rec_ComboBoxList[i]->setStyleSheet(styleSheet);
                data_rec_change[i]=true;
            }
            else
            {
                if((sensorItemTable[i][2]->text().toInt()>0)&&(sensorItemTable[i][2]->text().toInt()<500)){
                QString styleSheet = "QComboBox   {  color:   black;   }";
                data_rec_change[i]=false;
                data_rec_ComboBoxList[i]->setStyleSheet(styleSheet);
                }
            }
        }
    }
}

void managewirelessdata::legacy_mode_changed(){
    if(!fillingSensorTable)
    {
        int max_line=sensorTableWidget->rowCount()-1;
        for(int i=0; i<max_line;i++){
            if((legacy_mode[i]->isChecked()!=legacy_old[i])&&!legacy_mode[i]->isChecked()){
                QString styleSheet = "QComboBox   {  color:   red;   }";
                legacy_changed[i]=true;
                legacy_mode[i]->setStyleSheet(styleSheet);
            }
            else
            {
                QString styleSheet = "QComboBox   {  color:   black;   }";
                legacy_changed[i]=false;
                legacy_mode[i]->setStyleSheet(styleSheet);
            }
        }
    }
}

void managewirelessdata::get_data_to_send(uint16_t serial_nr){
    uint8_t data_rec_tmp=0;
    int row=0;
    int max_line=sensorTableWidget->rowCount()-1;
    for(int i=0;i<max_line;i++){
        if(serial_nr==sensorList[i].serialNb) row=i;
    }
    if(set_data_rec->isChecked())
    {
   switch(sensorList[row].sensorType){
         case 1:
             if(data_rec_ComboBoxList[row]->itemCheckState(0)==Qt::Checked) data_rec_tmp+=0x01;
             if(data_rec_ComboBoxList[row]->itemCheckState(1)==Qt::Checked) data_rec_tmp+=0x02;
             if(data_rec_ComboBoxList[row]->itemCheckState(2)==Qt::Checked) data_rec_tmp+=0x04;
             if(data_rec_ComboBoxList[row]->itemCheckState(3)==Qt::Checked) data_rec_tmp+=0x08;
             break;
         case 2:
        if(data_rec_ComboBoxList[row]->itemCheckState(0)==Qt::Checked) data_rec_tmp+=0x01;
        if(data_rec_ComboBoxList[row]->itemCheckState(1)==Qt::Checked) data_rec_tmp+=0x02;
        if(data_rec_ComboBoxList[row]->itemCheckState(2)==Qt::Checked) data_rec_tmp+=0x04;
             break;
         case 3:

        if(data_rec_ComboBoxList[row]->itemCheckState(0)==Qt::Checked) data_rec_tmp+=0x01;
        if(data_rec_ComboBoxList[row]->itemCheckState(1)==Qt::Checked) data_rec_tmp+=0x04;
        if(data_rec_ComboBoxList[row]->itemCheckState(2)==Qt::Checked) data_rec_tmp+=0x08;
             break;
         default:
             break;
     }
    data_rec_to_send=data_rec_tmp;
    }
    if(setperiode->isChecked())
    {
        switch(periode_ComboBoxList[row]->currentIndex()){
        case 8:
            new_per=10;
            break;
        case 9:
            new_per=11;
            break;
        case 10:
            new_per=8;
            break;
        case 11:
            new_per=12;
            break;
        case 12:
            new_per=9;
            break;
        default:
            new_per=periode_ComboBoxList[row]->currentIndex();
        }
    }
}

void managewirelessdata::init_color(){
    int max_line=sensorTableWidget->rowCount()-1;
    for(int i=0;i<max_line;i++){
        for(int j=0;j<11;j++){
           if((j!=5)&&(j!=6)&&(j!=8)) sensorItemTable[i][j]->setTextColor(Qt::black);
        }
        if (sensorItemTable[i][8]->textColor()!=Qt::red) sensorItemTable[i][8]->setTextColor(Qt::black);
        QString styleSheet = "QComboBox   {  color:   black;   }";
        periode_ComboBoxList[i]->setStyleSheet(styleSheet);
        data_rec_ComboBoxList[i]->setStyleSheet(styleSheet);
    }
}

void managewirelessdata::restore_color(){
    int max_line=sensorTableWidget->rowCount()-1;
    QString styleSheet = "QComboBox   {  color:   red;   }";
    for(int i=0;i<max_line;i++){
        if(periode_change[i]) periode_ComboBoxList[i]->setStyleSheet(styleSheet);
        if(data_rec_change[i]) data_rec_ComboBoxList[i]->setStyleSheet(styleSheet);
        legacy_mode[i]->setEnabled(true);
    }
}

void managewirelessdata::button_select_folder_clicked(){
    folder_for_save.setPath(QFileDialog::getExistingDirectory(this,"Choose Destination folder",folder_for_save.absolutePath(),QFileDialog::ShowDirsOnly));
    saving_folder->setText(folder_for_save.absolutePath());

}

void managewirelessdata::folder_changed(QString folder){
    QDir temp_fold;
    temp_fold.setPath(folder);
    //if(temp_fold.exists()) {
        folder_for_save=temp_fold;
    /*}
    else
    {
        qDebug()<<"Can't find folder";
    }*/

}

void managewirelessdata::keyPressEvent(QKeyEvent *event)
{
   if (event->key() == Qt::Key_Delete) {
       bool ok=true;
       QModelIndexList list;
       QItemSelectionModel *selectionModel = sensorTableWidget->selectionModel();
       list=selectionModel->selectedRows();
       int n_select=list.count();
       int32_t sensor_to_del [256];
       int row_to_delete=0;
       if (!button_state_sa&&!button_state_ad)
       {
           QString lined="Selected Rows : ";
           for(int i=0; i<n_select;i++){
               sensor_to_del[i]=sensorItemTable[list.at(i).row()][0]->text().toLong(&ok,16);
               lined+=QString::number(sensor_to_del[i],16).rightJustified(4,'0').toUpper()+" ";
              //     delete_row(list.at(i).row());
           }
            for(int i=0; i<n_select;i++){
                int max_row=sensorTableWidget->rowCount()-1;
                for(int j=0;j<max_row;j++) if(sensor_to_del[i]==sensorItemTable[j][0]->text().toLong(&ok,16)) row_to_delete=j;
                if(row_to_delete<max_row) delete_row(row_to_delete);
            }
           sensorTableWidget->clearSelection();
           fillingSensorTable=false;
           qDebug()<<lined;
       }
       qDebug()<<"suppr";
   }
}

bool managewirelessdata::winEvent(MSG* message, long* result)
{
    UINT msg = message->message;
    //WPARAM wp = message->wParam;
    //LPARAM lp = message->lParam;
    HWND hwnd=message->hwnd;

    switch ( msg )
    {
    case WM_ENTERSIZEMOVE :
        qDebug() << "M_ENTERSIZEMOVE";
        SetTimer(hwnd,             // handle to main window
            a,            // timer identifier
            100,                 // 100-msecond interval
            (TIMERPROC) NULL);     // no timer callback
        QApplication::processEvents();
        return true;
        break;

    case WM_EXITSIZEMOVE :
        qDebug() << "M_EXITSIZEMOVE";
        KillTimer(hwnd, a);
       // emit tagDetected( (char*)lp );
        return true;
        break;
    default:
        break;
    }

    return false;
}

void managewirelessdata::time_out_dl()
{
    flag_dl_interrupt=true;
    current_relay=0xFFFF;
    timer_dl->stop();
}

void managewirelessdata::timeout4(){
    flag_timeout4=true;
}

void managewirelessdata::refresh_relay()
{
    timer_refresh_list->stop();
    if(!dl_in_progress)
    {
        flag_refresh_relay=true;
        QByteArray _data_to_send;
        _data_to_send[0]=0x30;
        serialCom->write_serial_data(_data_to_send,0); //envoie cmd 0x30
        waitForUs(200);
        flag_refresh_relay=false;
    }
    timer_refresh_list->start(64000);
}
 void managewirelessdata::update_relay_info()
 {
     uint16_t max_line;
     uint32_t sensor_received=0;
     bool end_list=false;
     uint16_t serial_relay_received=serialCom->rx_source_address;
     bool relay_exist=false;
     int p=0;
     for(p=0;p<nb_relay;p++) if(serial_relay_received==list_relay[p].serialNb)
     {
         relay_exist=true;
         list_relay[p].rssi=serialCom->rssi_sensor;
         break;
     }

     end_list=false;
     if(!relay_exist)
     {
         list_relay[nb_relay].serialNb=serial_relay_received;
         list_relay[nb_relay].rssi=serialCom->rssi_sensor;
         nb_relay++;
     }
     QString info_relais="";
     for(p=0;p<nb_relay;p++)
     {
     info_relais+="Relay "+QString::number(p+1)+" , SN : "+QString::number(list_relay[p].serialNb,16).rightJustified(4,'0').toUpper()+
             ", RSSI : -"+QString::number(list_relay[p].rssi)+" dbm\t";
     }
     relay_status->setText(info_relais);
     int i=0;
     do{
         max_line=(sensorTableWidget->rowCount()-1);

         sensor_received = (serialCom->getAllReceivedData()[(i*4)+1]<<8)+serialCom->getAllReceivedData()[(i*4)+2];
         if(sensor_received!=0x0000)
         {
             qDebug()<<"relay : "<<QString::number(serial_relay_received,16).rightJustified(4,'0').toUpper()
                        <<"sensor : "<<QString::number(sensor_received,16).rightJustified(4,'0').toUpper();
             uint8_t rssi_received=serialCom->getAllReceivedData()[(i*4)+3];
             int i_row=0;
             bool sensor_exist=false;
             for(i_row=0;i_row<max_line;i_row++)
             {
                 if(sensor_received==sensorList[i_row].serialNb)
                 {
                     sensor_exist=true;
                     break;
                 }
             }
             if(sensor_exist)
             {


                 if(!(!sensorList[i_row].relay_list[0].serialNb&&(sensorList[i_row].relay_list[0].rssi<81))
                         &&(rssi_received<sensorList[i_row].relay_list[0].rssi))
                 {
                     sensorItemTable[i_row][9]->setText("-"+QString::number(rssi_received)+"dbm");
                     if(!sensorList[i_row].relay_list[0].serialNb) remove_sensor_to_list(sensor_received);
                     else remove_sensor_to_list_relay(sensor_received,sensorList[i_row].relay_list[0].serialNb);
                     add_sensor_to_list_relay(sensor_received,serial_relay_received);
                     sensorList[i_row].relay_list[0].serialNb=serial_relay_received;
                     sensorList[i_row].relay_list[0].rssi=rssi_received;
                 }
             }
         }
         else end_list=true;
         i++;
         if(i>63) end_list=true;
         QApplication::processEvents();
     }while(!end_list);
 }

void managewirelessdata::adv_config_closed(){
    delete AdvanceWindow;
    AdvanceWindow=NULL;
}
