#ifndef MYFTP_H
#define MYFTP_H
#include <QtNetwork>
#include <iostream>
using namespace std;
class myFtp:public QFtp
{
  Q_OBJECT
public:
    QStringList listfile;
  myFtp():QFtp()
  {

    m_MStateMap.insert(pair<int,QString>(0,"Unconnected"));
    m_MStateMap.insert(pair<int,QString>(1,"Host Lookup"));
    m_MStateMap.insert(pair<int,QString>(2,"Connecting"));
    m_MStateMap.insert(pair<int,QString>(3,"Connected"));
    m_MStateMap.insert(pair<int,QString>(4,"Login"));
    m_MStateMap.insert(pair<int,QString>(5,"Closing"));

    connect(this,SIGNAL(stateChanged(int)),this,SLOT(connectionStateChanged(int)));
    connect(this,SIGNAL(listInfo(QUrlInfo)),this,SLOT(listInfo2(QUrlInfo)));
    connect(this,SIGNAL(readyRead()),this,SLOT(readData()));
    connect(this,SIGNAL(commandFinished(int,bool)),this,SLOT(commandFinished(int,bool)));
    connect(this,SIGNAL(dataTransferProgress(qint64,qint64))
                        ,this,SLOT(viewProgress(qint64,qint64)));
  };
  ~myFtp()
  {};

signals:
  void command_done(bool _state);

private slots:
  void connectionStateChanged(int state)
  {
    qDebug()<<"Connection State Changed->"
             << state<<" Status: "
             <<m_MStateMap.find(state)->second
             <<endl;
  };

  void viewProgress(qint64 done ,qint64 total)
  {
    qDebug()<<"Transferred Data: "<<done
        <<endl<<"Remaining: "<<total<<endl;
  };

  void listInfo2(QUrlInfo info)
  {
      listfile<<info.name();
    qDebug()<<"Listing URL Info:"<<info.name()<<endl;
  };

  void commandFinished(int id,bool error)
  {

    qDebug()<<"Command Finished! Id:"<<id<<"-Status:"<<error<<endl;
    emit command_done(error);
  };

  void readData()
  {
    qDebug()<<"Read File Content-->"<<endl
        <<QString(readAll())
        <<endl
        <<"Read File END "<<endl;
  };

private:
  map<int,QString> m_MStateMap;
};
#endif // MYFTP_H
