#ifndef WIRELESSMODULE_H
#define WIRELESSMODULE_H

#include "manageserialport.h"
#include "refreshtimer.h"
class WirelessModule : public QWidget
{
    Q_OBJECT
public:
    explicit WirelessModule(ManageSerialPort *_serialPort, RefreshTimer *_commonRefreshTimer, Module *_wireless_Module, QWidget *parent = 0);
    ~WirelessModule();

signals:
    void backToMainWindow();
 //   void timeout_cfg();

public slots:
   /* void mousePressEvent(QMouseEvent *)
    {
        emit timeout_cfg();
    }*/
    void backToManageModule();
    void startTimerAgain();
    void valueChanged(int row, int column);
    void comboBoxChanged(int _row);
    void sensorNbButtonClicked();
    void timerSlot();



private:
    ManageSerialPort *serialCom;
    RefreshTimer *commonRefreshTimer;
    Module *wireless_Module;
    bool firstRefresh;
    bool fillingSensorTable;
    vector< Sensor> sensorList;
    vector< QComboBox*> channelComboBoxList;
    QSignalMapper *comboBoxSignalMapper;
    vector< vector< QTableWidgetItem * > > sensorItemTable;

    QStringList batt_volt;//=(QStringList()<<"~"<<"2.9V"<<"3.0V"<<"3.4V"<<"2.2V"<<"2.3V"<<"2.4V"<<"2.5V"<<"2.6V"<<"2.7V"<<"2.8V"<<"3.1V"<<"3.2V"<<"3.3V"<<"3.5V"<<"3.7V");


    QStringList listTempHygroPulse;
    QStringList listTempPulse;
    QStringList listLamp;
    QStringList listWattmeter;
    QStringList listCo2;
    QStringList listDelayAna;
    QStringList listPressure;
    QStringList listPresence ;
    QStringList listLux;

    void setTableWidget();
    bool fillSensorTable();
    void setSerialNb(int row);
    void setSensorName(int row);

    void updateComboBoxList(int _row);
    void updateComboBoxSelection(int _row);
    void updateStructureFromChannelType(int _sensorIndex);

    //update table :
    void updateSensorTableEntryFromList(int _sensorIndex);
    bool updateVisibleSensorsValues();



    //graphics elements :
    void fillWindow();
    QVBoxLayout *globalLayout;
    QGroupBox *groupBoxWireless;
    QVBoxLayout *verticalLayout;
        QTableWidget *sensorTableWidget;
            QTableWidgetItem *sensorSNTableItem;
            QTableWidgetItem *sensorChannelTableItem;
            QTableWidgetItem *sensorNameTableItem;
            QTableWidgetItem *sensorValueTableItem;
            QTableWidgetItem *sensorDelayTableItem;
            QTableWidgetItem *sensorSignalFromTableItem;
            QTableWidgetItem *sensorSignalToTableItem;
            QTableWidgetItem *sensorBatteryTableItem;
        QHBoxLayout *buttonLayout;
            QPushButton *returnButton;
            QPushButton *sensorNbButton;

    //debug :
    void displaySensorList();

};

#endif // WIRELESSMODULE_H
